/*

  Copyright (C) 2000, 2001 Silicon Graphics, Inc.  All Rights Reserved.

  This program is free software; you can redistribute it and/or modify it
  under the terms of version 2 of the GNU General Public License as
  published by the Free Software Foundation.

  This program is distributed in the hope that it would be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

  Further, this software is distributed without any warranty that it is
  free of the rightful claim of any third person regarding infringement 
  or the like.  Any license provided herein, whether implied or 
  otherwise, applies only to this software file.  Patent licenses, if 
  any, provided herein do not apply to combinations of this program with 
  other software, or any other product whatsoever.  

  You should have received a copy of the GNU General Public License along
  with this program; if not, write the Free Software Foundation, Inc., 59
  Temple Place - Suite 330, Boston MA 02111-1307, USA.

  Contact information:  Silicon Graphics, Inc., 1600 Amphitheatre Pky,
  Mountain View, CA 94043, or:

  http://www.sgi.com

  For further information regarding this notice, see:

  http://oss.sgi.com/projects/GenInfo/NoticeExplan

*/

/* This file was automatically generated by f90generate.pl */

ENTER_F90_INTR(INTRN_F4EXPONENT,RETURN_I4,"F4EXPONENT","_EXPONENT_4")
ENTER_F90_INTR(INTRN_F8EXPONENT,RETURN_I4,"F8EXPONENT","_EXPONENT")
ENTER_F90_INTR(INTRN_FQEXPONENT,RETURN_I4,"FQEXPONENT","_EXPONENT_16")
ENTER_F90_INTR(INTRN_F4FRACTION,RETURN_F4,"F4FRACTION","_FRACTION_4")
ENTER_F90_INTR(INTRN_F8FRACTION,RETURN_F8,"F8FRACTION","_FRACTION")
ENTER_F90_INTR(INTRN_FQFRACTION,RETURN_FQ,"FQFRACTION","_FRACTION_16")
ENTER_F90_INTR(INTRN_F4MODULO,RETURN_F4,"F4MODULO","_modulo4")
ENTER_F90_INTR(INTRN_F8MODULO,RETURN_F8,"F8MODULO","_modulo8")
ENTER_F90_INTR(INTRN_FQMODULO,RETURN_FQ,"FQMODULO","_moduloq")
ENTER_F90_INTR(INTRN_F4NEAREST,RETURN_F4,"F4NEAREST","_NEAREST_4")
ENTER_F90_INTR(INTRN_F8NEAREST,RETURN_F8,"F8NEAREST","_NEAREST")
ENTER_F90_INTR(INTRN_FQNEAREST,RETURN_FQ,"FQNEAREST","_NEAREST_16")
ENTER_F90_INTR(INTRN_F4RRSPACING,RETURN_F4,"F4RRSPACING","_RRSPACING_4")
ENTER_F90_INTR(INTRN_F8RRSPACING,RETURN_F8,"F8RRSPACING","_RRSPACING")
ENTER_F90_INTR(INTRN_FQRRSPACING,RETURN_FQ,"FQRRSPACING","_RRSPACING_16")
ENTER_F90_INTR(INTRN_F4SCALE,RETURN_F4,"F4SCALE","_SCALE_4")
ENTER_F90_INTR(INTRN_F8SCALE,RETURN_F8,"F8SCALE","_SCALE")
ENTER_F90_INTR(INTRN_FQSCALE,RETURN_FQ,"FQSCALE","_SCALE_16")
ENTER_F90_INTR(INTRN_F4SET_EXPONENT,RETURN_F4,"F4SET_EXPONENT","_SET_EXPONENT_4")
ENTER_F90_INTR(INTRN_F8SET_EXPONENT,RETURN_F8,"F8SET_EXPONENT","_SET_EXPONENT")
ENTER_F90_INTR(INTRN_FQSET_EXPONENT,RETURN_FQ,"FQSET_EXPONENT","_SET_EXPONENT_16")
ENTER_F90_INTR(INTRN_F4SPACING,RETURN_F4,"F4SPACING","_SPACING_4")
ENTER_F90_INTR(INTRN_F8SPACING,RETURN_F8,"F8SPACING","_SPACING")
ENTER_F90_INTR(INTRN_FQSPACING,RETURN_FQ,"FQSPACING","_SPACING_16")
ENTER_F90_INTR(INTRN_F4NEXTAFTER,RETURN_F4,"F4NEXTAFTER","_IEEE_NEXT_AFTER_H")
#ifdef KEY /* Bug 11103 */
/* The GNU libm -m32 version of "nextafter" fails to set exceptions. If that
 * bug is fixed, we could resume calling "nextafter" directly, and for that
 * matter, we could call "nextafterf" for F4NEXTAFTER. */
ENTER_F90_INTR(INTRN_F8NEXTAFTER,RETURN_F8,"F8NEXTAFTER","_IEEE_NEXT_AFTER")
#else /* KEY Bug 11103 */
ENTER_F90_INTR(INTRN_F8NEXTAFTER,RETURN_F8,"F8NEXTAFTER","nextafter")
#endif /* KEY Bug 11103 */
ENTER_F90_INTR(INTRN_FQNEXTAFTER,RETURN_FQ,"FQNEXTAFTER","qnextafter")
ENTER_F90_INTR(INTRN_F4ISNAN,RETURN_F4,"F4ISNAN","isnanf")
ENTER_F90_INTR(INTRN_F8ISNAN,RETURN_F8,"F8ISNAN","isnan")
ENTER_F90_INTR(INTRN_FQISNAN,RETURN_FQ,"FQISNAN","isnanq")
ENTER_F90_INTR(INTRN_F4SCALB,RETURN_F4,"F4SCALB","ldexp")
ENTER_F90_INTR(INTRN_F8SCALB,RETURN_F8,"F8SCALB","ldexp")
ENTER_F90_INTR(INTRN_FQSCALB,RETURN_FQ,"FQSCALB","qldexp")
#ifdef KEY /* Bug 10261 */
/* GNU libm drem and remainder have a bug: they don't ignore the rounding
 * mode as required by C99 (and F90 ieee_rem.) Using "remainder" instead of
 * "drem" causes pathcc (and pathf90) to link the version provided by
 * libmpath, which works correctly. */
ENTER_F90_INTR(INTRN_F4IEEE_REMAINDER,RETURN_F4,"F4IEEE_REMAINDER","remainder")
ENTER_F90_INTR(INTRN_F8IEEE_REMAINDER,RETURN_F8,"F8IEEE_REMAINDER","remainder")
#else /* KEY Bug 10261 */
ENTER_F90_INTR(INTRN_F4IEEE_REMAINDER,RETURN_F4,"F4IEEE_REMAINDER","drem")
ENTER_F90_INTR(INTRN_F8IEEE_REMAINDER,RETURN_F8,"F8IEEE_REMAINDER","drem")
#endif /* KEY Bug 10261 */
ENTER_F90_INTR(INTRN_FQIEEE_REMAINDER,RETURN_FQ,"FQIEEE_REMAINDER","_IEEE_REMAINDER_Q")
ENTER_F90_INTR(INTRN_F4LOGB,RETURN_F4,"F4LOGB","logb")
ENTER_F90_INTR(INTRN_F8LOGB,RETURN_F8,"F8LOGB","logb")
ENTER_F90_INTR(INTRN_FQLOGB,RETURN_FQ,"FQLOGB","__qlogb")
ENTER_F90_INTR(INTRN_F4ILOGB,RETURN_I4,"F4ILOGB","__ilogbf")
ENTER_F90_INTR(INTRN_F8ILOGB,RETURN_I4,"F8ILOGB","__ilogb")
ENTER_F90_INTR(INTRN_FQILOGB,RETURN_I4,"FQILOGB","__iqlogb")
ENTER_F90_INTR(INTRN_F4FPCLASS,RETURN_I4,"F4FPCLASS","_fp_class_f")
ENTER_F90_INTR(INTRN_F8FPCLASS,RETURN_I4,"F8FPCLASS","_fp_class_d")
ENTER_F90_INTR(INTRN_FQFPCLASS,RETURN_I4,"FQFPCLASS","_fp_class_q")
ENTER_F90_INTR(INTRN_F4FINITE,RETURN_I4,"F4FINITE","finite")
ENTER_F90_INTR(INTRN_F8FINITE,RETURN_I4,"F8FINITE","finite")
ENTER_F90_INTR(INTRN_FQFINITE,RETURN_I4,"FQFINITE","__qfinite")
ENTER_F90_INTR(INTRN_F4UNORDERED,RETURN_I4,"F4UNORDERED","unordered")
ENTER_F90_INTR(INTRN_F8UNORDERED,RETURN_I4,"F8UNORDERED","unordered")
ENTER_F90_INTR(INTRN_FQUNORDERED,RETURN_I4,"FQUNORDERED","unorderedl")
ENTER_F90_INTR(INTRN_I1POPCNT,RETURN_I4,"I1POPCNT","__popcnt1")
ENTER_F90_INTR(INTRN_I2POPCNT,RETURN_I4,"I2POPCNT","__popcnt2")
ENTER_F90_INTR(INTRN_I4POPCNT,RETURN_I4,"I4POPCNT","__popcnt4")
ENTER_F90_INTR(INTRN_I8POPCNT,RETURN_I4,"I8POPCNT","__popcnt8")
ENTER_F90_INTR(INTRN_I1LEADZ,RETURN_I4,"I1LEADZ","__leadz1")
ENTER_F90_INTR(INTRN_I2LEADZ,RETURN_I4,"I2LEADZ","__leadz2")
ENTER_F90_INTR(INTRN_I4LEADZ,RETURN_I4,"I4LEADZ","__leadz4")
ENTER_F90_INTR(INTRN_I8LEADZ,RETURN_I4,"I8LEADZ","__leadz8")
ENTER_F90_LIBFUNC(INTRN_LENTRIM,RETURN_I4,"LENTRIM","i_lentrim")
ENTER_F90_LIBFUNC(INTRN_F90INDEX,RETURN_I4,"F90INDEX","_index90")
ENTER_F90_LIBFUNC(INTRN_SCAN,RETURN_I4,"SCAN","_scan90")
ENTER_F90_LIBFUNC(INTRN_VERIFY,RETURN_I4,"VERIFY","_verify90")
ENTER_F90_LIBROUTINE(INTRN_ADJUSTL,RETURN_V,"ADJUSTL","_F90_ADJUSTL")
ENTER_F90_LIBROUTINE(INTRN_ADJUSTR,RETURN_V,"ADJUSTR","_F90_ADJUSTR")
ENTER_F90_LIBROUTINE(INTRN_GET_IEEE_EXCEPTIONS,RETURN_I4,"GET_IEEE_EXCEPTIONS","__get_ieee_exceptions")
ENTER_F90_LIBROUTINE(INTRN_GET_IEEE_INTERRUPTS,RETURN_I4,"GET_IEEE_INTERRUPTS","__get_ieee_interrupts")
ENTER_F90_LIBROUTINE(INTRN_GET_IEEE_ROUNDING_MODE,RETURN_I4,"GET_IEEE_ROUNDING_MODE","fpgetround")
ENTER_F90_LIBROUTINE(INTRN_GET_IEEE_STATUS,RETURN_I4,"GET_IEEE_STATUS","__get_ieee_status")
ENTER_F90_LIBROUTINE(INTRN_SET_IEEE_EXCEPTIONS,RETURN_V,"SET_IEEE_EXCEPTIONS","__set_ieee_exceptions")
ENTER_F90_LIBROUTINE(INTRN_SET_IEEE_EXCEPTION,RETURN_V,"SET_IEEE_EXCEPTION","__set_ieee_exception")
ENTER_F90_LIBROUTINE(INTRN_SET_IEEE_INTERRUPTS,RETURN_V,"SET_IEEE_INTERRUPTS","__set_ieee_interrupts")
ENTER_F90_LIBROUTINE(INTRN_SET_IEEE_ROUNDING_MODE,RETURN_V,"SET_IEEE_ROUNDING_MODE","fpsetround")
ENTER_F90_LIBROUTINE(INTRN_SET_IEEE_STATUS,RETURN_V,"SET_IEEE_STATUS","__set_ieee_status")
ENTER_F90_LIBROUTINE(INTRN_ENABLE_IEEE_INTERRUPT,RETURN_V,"ENABLE_IEEE_INTERRUPT","__enable_ieee_interrupt")
ENTER_F90_LIBROUTINE(INTRN_DISABLE_IEEE_INTERRUPT,RETURN_V,"DISABLE_IEEE_INTERRUPT","__disable_ieee_interrupt")
ENTER_F90_LIBROUTINE(INTRN_TEST_IEEE_EXCEPTION,RETURN_I4,"TEST_IEEE_EXCEPTION","__test_ieee_exception")
ENTER_F90_LIBROUTINE(INTRN_TEST_IEEE_INTERRUPT,RETURN_I4,"TEST_IEEE_INTERRUPT","__test_ieee_interrupt")
ENTER_F90_INTR(INTRN_I1IEEE_INT,RETURN_I1,"I1IEEE_INT","_IEEE_INT_D_I1")
ENTER_F90_INTR(INTRN_I2IEEE_INT,RETURN_I2,"I2IEEE_INT","_IEEE_INT_D_I2")
ENTER_F90_INTR(INTRN_I4IEEE_INT,RETURN_I4,"I4IEEE_INT","_IEEE_INT_D_I4")
ENTER_F90_INTR(INTRN_I8IEEE_INT,RETURN_I8,"I8IEEE_INT","_IEEE_INT_D_I8")
ENTER_F90_INTR(INTRN_F4IEEE_INT,RETURN_F4,"F4IEEE_INT","_IEEE_INT_D_H")
ENTER_F90_INTR(INTRN_F8IEEE_INT,RETURN_F8,"F8IEEE_INT","_IEEE_INT_D_R")
ENTER_F90_INTR(INTRN_FQIEEE_INT,RETURN_FQ,"FQIEEE_INT","_IEEE_INT_D_D")
ENTER_F90_LIBROUTINE(INTRN_F90BOUNDS_CHECK,RETURN_V,"F90BOUNDS_CHECK","__f90_bounds_check")
ENTER_F90_LIBROUTINE(INTRN_F90CONFORM_CHECK,RETURN_V,"F90CONFORM_CHECK","__f90_conform_check")
