/********************************************************************\
|*                                                                  *|   
|*  Copyright (c) 2006 by SimpLight Nanoelectronics.                *|
|*  All rights reserved                                             *|
|*                                                                  *|
|*  This program is free software; you can redistribute it and/or   *|
|*  modify it under the terms of the GNU General Public License as  *|
|*  published by the Free Software Foundation; either version 2,    *|
|*  or (at your option) any later version.                          *|
|*                                                                  *|
\********************************************************************/

//
// Group TOPS with similar packing format together. 
/////////////////////////////////////////////////////////
// The instructions are listed by category. The different categories of
// instructions are:
//
//   1. ALU
//   2. Integer
//   3. Memory
//   4. Branch
//   5. Float
//
// Within each Pack_Type instructions are listed in the order as shown
// in the IA-64 instructions formats manual
/////////////////////////////////////

#include <stddef.h>
#include "topcode.h"
#include "isa_pack_gen.h"
 
main()
{
  ISA_Pack_Begin("MIPS", 32);

  ISA_PACK_TYPE p1 = ISA_Pack_Type_Create("p1");
  Result(0, 12, 4);
  Operand(0, 0, 16, 4);
  Operand(1, 0, 20, 4);
  Instruction_Pack_Group(p1,
			 TOP_lb, 0x000000ff,
			 TOP_lbu, 0x000000ff,
			 TOP_lh, 0x000000ff,
			 TOP_lhu, 0x000000ff,
			 TOP_lw, 0x000000ff,
			 TOP_lwl, 0x000000ff,
			 TOP_lwr, 0x000000ff,
			 TOP_sb, 0x000000ff,
			 TOP_sh, 0x000000ff,
			 TOP_sw, 0x000000ff,
			 TOP_swl, 0x000000ff,
			 TOP_swr, 0x000000ff,
			 TOP_ll, 0x000000ff,
			 TOP_sc, 0x000000ff,
			 TOP_sync, 0x000000ff,
			 TOP_lwu, 0x000000ff,
			 TOP_ld, 0x000000ff,
			 TOP_ldl, 0x000000ff,
			 TOP_ldr, 0x000000ff,
			 TOP_lld, 0x000000ff,
			 TOP_sd, 0x000000ff,
			 TOP_sdl, 0x000000ff,
			 TOP_sdr, 0x000000ff,
			 TOP_scd, 0x000000ff,
			 TOP_pref, 0x000000ff,
			 TOP_prefx, 0x000000ff,
			 TOP_add, 0x000000ff,
			 TOP_addi, 0x000000ff,
			 TOP_addiu, 0x000000ff,
			 TOP_addu, 0x000000ff,
			 TOP_div, 0x000000ff,
			 TOP_divu, 0x000000ff,
			 TOP_mult, 0x000000ff,
			 TOP_multu, 0x000000ff,
			 TOP_slt, 0x000000ff,
			 TOP_slti, 0x000000ff,
			 TOP_sltiu, 0x000000ff,
			 TOP_sltu, 0x000000ff,
			 TOP_sub, 0x000000ff,
			 TOP_subu, 0x000000ff,
			 TOP_dadd, 0x000000ff,
			 TOP_daddi, 0x000000ff,
			 TOP_daddiu, 0x000000ff,
			 TOP_daddu, 0x000000ff,
			 TOP_ddiv, 0x000000ff,
			 TOP_ddivu, 0x000000ff,
			 TOP_dmult, 0x000000ff,
			 TOP_dmultu, 0x000000ff,
			 TOP_dsub, 0x000000ff,
			 TOP_dsubu, 0x000000ff,
			 TOP_and, 0x000000ff,
			 TOP_andi, 0x000000ff,
			 TOP_lui, 0x000000ff,
			 TOP_nor, 0x000000ff,
			 TOP_or, 0x000000ff,
			 TOP_ori, 0x000000ff,
			 TOP_xor, 0x000000ff,
			 TOP_xori, 0x000000ff,
			 TOP_mfhi, 0x000000ff,
			 TOP_mflo, 0x000000ff,
			 TOP_mthi, 0x000000ff,
			 TOP_mtlo, 0x000000ff,
#if defined(TARG_SL)	
			 TOP_smult,     0x000000ff,
			 TOP_loop,      0x000000ff,
			 TOP_mc_z_eq,   0x000000ff,
			 TOP_mc_z_ne,   0x000000ff,
			 TOP_mc_z_gt,   0x000000ff,
			 TOP_mc_z_ge,   0x000000ff,
			 TOP_mc_z_lt,   0x000000ff,
			 TOP_mc_z_le,   0x000000ff,
			 TOP_mc_zn_eq,  0x000000ff,
			 TOP_mc_zn_ne,  0x000000ff,
			 TOP_mc_zn_gt,  0x000000ff,
			 TOP_mc_zn_ge,  0x000000ff,
			 TOP_mc_zn_lt,  0x000000ff,
			 TOP_mc_zn_le,  0x000000ff,
			 TOP_mc_r_eq,   0x000000ff,
			 TOP_mc_r_ne,   0x000000ff,
			 TOP_mc_r_gt,   0x000000ff,
			 TOP_mc_r_ge,   0x000000ff,
			 TOP_mc_r_lt,   0x000000ff,
			 TOP_mc_r_le,   0x000000ff,
			 TOP_mc_abs,    0x000000ff,	
			 TOP_mc_zc_eq,  0x000000ff,	
			 TOP_mc_zc_ne,  0x000000ff,	
			 TOP_mc_zc_gt,  0x000000ff,	
			 TOP_mc_zc_ge,  0x000000ff,	
			 TOP_mc_zc_lt,  0x000000ff,	
			 TOP_mc_zc_le,  0x000000ff,	 
			 TOP_depb,	0x000000ff,	
			 TOP_extrbs,	0x000000ff,	
			 TOP_extrbu,	0x000000ff,				
                         TOP_ret,       0x000000ff,
                         TOP_mvtc,      0x000000ff,
                         TOP_mvtc_i,   0x000000ff,
                         TOP_mvfc,      0x000000ff,
                         TOP_abs16,     0x000000ff,
                         TOP_add16,     0x000000ff,
                         TOP_add16_i,   0x000000ff,
                         TOP_add16_sp,  0x000000ff,
                         TOP_and16,     0x000000ff,
                         TOP_and16_i,   0x000000ff,
                         TOP_jr16,      0x000000ff,
                         TOP_jr16_lnk,  0x000000ff,
                         TOP_ldw16,     0x000000ff,
                         TOP_ldub16_rs, 0x000000ff,
                         TOP_lduh16_rs, 0x000000ff,
                         TOP_mv16,      0x000000ff,
                         TOP_mv16_i,    0x000000ff,
                         TOP_mvfc16,    0x000000ff,
                         TOP_mvtc16,    0x000000ff,
                         TOP_nop16,     0x000000ff,
                         TOP_inv16,    0x000000ff,
                         TOP_or16,      0x000000ff,
                         TOP_or16_i,    0x000000ff,
                         TOP_pop16,     0x000000ff,
                         TOP_push16,    0x000000ff,
                         TOP_ret16,     0x000000ff,
                         TOP_shll16,    0x000000ff,
                         TOP_shll16_i,  0x000000ff,
                         TOP_shra16,    0x000000ff,
                         TOP_shra16_i,  0x000000ff,
                         TOP_shrl16,    0x000000ff,
                         TOP_shrl16_i,  0x000000ff,
                         TOP_stw16,     0x000000ff,
                         TOP_sub16,     0x000000ff,
                         TOP_sub16_i,   0x000000ff,
                         TOP_xor16,     0x000000ff,
                         TOP_xor16_i,   0x000000ff,
                         TOP_br16_eqz,0x000000ff,
                         TOP_br16_nez,0x000000ff,
        		 TOP_c3_aadda, 0x000000ff,
			 TOP_c3_bitr, 0x000000ff,
                         TOP_c3_cs, 0x000000ff,
                         TOP_c3_dadd, 0x000000ff,
                         TOP_c3_dmac, 0x000000ff,
                         TOP_c3_dmacn, 0x000000ff,
                         TOP_c3_dmac_a, 0x000000ff,
                         TOP_c3_dmacn_a, 0x000000ff,
                         TOP_c3_dmula, 0x000000ff,
                         TOP_c3_dmulan, 0x000000ff,
                         TOP_c3_dmula_a, 0x000000ff,
                         TOP_c3_dmulan_a, 0x000000ff,
                         TOP_c3_dshll_i, 0x000000ff,
                         TOP_c3_dshrl_i, 0x000000ff,
                         TOP_c3_dsub, 0x000000ff,
                         TOP_c3_ffe, 0x000000ff,
                         TOP_c3_fftld, 0x000000ff,
                         TOP_c3_fftst, 0x000000ff,
                         TOP_c3_ld, 0x000000ff,
                         TOP_c3_lead, 0x000000ff,
                         TOP_c3_mac, 0x000000ff,
                         TOP_c3_mac_a, 0x000000ff,
                         TOP_c3_mac_ar, 0x000000ff,
                         TOP_c3_mac_i, 0x000000ff,
                         TOP_c3_macn, 0x000000ff,
                         TOP_c3_macn_a, 0x000000ff,
                         TOP_c3_macn_ar, 0x000000ff,
                         TOP_c3_macn_i, 0x000000ff,
                         TOP_c3_mula, 0x000000ff,
                         TOP_c3_mula_a, 0x000000ff,
                         TOP_c3_mula_ar, 0x000000ff,
                         TOP_c3_mula_i, 0x000000ff,
                         TOP_c3_mulan, 0x000000ff,
                         TOP_c3_muls, 0x000000ff,
                         TOP_c3_mulus, 0x000000ff,
                         TOP_c3_mvfs, 0x000000ff,
                         TOP_c3_mvts, 0x000000ff,
                         TOP_c3_revb, 0x000000ff,
                         TOP_c3_round, 0x000000ff,
                         TOP_c3_saadd_a, 0x000000ff,
                         TOP_c3_saaddh_a, 0x000000ff,
                         TOP_c3_saadds, 0x000000ff,
                         TOP_c3_saaddsh, 0x000000ff,
                         TOP_c3_sadda, 0x000000ff,
                         TOP_c3_sadda_a, 0x000000ff,
                         TOP_c3_samulh_a, 0x000000ff,
                         TOP_c3_samulsh, 0x000000ff,
                         TOP_c3_sasub_a, 0x000000ff,
                         TOP_c3_sasubh_a, 0x000000ff,
                         TOP_c3_sasubs, 0x000000ff,
                         TOP_c3_sasubsh, 0x000000ff,
                         TOP_c3_shav, 0x000000ff,
                         TOP_c3_shlafa_i, 0x000000ff,
                         TOP_c3_shlata_i, 0x000000ff,
                         TOP_c3_shla_i, 0x000000ff,
                         TOP_c3_shrafa_i, 0x000000ff,
                         TOP_c3_shrata_i, 0x000000ff,
                         TOP_c3_shra_i, 0x000000ff,
                         TOP_c3_st, 0x000000ff,
                         TOP_c3_subc,  0x000000ff,
                         TOP_c3_nega,  0x000000ff,
                         TOP_c3_mvfacc, 0x000000ff,
                         TOP_c3_mvfaddr, 0x000000ff,
                         TOP_c3_mvfadds, 0x000000ff,
                         TOP_c3_mvtacc, 0x000000ff,
                         TOP_c3_mvtaddr, 0x000000ff,
                         TOP_c3_mvtadds, 0x000000ff,
#endif					 
			 TOP_movf, 0x000000ff,
			 TOP_movn, 0x000000ff,
			 TOP_movt, 0x000000ff,
			 TOP_movz, 0x000000ff,
			 TOP_sll, 0x000000ff,
			 TOP_sllv, 0x000000ff,
			 TOP_sra, 0x000000ff,
			 TOP_srav, 0x000000ff,
			 TOP_srl, 0x000000ff,
			 TOP_srlv, 0x000000ff,
			 TOP_dsll, 0x000000ff,
			 TOP_dsll32, 0x000000ff,
			 TOP_dsllv, 0x000000ff,
			 TOP_dsra, 0x000000ff,
			 TOP_dsra32, 0x000000ff,
			 TOP_dsrav, 0x000000ff,
			 TOP_dsrl, 0x000000ff,
			 TOP_dsrl32, 0x000000ff,
			 TOP_dsrlv, 0x000000ff,
			 TOP_beq, 0x000000ff,
			 TOP_bgez, 0x000000ff,
			 TOP_bgezal, 0x000000ff,
			 TOP_bgtz, 0x000000ff,
			 TOP_blez, 0x000000ff,
			 TOP_bltz, 0x000000ff,
			 TOP_bltzal, 0x000000ff,
			 TOP_bne, 0x000000ff,
			 TOP_j, 0x000000ff,
			 TOP_jal, 0x000000ff,
			 TOP_jalr, 0x000000ff,
			 TOP_jr, 0x000000ff,
			 TOP_break, 0x000000ff,
			 TOP_syscall, 0x000000ff,
			 TOP_teq, 0x000000ff,
			 TOP_teqi, 0x000000ff,
			 TOP_tge, 0x000000ff,
			 TOP_tgei, 0x000000ff,
			 TOP_tgeiu, 0x000000ff,
			 TOP_tgeu, 0x000000ff,
			 TOP_tlt, 0x000000ff,
			 TOP_tlti, 0x000000ff,
			 TOP_tltiu, 0x000000ff,
			 TOP_tltu, 0x000000ff,
			 TOP_tne, 0x000000ff,
			 TOP_tnei, 0x000000ff,
			 TOP_lwc1, 0x000000ff,
			 TOP_ldc1, 0x000000ff,
			 TOP_lwxc1, 0x000000ff,
			 TOP_ldxc1, 0x000000ff,
			 TOP_swc1, 0x000000ff,
			 TOP_sdc1, 0x000000ff,
			 TOP_swxc1, 0x000000ff,
			 TOP_sdxc1, 0x000000ff,
			 TOP_abs_s, 0x000000ff,
			 TOP_abs_d, 0x000000ff,
			 TOP_add_s, 0x000000ff,
			 TOP_add_d, 0x000000ff,
			 TOP_c_f_s, 0x000000ff,
			 TOP_c_f_d, 0x000000ff,
			 TOP_c_t_s, 0x000000ff,
			 TOP_c_t_d, 0x000000ff,
			 TOP_c_un_s, 0x000000ff,
			 TOP_c_un_d, 0x000000ff,
			 TOP_c_or_s, 0x000000ff,
			 TOP_c_or_d, 0x000000ff,
			 TOP_c_eq_s, 0x000000ff,
			 TOP_c_eq_d, 0x000000ff,
			 TOP_c_neq_s, 0x000000ff,
			 TOP_c_neq_d, 0x000000ff,
			 TOP_c_ueq_s, 0x000000ff,
			 TOP_c_ueq_d, 0x000000ff,
			 TOP_c_olg_s, 0x000000ff,
			 TOP_c_olg_d, 0x000000ff,
			 TOP_c_olt_s, 0x000000ff,
			 TOP_c_olt_d, 0x000000ff,
			 TOP_c_uge_s, 0x000000ff,
			 TOP_c_uge_d, 0x000000ff,
			 TOP_c_ult_s, 0x000000ff,
			 TOP_c_ult_d, 0x000000ff,
			 TOP_c_oge_s, 0x000000ff,
			 TOP_c_oge_d, 0x000000ff,
			 TOP_c_ole_s, 0x000000ff,
			 TOP_c_ole_d, 0x000000ff,
			 TOP_c_ugt_s, 0x000000ff,
			 TOP_c_ugt_d, 0x000000ff,
			 TOP_c_ule_s, 0x000000ff,
			 TOP_c_ule_d, 0x000000ff,
			 TOP_c_ogt_s, 0x000000ff,
			 TOP_c_ogt_d, 0x000000ff,
			 TOP_c_sf_s, 0x000000ff,
			 TOP_c_sf_d, 0x000000ff,
			 TOP_c_st_s, 0x000000ff,
			 TOP_c_st_d, 0x000000ff,
			 TOP_c_ngle_s, 0x000000ff,
			 TOP_c_ngle_d, 0x000000ff,
			 TOP_c_gle_s, 0x000000ff,
			 TOP_c_gle_d, 0x000000ff,
			 TOP_c_seq_s, 0x000000ff,
			 TOP_c_seq_d, 0x000000ff,
			 TOP_c_sne_s, 0x000000ff,
			 TOP_c_sne_d, 0x000000ff,
			 TOP_c_ngl_s, 0x000000ff,
			 TOP_c_ngl_d, 0x000000ff,
			 TOP_c_gl_s, 0x000000ff,
			 TOP_c_gl_d, 0x000000ff,
			 TOP_c_lt_s, 0x000000ff,
			 TOP_c_lt_d, 0x000000ff,
			 TOP_c_nlt_s, 0x000000ff,
			 TOP_c_nlt_d, 0x000000ff,
			 TOP_c_nge_s, 0x000000ff,
			 TOP_c_nge_d, 0x000000ff,
			 TOP_c_ge_s, 0x000000ff,
			 TOP_c_ge_d, 0x000000ff,
			 TOP_c_le_s, 0x000000ff,
			 TOP_c_le_d, 0x000000ff,
			 TOP_c_nle_s, 0x000000ff,
			 TOP_c_nle_d, 0x000000ff,
			 TOP_c_ngt_s, 0x000000ff,
			 TOP_c_ngt_d, 0x000000ff,
			 TOP_c_gt_s, 0x000000ff,
			 TOP_c_gt_d, 0x000000ff,
			 TOP_div_s, 0x000000ff,
			 TOP_div_d, 0x000000ff,
			 TOP_mul_s, 0x000000ff,
			 TOP_mul_d, 0x000000ff,
			 TOP_neg_s, 0x000000ff,
			 TOP_neg_d, 0x000000ff,
			 TOP_sub_s, 0x000000ff,
			 TOP_sub_d, 0x000000ff,
			 TOP_sqrt_s, 0x000000ff,
			 TOP_sqrt_d, 0x000000ff,
			 TOP_madd_s, 0x000000ff,
			 TOP_madd_d, 0x000000ff,
			 TOP_msub_s, 0x000000ff,
			 TOP_msub_d, 0x000000ff,
			 TOP_nmadd_s, 0x000000ff,
			 TOP_nmadd_d, 0x000000ff,
			 TOP_nmsub_s, 0x000000ff,
			 TOP_nmsub_d, 0x000000ff,
			 TOP_recip_s, 0x000000ff,
			 TOP_recip_d, 0x000000ff,
			 TOP_rsqrt_s, 0x000000ff,
			 TOP_rsqrt_d, 0x000000ff,
			 TOP_cfc1, 0x000000ff,
			 TOP_ctc1, 0x000000ff,
			 TOP_mfc1, 0x000000ff,
			 TOP_mtc1, 0x000000ff,
			 TOP_dmfc1, 0x000000ff,
			 TOP_dmtc1, 0x000000ff,
			 TOP_mov_s, 0x000000ff,
			 TOP_mov_d, 0x000000ff,
			 TOP_movf_s, 0x000000ff,
			 TOP_movf_d, 0x000000ff,
			 TOP_movn_s, 0x000000ff,
			 TOP_movn_d, 0x000000ff,
			 TOP_movt_s, 0x000000ff,
			 TOP_movt_d, 0x000000ff,
			 TOP_movz_s, 0x000000ff,
			 TOP_movz_d, 0x000000ff,
			 TOP_cvt_d_s, 0x000000ff,
			 TOP_cvt_d_w, 0x000000ff,
			 TOP_cvt_d_l, 0x000000ff,
			 TOP_cvt_l_s, 0x000000ff,
			 TOP_cvt_l_d, 0x000000ff,
			 TOP_cvt_s_d, 0x000000ff,
			 TOP_cvt_s_w, 0x000000ff,
			 TOP_cvt_s_l, 0x000000ff,
			 TOP_cvt_w_s, 0x000000ff,
			 TOP_cvt_w_d, 0x000000ff,
			 TOP_ceil_w_s, 0x000000ff,
			 TOP_ceil_w_d, 0x000000ff,
			 TOP_ceil_l_s, 0x000000ff,
			 TOP_ceil_l_d, 0x000000ff,
			 TOP_floor_w_s, 0x000000ff,
			 TOP_floor_w_d, 0x000000ff,
			 TOP_floor_l_s, 0x000000ff,
			 TOP_floor_l_d, 0x000000ff,
			 TOP_round_w_s, 0x000000ff,
			 TOP_round_w_d, 0x000000ff,
			 TOP_round_l_s, 0x000000ff,
			 TOP_round_l_d, 0x000000ff,
			 TOP_trunc_w_s, 0x000000ff,
			 TOP_trunc_w_d, 0x000000ff,
			 TOP_trunc_l_s, 0x000000ff,
			 TOP_trunc_l_d, 0x000000ff,
			 TOP_bc1f, 0x000000ff,
			 TOP_bc1t, 0x000000ff,
#ifdef TARG_SL2
                         TOP_c2_mvgr_r2g_h_u,          0x000000ff,
                         TOP_c2_mvgr_r2g_h,          0x000000ff,
                         TOP_c2_mvgr_r2g_w,          0x000000ff,
                         TOP_c2_mvgr_r2g_h_u_i,          0x000000ff,
                         TOP_c2_mvgr_r2g_h_i,          0x000000ff,
                         TOP_c2_mvgr_r2g_w_i,          0x000000ff,
                         TOP_c2_mvgr_g2r_ba_lh,          0x000000ff,
                         TOP_c2_mvgr_g2r_ba_hh,          0x000000ff,
                         TOP_c2_mvgr_g2r_ba_w,          0x000000ff,
                         TOP_c2_mvgr_g2r_lh_i,          0x000000ff,
                         TOP_c2_mvgr_g2r_hh_i,          0x000000ff,
                         TOP_c2_mvgr_g2r_w_i,          0x000000ff,
                         TOP_c2_mvgr_g2r_lh,          0x000000ff,
                         TOP_c2_mvgr_g2r_hh,          0x000000ff,
                         TOP_c2_mvgr_g2r_w,          0x000000ff,
                         TOP_c2_mvgr_g2r_bh,          0x000000ff,
                         TOP_c2_mvgr_g2r_bh_u,          0x000000ff,
                         TOP_c2_mvgr_g2r_bv,          0x000000ff,
                         TOP_c2_mvgr_g2r_bv_u,          0x000000ff,
                         TOP_c2_mvgr_g2r_b4_i,          0x000000ff,
                         TOP_c2_mvgr_g2r_b4,          0x000000ff,
                         TOP_c2_mvgc_c2g,          0x000000ff,
                         TOP_c2_mvgc_g2c,          0x000000ff,
                         TOP_c2_ld_v_b_u,          0x000000ff,
                         TOP_c2_ld_v_b,          0x000000ff,
                         TOP_c2_ld_v_h,          0x000000ff,
                         TOP_c2_ld_v_w,          0x000000ff,
                         TOP_c2_ld_v_sw,          0x000000ff,
                         TOP_c2_ld_v_m_b_u,          0x000000ff,
                         TOP_c2_ld_v_m_b,          0x000000ff,
                         TOP_c2_ld_v_m_h,          0x000000ff,
                         TOP_c2_ld_v_m_w,          0x000000ff,
                         TOP_c2_ld_s_h_u_p,          0x000000ff,
                         TOP_c2_ld_s_h_u,          0x000000ff,
                         TOP_c2_ld_s_h_p,          0x000000ff,
                         TOP_c2_ld_s_h,          0x000000ff,
                         TOP_c2_ld_s_w_p,          0x000000ff,
                         TOP_c2_ld_s_w,          0x000000ff,

                         TOP_c2_ld_v2g_b_u,        0x000000ff,
                         TOP_c2_ld_v2g_b,           0x000000ff,
                         TOP_c2_ld_v2g_h_u,        0x000000ff,
                         TOP_c2_ld_v2g_h,           0x000000ff,
                         TOP_c2_ld_v2g_w,           0x000000ff,

                         TOP_c2_st_v_b,          0x000000ff,
                         TOP_c2_st_v_h,          0x000000ff,
                         TOP_c2_st_v_w,          0x000000ff,
                         TOP_c2_st_v_m_b,          0x000000ff,
                         TOP_c2_st_v_m_h,          0x000000ff,
                         TOP_c2_st_v_m_w,          0x000000ff,
                         TOP_c2_st_s_h,          0x000000ff,
                         TOP_c2_st_s_h_p,          0x000000ff,
                         TOP_c2_st_s_w,          0x000000ff,
                         TOP_c2_st_s_w_p,          0x000000ff,

                         TOP_c2_st_g2v_b,        0x000000ff,
                         TOP_c2_st_g2v_h,        0x000000ff,
                         TOP_c2_st_g2v_w,       0x000000ff,

                         TOP_c2_ldi_s_h_u,          0x000000ff,
                         TOP_c2_ldi_s_h,          0x000000ff,
                         TOP_c2_ldi_s_w,          0x000000ff,
                         TOP_c2_ldi_c,          0x000000ff,
                         TOP_c2_ldi_v_b_u,          0x000000ff,
                         TOP_c2_ldi_v_b,          0x000000ff,
                         TOP_c2_ldi_v_h,          0x000000ff,
                         TOP_c2_ldi_v_w,          0x000000ff,
                         TOP_c2_ldi_v_m_b_u,          0x000000ff,
                         TOP_c2_ldi_v_m_b,          0x000000ff,
                         TOP_c2_ldi_v_m_h,          0x000000ff,
                         TOP_c2_ldi_v_m_w,          0x000000ff,

                         TOP_c2_ldi_v2g_b_u,       0x000000ff,
                         TOP_c2_ldi_v2g_b,           0x000000ff,
                         TOP_c2_ldi_v2g_h_u,       0x000000ff,
                         TOP_c2_ldi_v2g_h,           0x000000ff,
                         TOP_c2_ldi_v2g_w,          0x000000ff,


                         TOP_c2_sti_v_b,          0x000000ff,
                         TOP_c2_sti_v_h,          0x000000ff,
                         TOP_c2_sti_v_w,          0x000000ff,
                         TOP_c2_sti_v_m_b,      0x000000ff,
                         TOP_c2_sti_v_m_h,      0x000000ff,
                         TOP_c2_sti_v_m_w,     0x000000ff,
                         TOP_c2_sti_c,              0x000000ff,
                         TOP_c2_sti_s_h,          0x000000ff,
                         TOP_c2_sti_s_w,          0x000000ff,

                         TOP_c2_sti_g2v_b,       0x000000ff,
                         TOP_c2_sti_g2v_h,       0x000000ff,
                         TOP_c2_sti_g2v_w,      0x000000ff,

                         TOP_c2_vadds_h,          0x000000ff,
                         TOP_c2_vadds_w,          0x000000ff,
                         TOP_c2_vadds_p,          0x000000ff,
                         TOP_c2_vadds_h_mode6,          0x000000ff,
                         TOP_c2_vadds_h_mode2,          0x000000ff,
                         TOP_c2_vadds_w_mode6,          0x000000ff,
                         TOP_c2_vadds_w_mode2,          0x000000ff,
                         TOP_c2_vadds_p_mode6,          0x000000ff,
                         TOP_c2_vadds_p_mode2,          0x000000ff,
                         TOP_c2_vsubs_h,          0x000000ff,
                         TOP_c2_vsubs_h_sm,          0x000000ff,
                         TOP_c2_vsubs_h_abs,          0x000000ff,
                         TOP_c2_vsubs_h_abs_sm,          0x000000ff,
                         TOP_c2_vabs_h,          0x000000ff,
                         TOP_c2_vabs_h_sm,          0x000000ff,
                         TOP_c2_vsubs_w,          0x000000ff,
                         TOP_c2_vsubs_w_sm,          0x000000ff,
                         TOP_c2_vsubs_w_abs,          0x000000ff,
                         TOP_c2_vsubs_w_abs_sm,          0x000000ff,
                         TOP_c2_vabs_w,          0x000000ff,
                         TOP_c2_vabs_w_sm,          0x000000ff,
                         TOP_c2_vsubs_p,          0x000000ff,
                         TOP_c2_vsubs_p_sm,          0x000000ff,
                         TOP_c2_vsubs_p_abs,          0x000000ff,
                         TOP_c2_vsubs_p_abs_sm,          0x000000ff,
                         TOP_c2_vabs_p,          0x000000ff,
                         TOP_c2_vabs_p_sm,          0x000000ff,
                         TOP_c2_vmul_h,          0x000000ff,
                         TOP_c2_vmul_w,          0x000000ff,
                         TOP_c2_vneg_h,          0x000000ff,
                         TOP_c2_vneg_w,          0x000000ff,
                         TOP_c2_vneg_p,          0x000000ff,
                         TOP_c2_vshr_p,          0x000000ff,
                         TOP_c2_vshr_h,          0x000000ff,
                         TOP_c2_vshr_w,          0x000000ff,
                         TOP_c2_vshl_p,          0x000000ff,
                         TOP_c2_vshl_h,          0x000000ff,
                         TOP_c2_vshl_w,          0x000000ff,
                         TOP_c2_vclp,          0x000000ff,
                         TOP_c2_vclp_p,          0x000000ff,
                         TOP_c2_vclp_a,          0x000000ff,
                         TOP_c2_vclp_s,          0x000000ff,
                         TOP_c2_vclp_2,          0x000000ff,
                         TOP_c2_vclp_n,          0x000000ff,
                         TOP_c2_vclg_h_lt_and,          0x000000ff,
                         TOP_c2_vclg_h_lt_or,          0x000000ff,
                         TOP_c2_vclg_h_le_and,          0x000000ff,
                         TOP_c2_vclg_h_le_or,          0x000000ff,
                         TOP_c2_vclg_h_eq_and,          0x000000ff,
                         TOP_c2_vclg_h_eq_or,          0x000000ff,
                         TOP_c2_vclg_h_ge_and,          0x000000ff,
                         TOP_c2_vclg_h_ge_or,          0x000000ff,
                         TOP_c2_vclg_h_gt_and,      0x000000ff,
                         TOP_c2_vclg_h_gt_or,       0x000000ff,
                         TOP_c2_vclg_h_and,         0x000000ff,
                         TOP_c2_vclg_h_or,          0x000000ff,
                         TOP_c2_vclg_h_le,          0x000000ff,
                         TOP_c2_vclg_h_lt,          0x000000ff,
                         TOP_c2_vclg_h_ge,          0x000000ff,
                         TOP_c2_vclg_h_gt,          0x000000ff,
                         TOP_c2_vclg_w_lt_and,      0x000000ff,
                         TOP_c2_vclg_w_lt_or,       0x000000ff,
                         TOP_c2_vclg_w_le_and,      0x000000ff,
                         TOP_c2_vclg_w_le_or,       0x000000ff,
                         TOP_c2_vclg_w_eq_and,      0x000000ff,
                         TOP_c2_vclg_w_eq_or,       0x000000ff,
                         TOP_c2_vclg_w_ge_and,      0x000000ff,
                         TOP_c2_vclg_w_ge_or,       0x000000ff,
                         TOP_c2_vclg_w_gt_and,      0x000000ff,
                         TOP_c2_vclg_w_gt_or,       0x000000ff,
                         TOP_c2_vclg_w_and,         0x000000ff,
                         TOP_c2_vclg_w_or,          0x000000ff,
                         TOP_c2_vclg_w_le,          0x000000ff,
                         TOP_c2_vclg_w_lt,          0x000000ff,
                         TOP_c2_vclg_w_ge,          0x000000ff,
                         TOP_c2_vclg_w_gt,          0x000000ff,
                         TOP_c2_vclg_p_lt_and,          0x000000ff,
                         TOP_c2_vclg_p_lt_or,          0x000000ff,
                         TOP_c2_vclg_p_le_and,          0x000000ff,
                         TOP_c2_vclg_p_le_or,          0x000000ff,
                         TOP_c2_vclg_p_eq_and,          0x000000ff,
                         TOP_c2_vclg_p_eq_or,          0x000000ff,
                         TOP_c2_vclg_p_ge_and,          0x000000ff,
                         TOP_c2_vclg_p_ge_or,          0x000000ff,
                         TOP_c2_vclg_p_gt_and,          0x000000ff,
                         TOP_c2_vclg_p_gt_or,          0x000000ff,
                         TOP_c2_vclg_p_and,          0x000000ff,
                         TOP_c2_vclg_p_or,          0x000000ff,
                         TOP_c2_vclg_p_le,          0x000000ff,
                         TOP_c2_vclg_p_eq,          0x000000ff,
                         TOP_c2_vclg_p_ge,          0x000000ff,
                         TOP_c2_vclg_p_gt,          0x000000ff,
                         TOP_c2_vcmov_h_f,          0x000000ff,
                         TOP_c2_vcmov_h_t,          0x000000ff,
                         TOP_c2_vcmov_w_f,          0x000000ff,
                         TOP_c2_vcmov_w_t,          0x000000ff,
                         TOP_c2_lczero_z,             0x000000ff,
                         TOP_c2_lczero_nz_fw,      0x000000ff,
                         TOP_c2_lczero_nz_bw,      0x000000ff,
                         TOP_c2_vrnd_h,          0x000000ff,
                         TOP_c2_vrnd_w,          0x000000ff,
                         TOP_c2_vspas,          0x000000ff,
                         TOP_c2_vspel_mul_h,  0x000000ff,
                         TOP_c2_vspel_mul_w,  0x000000ff,
                         TOP_c2_vspel_adds,   0x000000ff,
                         TOP_c2_vspel_mac_h,  0x000000ff,
                         TOP_c2_vspel_mac_w,     0x000000ff,
                         TOP_c2_mmul_h,          0x000000ff,
                         TOP_c2_mmul_w,          0x000000ff,
                         TOP_c2_vmov,          0x000000ff,
                         TOP_c2_vmov_swin,          0x000000ff,
                         TOP_c2_vcopy,      0x000000ff,
                         TOP_c2_vcmpr_h_eq,          0x000000ff,
                         TOP_c2_vcmpr_h_lt,          0x000000ff,
                         TOP_c2_vcmpr_h_le,          0x000000ff,
                         TOP_c2_vcmpr_h_gt,          0x000000ff,
                         TOP_c2_vcmpr_h_ge,          0x000000ff,
                         TOP_c2_vcmpr_w_eq,          0x000000ff,
                         TOP_c2_vcmpr_w_lt,          0x000000ff,
                         TOP_c2_vcmpr_w_le,          0x000000ff,
                         TOP_c2_vcmpr_w_gt,          0x000000ff,
                         TOP_c2_vcmpr_w_ge,          0x000000ff,
                         TOP_c2_sad,          0x000000ff,
                         TOP_c2_satd,   0x000000ff, 
                         TOP_c2_intra,          0x000000ff,
                         TOP_c2_intra_0_1_9_14_16,      0x000000ff,
                         TOP_c2_intra_2_3_8_10,      0x000000ff,
                         TOP_c2_intra_4,      0x000000ff,
                         TOP_c2_intra_5_11,      0x000000ff,
                         TOP_c2_intra_6,      0x000000ff,
                         TOP_c2_intra_7,      0x000000ff,
                         TOP_c2_intra_12_13,      0x000000ff,
                         TOP_c2_intra_15_17,  0x000000ff,
                         TOP_c2_mvsel_mode0,          0x000000ff,
                         TOP_c2_mvsel_mode1,          0x000000ff,
                         TOP_c2_mvsel_mode2,          0x000000ff,
                         TOP_c2_mvsel_mode345,          0x000000ff,
                         TOP_c2_bcst_q,          0x000000ff,
                         TOP_c2_bcst_i,          0x000000ff,
                         TOP_c2_vlcs_dc,          0x000000ff,
                         TOP_c2_vlcs_ac,          0x000000ff,
                         TOP_c2_vlcs_wb,          0x000000ff,
                         TOP_c2_add_shl_g_i,          0x000000ff,
                         TOP_c2_add_shr_g_i,          0x000000ff,
                         TOP_c2_add_shl_g,          0x000000ff,
                         TOP_c2_add_shr_g,          0x000000ff,
                         TOP_c2_add_shl_r_h_i,          0x000000ff,
                         TOP_c2_add_shr_r_h_i,          0x000000ff,
                         TOP_c2_add_shl_r_w_i,          0x000000ff,
                         TOP_c2_add_shr_r_w_i,          0x000000ff,
                         TOP_c2_add_shl_r_h,          0x000000ff,
                         TOP_c2_add_shr_r_h,          0x000000ff,
                         TOP_c2_add_shl_r_w,          0x000000ff,
                         TOP_c2_add_shr_r_w,          0x000000ff,

                         TOP_c2_sub_g_abs_i,          0x000000ff,
                         TOP_c2_subs_g_i,          0x000000ff,
                         TOP_c2_sub_g_abs,          0x000000ff,
                         TOP_c2_subs_g,          0x000000ff,
                         TOP_c2_subs_r_h_i,          0x000000ff,
                         TOP_c2_subs_r_w_i,          0x000000ff,
                         TOP_c2_sub_r_abs_h_i,          0x000000ff,
                         TOP_c2_sub_r_abs_w_i,          0x000000ff,
                         TOP_c2_subs_r_h,          0x000000ff,
                         TOP_c2_subs_r_w,          0x000000ff,
                         TOP_c2_sub_r_abs_h,          0x000000ff,
                         TOP_c2_sub_r_abs_w,          0x000000ff,
                         TOP_c2_muls,          0x000000ff,
                         TOP_c2_mads,          0x000000ff,
                         TOP_c2_smads,          0x000000ff,
                         TOP_c2_min,          0x000000ff,
                         TOP_c2_max,          0x000000ff,
                         TOP_c2_cmov,          0x000000ff,
                         TOP_c2_mov_g,          0x000000ff,
                         TOP_c2_mov_r,          0x000000ff,
                         TOP_c2_mov_c_i,          0x000000ff,
                         TOP_c2_mov_c,          0x000000ff,
                         TOP_c2_mov_s_i,          0x000000ff,
                         TOP_c2_mov_s,          0x000000ff,
                         TOP_c2_clp,          0x000000ff,
                         TOP_c2_clp_i,          0x000000ff,
                         TOP_c2_chkrng,          0x000000ff,

                         TOP_c2_scond_r_h_eq,          0x000000ff,
                         TOP_c2_scond_r_h_lt,          0x000000ff,
                         TOP_c2_scond_r_h_le,          0x000000ff,
                         TOP_c2_scond_r_h_gt,          0x000000ff,
                         TOP_c2_scond_r_h_ge,          0x000000ff,
                         TOP_c2_scond_r_h_eq_i,          0x000000ff,
                         TOP_c2_scond_r_h_lt_i,          0x000000ff,
                         TOP_c2_scond_r_h_le_i,          0x000000ff,
                         TOP_c2_scond_r_h_gt_i,          0x000000ff,
                         TOP_c2_scond_r_h_ge_i,          0x000000ff,
                         TOP_c2_scond_r_w_eq,          0x000000ff,
                         TOP_c2_scond_r_w_lt,          0x000000ff,
                         TOP_c2_scond_r_w_le,          0x000000ff,
                         TOP_c2_scond_r_w_gt,          0x000000ff,
                         TOP_c2_scond_r_w_ge,          0x000000ff,
                         TOP_c2_scond_r_w_eq_i,          0x000000ff,
                         TOP_c2_scond_r_w_lt_i,          0x000000ff,
                         TOP_c2_scond_r_w_le_i,          0x000000ff,
                         TOP_c2_scond_r_w_gt_i,          0x000000ff,
                         TOP_c2_scond_r_w_ge_i,          0x000000ff,


                         TOP_c2_scond_r_h_wb_eq,          0x000000ff,
                         TOP_c2_scond_r_h_wb_lt,          0x000000ff,
                         TOP_c2_scond_r_h_wb_le,          0x000000ff,
                         TOP_c2_scond_r_h_wb_gt,          0x000000ff,
                         TOP_c2_scond_r_h_wb_ge,          0x000000ff,
                         TOP_c2_scond_r_wb_eq_i,          0x000000ff,
                         TOP_c2_scond_r_wb_lt_i,          0x000000ff,
                         TOP_c2_scond_r_wb_le_i,          0x000000ff,
                         TOP_c2_scond_r_wb_gt_i,          0x000000ff,
                         TOP_c2_scond_r_wb_ge_i,          0x000000ff,
                         TOP_c2_scond_r_w_wb_eq,          0x000000ff,
                         TOP_c2_scond_r_w_wb_lt,          0x000000ff,
                         TOP_c2_scond_r_w_wb_le,          0x000000ff,
                         TOP_c2_scond_r_w_wb_gt,          0x000000ff,
                         TOP_c2_scond_r_w_wb_ge,          0x000000ff,
                         TOP_c2_scond_r_w_wb_eq_i,          0x000000ff,
                         TOP_c2_scond_r_w_wb_lt_i,          0x000000ff,
                         TOP_c2_scond_r_w_wb_le_i,          0x000000ff,
                         TOP_c2_scond_r_w_wb_gt_i,          0x000000ff,
                         TOP_c2_scond_r_w_wb_ge_i,          0x000000ff,

                         TOP_c2_scond_eq,          0x000000ff,
                         TOP_c2_scond_lt,          0x000000ff,
                         TOP_c2_scond_le,          0x000000ff,
                         TOP_c2_scond_gt,          0x000000ff,
                         TOP_c2_scond_ge,          0x000000ff,
                         TOP_c2_scond_eq_i,          0x000000ff,
                         TOP_c2_scond_lt_i,          0x000000ff,
                         TOP_c2_scond_le_i,          0x000000ff,
                         TOP_c2_scond_gt_i,          0x000000ff,
                         TOP_c2_scond_ge_i,          0x000000ff,
                         TOP_c2_bop_ls,          0x000000ff,
                         TOP_c2_bop_rs,          0x000000ff,
                         TOP_c2_bop_and,          0x000000ff,
                         TOP_c2_bop_or,          0x000000ff,
                         TOP_c2_bop_xor,          0x000000ff,
                         TOP_c2_bop_andxor, 0x000000ff,
                         TOP_c2_bop_ls_i,     0x000000ff,
                         TOP_c2_bop_rs_i,    0x000000ff,
                         TOP_c2_bop_and_i,  0x000000ff,
                         TOP_c2_bop_or_i,    0x000000ff,
                         TOP_c2_bop_xor_i,  0x000000ff,
                         TOP_c2_bdep_l,       0x000000ff,
                         TOP_c2_bdep_m,     0x000000ff,
                         TOP_c2_bxtr_u_l,     0x000000ff,
                         TOP_c2_bxtr_s_l,     0x000000ff,
                         TOP_c2_bxtr_u_m,   0x000000ff,
                         TOP_c2_bxtr_s_m,   0x000000ff,
                         TOP_c2_bxtrr48,   0x000000ff,
                         TOP_c2_bxtrr48_i,   0x000000ff,
                         TOP_c2_sum4_c,    0x000000ff,
                         TOP_c2_sum4_g,    0x000000ff,
                         TOP_c2_sum4_sw,  0x000000ff,
                         TOP_c2_sum4_r,     0x000000ff,
                         TOP_c2_sum4_saddr,  0x000000ff, 
                         TOP_c2_med,         0x000000ff,
                         TOP_c2_gsums,      0x000000ff,
                         TOP_c2_wrap,      0x000000ff,
                         TOP_c2_clzob_zd,       0x000000ff, 
                         TOP_c2_clzob_od,       0x000000ff, 
                         TOP_c2_clzob_zd_i,        0x000000ff, 
                         TOP_c2_clzob_od_i,        0x000000ff, 
                         TOP_c2_thctrl_lock,       0x000000ff,
                         TOP_c2_thctrl_unlock,     0x000000ff,
                         TOP_c2_thctrl_deact,      0x000000ff,
                         TOP_c2_thctrl_act,        0x000000ff,
                         TOP_c2_thctrl_mode4,      0x000000ff, 
                         TOP_c2_thctrl_mode5,      0x000000ff,
                         TOP_c2_thctrl_mode6,      0x000000ff,
                         TOP_c2_thctrl_mode7,      0x000000ff,
                         TOP_c2_fork_m,     0x000000ff,
                         TOP_c2_fork_n ,     0x000000ff,
                         TOP_c2_joint,         0x000000ff,
                         TOP_c2_macro,      0x000000ff,
                         TOP_c2_shor_l,      0x000000ff,
                         TOP_c2_shor_rl,     0x000000ff,
                         TOP_c2_shor_ra,    0x000000ff,
                         TOP_c2_shadd_l,    0x000000ff,
                         TOP_c2_shadd_rl,   0x000000ff,
                         TOP_c2_shadd_ra,  0x000000ff,
                         TOP_c2_shsub_l,     0x000000ff,
                         TOP_c2_shsub_rl,    0x000000ff,
                         TOP_c2_shsub_ra,   0x000000ff,
                         TOP_c2_shor_l_i,     0x000000ff,
                         TOP_c2_shor_rl_i,    0x000000ff,
                         TOP_c2_shor_ra_i,    0x000000ff,
                         TOP_c2_shadd_l_i,   0x000000ff,
                         TOP_c2_shadd_rl_i,  0x000000ff,
                         TOP_c2_shadd_ra_i, 0x000000ff,
                         TOP_c2_shsub_l_i,   0x000000ff,
                         TOP_c2_shsub_rl_i,  0x000000ff,
                         TOP_c2_shsub_ra_i, 0x000000ff,
#endif 
			 TOP_nop, 0x000000ff,
			 TOP_UNDEFINED);

  ISA_Pack_End();
}
