/*

  Copyright (C) 2006-2009 Tsinghua University.  All Rights Reserved.
  Copyright (C) 2000, 2001 Silicon Graphics, Inc.  All Rights Reserved.

  This program is free software; you can redistribute it and/or modify it
  under the terms of version 2 of the GNU General Public License as
  published by the Free Software Foundation.

  This program is distributed in the hope that it would be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

  Further, this software is distributed without any warranty that it is
  free of the rightful claim of any third person regarding infringement 
  or the like.  Any license provided herein, whether implied or 
  otherwise, applies only to this software file.  Patent licenses, if 
  any, provided herein do not apply to combinations of this program with 
  other software, or any other product whatsoever.  

  You should have received a copy of the GNU General Public License along
  with this program; if not, write the Free Software Foundation, Inc., 59
  Temple Place - Suite 330, Boston MA 02111-1307, USA.

  Contact information:  Silicon Graphics, Inc., 1600 Amphitheatre Pky,
  Mountain View, CA 94043, or:

  http://www.sgi.com

  For further information regarding this notice, see:

  http://oss.sgi.com/projects/GenInfo/NoticeExplan

*/


//  
//  Generate ISA bundle information
///////////////////////////////////////

//  $Revision: 1.3 $
//  $Date: 2005/09/28 07:38:45 $
//  $Author: kevinlo $
//  $Source: /depot/CVSROOT/javi/src/sw/cmplr/common/targ_info/isa/MIPS/isa_bundle.cxx,v $

#include <stddef.h>
#include "topcode.h"
#include "isa_bundle_gen.h"

main()
{
  ISA_EXEC_UNIT_TYPE
    Fetch_Unit;  // Instruction fetch type

  ISA_Bundle_Begin("PPC32", 32);

  ISA_Bundle_Pack_Create(ISA_Bundle_Pack_Little_Endian);
  Pack_Slot(0, 0, 0, 32);

  /* ===== Specification for Fetch_Unit Type ===== */
  Fetch_Unit = ISA_Exec_Unit_Type_Create("Fetch_Unit", NULL);
  Instruction_Exec_Unit_Group(Fetch_Unit,
			      TOP_lbz,
			      TOP_lbzu,
			      TOP_lhz,
			      TOP_lhzu,
			      TOP_lha,
		        TOP_lhau,
			      TOP_lwz,
			      TOP_lwzu,
//			      TOP_lwl,
//			      TOP_lwr,
			      TOP_stb,
			      TOP_stbu,
			      TOP_sth,
			      TOP_sthu,
			      TOP_stw,
			      TOP_stwu,

            TOP_lbzx,
          	TOP_lbzux,
          	TOP_lhzx,
          	TOP_lhzux,
          	TOP_lhax,
          	TOP_lhaux,
          	TOP_lwzx,
          	TOP_lwzux,
            	
          	TOP_stbx,
          	TOP_stbux,
          	TOP_sthx,
          	TOP_sthux,
          	TOP_stwx,
          	TOP_stwux,
//			      TOP_swl,
//			      TOP_swr,
//			      TOP_ll,
//			      TOP_sc,
//			      TOP_sync,
//			      TOP_lwu,
//			      TOP_ld,
//			      TOP_ldl,
//			      TOP_ldr,
//			      TOP_lld,
//			      TOP_sd,
//			      TOP_sdl,
//			      TOP_sdr,
//			      TOP_scd,
//			      TOP_pref,
//			      TOP_prefx,
			      TOP_add,
			      TOP_addi,
			      TOP_addis,
                              TOP_add_,
			      TOP_addic,
//			      TOP_addiu,
//			      TOP_addu,
			      TOP_divw,
//			      TOP_divwxwxwxu,
                  TOP_mulli,
                  TOP_mullwo,
                  TOP_mulhw,
                  TOP_mulhwu,
                  TOP_divwo,
                  TOP_divwu,
                  TOP_divwuo,
			      TOP_mullw,
//			      TOP_mullwu,
			      TOP_cmpw,
			      TOP_cmpwi,
			      TOP_cmplwi,
			      TOP_cmplw,
			      TOP_subf,
			      TOP_subfc,
			      TOP_subfe,
			      TOP_subfic,
			      TOP_addc,
						TOP_addco,
						TOP_adde,
						TOP_addeo,
						TOP_addme,
						TOP_addmeo,
						TOP_addze,
						TOP_addzeo,
						
						TOP_subfco,
						TOP_subfeo,
						TOP_subfme,
						TOP_subfmeo,
						TOP_subfze,
						TOP_subfzeo,
//			      TOP_subu,
//			      TOP_dadd,
//			      TOP_daddi,
//			      TOP_daddiu,
//			      TOP_daddu,
//			      TOP_ddiv,
//			      TOP_ddivu,
//			      TOP_dmult,
//			      TOP_dmultu,
//			      TOP_dsub,
//			      TOP_dsubu,
			      TOP_and,
			      TOP_andc,
			      TOP_andi_,
			      TOP_nand,
			      TOP_andis_,
//			      TOP_lui,
			      TOP_nor,
			      TOP_not,
			      TOP_or,
			      TOP_ori,
			      TOP_oris,
			      TOP_xor,
			      TOP_xori,
			      TOP_xoris,
			      TOP_eqv,
			      TOP_orc,
			      TOP_extsb,
			      TOP_extsh,
//			      TOP_mfhi,
//			      TOP_mflo,
//			      TOP_mthi,
//			      TOP_mtlo,										      
//			      TOP_movf,
//			      TOP_movn,
//			      TOP_movt,
//			      TOP_movz,
			      TOP_slwi,
			      TOP_slw,
			      TOP_srawi,
			      TOP_sraw,
			      TOP_srwi,
			      TOP_srw,
			      
			      TOP_rlwinm,
                  TOP_rlwimi,
                  TOP_rlwnm,
                  
//			      TOP_dsll,
//			      TOP_dsll32,
//			      TOP_dsllv,
//			      TOP_dsra,
//			      TOP_dsra32,
//			      TOP_dsrav,
//			      TOP_dsrl,
//			      TOP_dsrl32,
//			      TOP_dsrlv,
			      TOP_beq,
			      TOP_bge,
//			      TOP_bgeal,
			      TOP_bgt,
			      TOP_ble,
//			      TOP_blt,
//			      TOP_bltal,
			      TOP_bne,
			      TOP_ba,
			      TOP_bla,
			      TOP_blrl,
			      TOP_blr,
			      TOP_bctr,
			      TOP_bctrl,
//			      TOP_break,
			      TOP_sc,
			      TOP_tweq,
			      TOP_tweqi,
			      TOP_twge,
			      TOP_twgei,
//			      TOP_tgeiu,
//			      TOP_tgeu,
			      TOP_twlt,
			      TOP_twlti,
//			      TOP_tltiu,
//			      TOP_tltu,
			      TOP_twne,
			      TOP_twnei,
			      TOP_lfs,
//	          TOP_lfsu,
//	          TOP_lfsux,
	          TOP_lfsx,
	          TOP_lfd,
//	          TOP_lfdu,
//	          TOP_lfdux,
	          TOP_lfdx,
	          TOP_stfs,
//	          TOP_stfsu,
//	          TOP_stfsux,
	          TOP_stfsx,
	          TOP_stfd,
//	          TOP_stfdu,
//	          TOP_stfdux,
	          TOP_stfdx,
//			      TOP_lwc1,
//			      TOP_ldc1,
//			      TOP_lwxc1,
//			      TOP_ldxc1,
//			      TOP_swc1,
//			      TOP_sdc1,
//			      TOP_swxc1,
//			      TOP_sdxc1,
//			      TOP_abs_s,
			      TOP_fabs,
			      TOP_fnabs,
//			      TOP_add_s,
            TOP_fadds,
			      TOP_fadd,
//			      TOP_c_f_s,
//			      TOP_c_f_d,
//			      TOP_c_t_s,
//			      TOP_c_t_d,
//			      TOP_c_un_s,
//			      TOP_c_un_d,
//			      TOP_c_or_s,
//			      TOP_c_or_d,
//			      TOP_c_eq_s,
//			      TOP_c_eq_d,
//			      TOP_c_neq_s,
//			      TOP_c_neq_d,
//			      TOP_c_ueq_s,
//			      TOP_c_ueq_d,
//			      TOP_c_olg_s,
//			      TOP_c_olg_d,
//			      TOP_c_olt_s,
//			      TOP_c_olt_d,
//			      TOP_c_uge_s,
//			      TOP_c_uge_d,
//			      TOP_c_ult_s,
//			      TOP_c_ult_d,
//			      TOP_c_oge_s,
//			      TOP_c_oge_d,
//			      TOP_c_ole_s,
//			      TOP_c_ole_d,
//			      TOP_c_ugt_s,
//			      TOP_c_ugt_d,
//			      TOP_c_ule_s,
//			      TOP_c_ule_d,
//			      TOP_c_ogt_s,
//			      TOP_c_ogt_d,
//			      TOP_c_sf_s,
//			      TOP_c_sf_d,
//			      TOP_c_st_s,
//			      TOP_c_st_d,
//			      TOP_c_ngle_s,
//			      TOP_c_ngle_d,
//			      TOP_c_gle_s,
//			      TOP_c_gle_d,
//			      TOP_c_seq_s,
//			      TOP_c_seq_d,
//			      TOP_c_sne_s,
//			      TOP_c_sne_d,
//			      TOP_c_ngl_s,
//			      TOP_c_ngl_d,
//			      TOP_c_gl_s,
//			      TOP_c_gl_d,
//			      TOP_c_lt_s,
//			      TOP_c_lt_d,
//			      TOP_c_nlt_s,
//			      TOP_c_nlt_d,
//			      TOP_c_nge_s,
//			      TOP_c_nge_d,
//			      TOP_c_ge_s,
//			      TOP_c_ge_d,
//			      TOP_c_le_s,
//			      TOP_c_le_d,
//			      TOP_c_nle_s,
//			      TOP_c_nle_d,
//			      TOP_c_ngt_s,
//			      TOP_c_ngt_d,
//			      TOP_c_gt_s,
//			      TOP_c_gt_d,
//			      TOP_divwxwxwx_s,
            TOP_fdivs,
			      TOP_fdiv,
//			      TOP_mul_s,
            TOP_fmuls,
			      TOP_fmul,
//			      TOP_neg_s,
			      TOP_fneg,
//			      TOP_sub_s,
            TOP_fsubs,
			      TOP_fsub,
			      TOP_fsqrts,
			      TOP_fsqrt,
			      TOP_fmadds,
			      TOP_fmadd,
			      TOP_fmsubs,
			      TOP_fmsub,
			      TOP_fnmadds,
			      TOP_fnmadd,
			      TOP_fnmsubs,
			      TOP_fmsub,
			      TOP_fres,
//			      TOP_recip_d,
			      TOP_frsqrte,
			      TOP_fcmpu,
		        TOP_fcmpo,
		        TOP_fsel,
			      TOP_mcrfs,
			      TOP_mtfsf,
			      TOP_mffs,
			      TOP_mflr, //			      TOP_mfc1,
			      TOP_mtlr, //			      TOP_mtc1,
			      TOP_mfctr,
			      TOP_mtctr,
						TOP_mtfsb0,
						TOP_mtfsb1,
//			      TOP_dmfc1,
//			      TOP_dmtc1,
//			      TOP_mov_s,
			      TOP_fmr,
			      TOP_mfcr,
//			      TOP_movf_s,
//			      TOP_movf_d,
//			      TOP_movn_s,
//			      TOP_movn_d,
//			      TOP_movt_s,
//			      TOP_movt_d,
//			      TOP_movz_s,
//			      TOP_movz_d,
			      TOP_frsp,
			      TOP_fctiw,
			      TOP_fctiwz,
//			      TOP_cvt_d_l,
//			      TOP_cvt_l_s,
//			      TOP_cvt_l_d,
//			      TOP_cvt_s_d,
//			      TOP_cvt_s_w,
//			      TOP_cvt_s_l,
//			      TOP_cvt_w_s,
//			      TOP_cvt_w_d,
//			      TOP_ceil_w_s,
//			      TOP_ceil_w_d,
//			      TOP_ceil_l_s,
//			      TOP_ceil_l_d,
//			      TOP_floor_w_s,
//			      TOP_floor_w_d,
//			      TOP_floor_l_s,
//			      TOP_floor_l_d,
//			      TOP_round_w_s,
//			      TOP_round_w_d,
//			      TOP_round_l_s,
//			      TOP_round_l_d,
//			      TOP_trunc_w_s,
//			      TOP_trunc_w_d,
//			      TOP_trunc_l_s,
//			      TOP_trunc_l_d,
//			      TOP_bc1f,
//			      TOP_bc1t,
                           TOP_crand,
                           TOP_cror,
                           TOP_crxor,
                           TOP_crnand,
                           TOP_crnor,
                           TOP_creqv,
                           TOP_crandc,
                           TOP_crorc,
			      TOP_UNDEFINED);

  ISA_Bundle_Type_Create("i", ".i", 1);
  Slot (0, Fetch_Unit);

  ISA_Bundle_End();
  return 0;
}
