/*

  Copyright (C) 2006-2009 Tsinghua University.  All Rights Reserved.
  Copyright (C) 2000, 2001 Silicon Graphics, Inc.  All Rights Reserved.

  This program is free software; you can redistribute it and/or modify it
  under the terms of version 2 of the GNU General Public License as
  published by the Free Software Foundation.

  This program is distributed in the hope that it would be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

  Further, this software is distributed without any warranty that it is
  free of the rightful claim of any third person regarding infringement 
  or the like.  Any license provided herein, whether implied or 
  otherwise, applies only to this software file.  Patent licenses, if 
  any, provided herein do not apply to combinations of this program with 
  other software, or any other product whatsoever.  

  You should have received a copy of the GNU General Public License along
  with this program; if not, write the Free Software Foundation, Inc., 59
  Temple Place - Suite 330, Boston MA 02111-1307, USA.

  Contact information:  Silicon Graphics, Inc., 1600 Amphitheatre Pky,
  Mountain View, CA 94043, or:

  http://www.sgi.com

  For further information regarding this notice, see:

  http://oss.sgi.com/projects/GenInfo/NoticeExplan

*/


//
// Group TOPS with similar packing format together. 
/////////////////////////////////////////////////////////
// The instructions are listed by category. The different categories of
// instructions are:
//
//   1. ALU
//   2. Integer
//   3. Memory
//   4. Branch
//   5. Float
//
// Within each Pack_Type instructions are listed in the order as shown
// in the IA-64 instructions formats manual
/////////////////////////////////////

#include <stddef.h>
#include "topcode.h"
#include "isa_pack_gen.h"
 
main()
{
  ISA_Pack_Begin("MIPS", 32);

  ISA_PACK_TYPE p1 = ISA_Pack_Type_Create("p1");
  Result(0, 12, 4);
  Operand(0, 0, 16, 4);
  Operand(1, 0, 20, 4);
  Instruction_Pack_Group(p1,
			 TOP_lbz, 0x000000ff,
			 TOP_lbzu, 0x000000ff,
			 TOP_lhz, 0x000000ff,
			 TOP_lhzu, 0x000000ff,
			 TOP_lha, 0x000000ff,
			 TOP_lhau, 0x000000ff,
			 TOP_lwz, 0x000000ff,
			 TOP_lwzu, 0x000000ff,
//			 TOP_lwl, 0x000000ff,
//			 TOP_lwr, 0x000000ff,
			 TOP_stb, 0x000000ff,
			 TOP_stbu, 0x000000ff,
			 TOP_sth, 0x000000ff,
			 TOP_sthu, 0x000000ff,
			 TOP_stw, 0x000000ff,
			 TOP_stwu, 0x000000ff,			 
			 
       TOP_lbzx, 0x000000ff,
       TOP_lbzux, 0x000000ff,
       TOP_lhzx, 0x000000ff,
       TOP_lhzux, 0x000000ff,
       TOP_lhax, 0x000000ff,
       TOP_lhaux, 0x000000ff,
       TOP_lwzx, 0x000000ff,
       TOP_lwzux, 0x000000ff,
        	
       TOP_stbx, 0x000000ff,
       TOP_stbux, 0x000000ff,
       TOP_sthx, 0x000000ff,
       TOP_sthux, 0x000000ff,
       TOP_stwx, 0x000000ff,
       TOP_stwux, 0x000000ff,
			 
			 TOP_la, 0x000000ff,
			 TOP_li, 0x000000ff,
			 TOP_lis, 0x000000ff,
			 TOP_add, 0x000000ff,
			 TOP_addi, 0x000000ff,
       TOP_addis, 0x000000ff, 
			 TOP_add_, 0x000000ff,
			 TOP_addic, 0x000000ff,
//			 TOP_addiu, 0x000000ff,
//			 TOP_addu, 0x000000ff,
			 TOP_divw, 0x000000ff,
//			 TOP_divwxwxwxu, 0x000000ff,
			 TOP_mullw, 0x000000ff,
			 TOP_mulli, 0x000000ff,
             TOP_mullwo, 0x000000ff,
             TOP_mulhw, 0x000000ff,
             TOP_mulhwu, 0x000000ff,
             TOP_divwo, 0x000000ff,
             TOP_divwu, 0x000000ff,
             TOP_divwuo, 0x000000ff,      
//			 TOP_mullwu, 0x000000ff,
			 TOP_cmpw, 0x000000ff,
			 TOP_cmpwi, 0x000000ff,
			 TOP_cmplwi, 0x000000ff,
			 TOP_cmplw, 0x000000ff,
			 TOP_subf, 0x000000ff,
			 TOP_subfc, 0x000000ff,
			 TOP_subfe, 0x000000ff,
			 TOP_subfic, 0x000000ff,
			 TOP_addc, 0x000000ff,
				TOP_addco, 0x000000ff,
				TOP_adde, 0x000000ff,
				TOP_addeo, 0x000000ff,
				TOP_addme, 0x000000ff,
				TOP_addmeo, 0x000000ff,
				TOP_addze, 0x000000ff,
				TOP_addzeo, 0x000000ff,
				
				TOP_subfco, 0x000000ff,
				TOP_subfeo, 0x000000ff,
				TOP_subfme, 0x000000ff,
				TOP_subfmeo, 0x000000ff,
				TOP_subfze, 0x000000ff,
				TOP_subfzeo, 0x000000ff,
//			 TOP_subu, 0x000000ff,
//			 TOP_dadd, 0x000000ff,
//			 TOP_daddi, 0x000000ff,
//			 TOP_daddiu, 0x000000ff,
//			 TOP_daddu, 0x000000ff,
//			 TOP_ddiv, 0x000000ff,
//			 TOP_ddivu, 0x000000ff,
//			 TOP_dmult, 0x000000ff,
//			 TOP_dmultu, 0x000000ff,
//			 TOP_dsub, 0x000000ff,
//			 TOP_dsubu, 0x000000ff,
			 TOP_and, 0x000000ff,
			 TOP_andc, 0x000000ff,
			 TOP_nand, 0x000000ff,
			 TOP_andi_, 0x000000ff,
			 TOP_andis_, 0x000000ff,
			 TOP_neg, 0x000000ff,
			 TOP_mr, 0x000000ff,
			 TOP_not, 0x000000ff,
//			 TOP_lui, 0x000000ff,
			 TOP_nor, 0x000000ff,
			 TOP_or, 0x000000ff,
			 TOP_ori, 0x000000ff,
			 TOP_oris, 0x000000ff,
			 TOP_xor, 0x000000ff,
			 TOP_xori, 0x000000ff,
			 TOP_xoris, 0x000000ff,
			 TOP_eqv, 0x000000ff,
			 TOP_orc, 0x000000ff,
			 TOP_extsb, 0x000000ff,
			 TOP_extsh, 0x000000ff,
//			 TOP_mfhi, 0x000000ff,
//			 TOP_mflo, 0x000000ff,
//			 TOP_mthi, 0x000000ff,
//			 TOP_mtlo, 0x000000ff,			 
//			 TOP_movf, 0x000000ff,
//			 TOP_movn, 0x000000ff,
//			 TOP_movt, 0x000000ff,
//			 TOP_movz, 0x000000ff,
			 TOP_slwi, 0x000000ff,
			 TOP_slw, 0x000000ff,
			 TOP_srawi, 0x000000ff,
			 TOP_sraw, 0x000000ff,
			 TOP_srwi, 0x000000ff,
			 TOP_srw, 0x000000ff,
			 
			 TOP_rlwinm, 0x000000ff,
             TOP_rlwimi, 0x000000ff,
             TOP_rlwnm, 0x000000ff,
//			 TOP_dsll, 0x000000ff,
//			 TOP_dsll32, 0x000000ff,
//			 TOP_dsllv, 0x000000ff,
//			 TOP_dsra, 0x000000ff,
//			 TOP_dsra32, 0x000000ff,
//			 TOP_dsrav, 0x000000ff,
//			 TOP_dsrl, 0x000000ff,
//			 TOP_dsrl32, 0x000000ff,
//			 TOP_dsrlv, 0x000000ff,
			 // reletive branch
        	TOP_beq, 0x000000ff,  
        	TOP_bge, 0x000000ff,
        	TOP_bgt, 0x000000ff,
        	TOP_ble, 0x000000ff,
        	TOP_blt, 0x000000ff,
        	
        	TOP_bnl, 0x000000ff,
        	TOP_bne, 0x000000ff,
        	TOP_bng, 0x000000ff,
        	
        	TOP_bso, 0x000000ff,
        	TOP_bns, 0x000000ff,
        	TOP_bun, 0x000000ff,
        	TOP_bnu, 0x000000ff,
        	
        	// absoult branch
        	TOP_beqa, 0x000000ff,  
        	TOP_bgea, 0x000000ff,
        	TOP_bgta, 0x000000ff,
        	TOP_blea, 0x000000ff,
        	TOP_blta, 0x000000ff,
        	
        	TOP_bnla, 0x000000ff,
        	TOP_bnea, 0x000000ff,
        	TOP_bnga, 0x000000ff,
        	
        	TOP_bsoa, 0x000000ff,
        	TOP_bnsa, 0x000000ff,
        	TOP_buna, 0x000000ff,
        	TOP_bnua, 0x000000ff,
        	
        	// branch to lr
        	TOP_beqlr, 0x000000ff,  
        	TOP_bgelr, 0x000000ff,
        	TOP_bgtlr, 0x000000ff,
        	TOP_blelr, 0x000000ff,
        	TOP_bltlr, 0x000000ff,
        	
        	TOP_bnllr, 0x000000ff,
        	TOP_bnelr, 0x000000ff,
        	TOP_bnglr, 0x000000ff,
        	
        	TOP_bsolr, 0x000000ff,
        	TOP_bnslr, 0x000000ff,
        	TOP_bunlr, 0x000000ff,
        	TOP_bnulr, 0x000000ff,
        	
        	// branch to ctr
        	TOP_beqctr, 0x000000ff,  
        	TOP_bgectr, 0x000000ff,
        	TOP_bgtctr, 0x000000ff,
        	TOP_blectr, 0x000000ff,
        	TOP_bltctr, 0x000000ff,
        	
        	TOP_bnlctr, 0x000000ff,
        	TOP_bnectr, 0x000000ff,
        	TOP_bngctr, 0x000000ff,
        	
        	TOP_bsoctr, 0x000000ff,
        	TOP_bnsctr, 0x000000ff,
        	TOP_bunctr, 0x000000ff,
        	TOP_bnuctr, 0x000000ff,
        	
        	// with lr update
        	// reletive branch
        	TOP_beql, 0x000000ff,  
        	TOP_bgel, 0x000000ff,
        	TOP_bgtl, 0x000000ff,
        	TOP_blel, 0x000000ff,
        	TOP_bltl, 0x000000ff,
        	
        	TOP_bnll, 0x000000ff,
        	TOP_bnel, 0x000000ff,
        	TOP_bngl, 0x000000ff,
        	
        	TOP_bsol, 0x000000ff,
        	TOP_bnsl, 0x000000ff,
        	TOP_bunl, 0x000000ff,
        	TOP_bnul, 0x000000ff,
        	
        	// absoult branch
        	TOP_beqla, 0x000000ff,  
        	TOP_bgela, 0x000000ff,
        	TOP_bgtla, 0x000000ff,
        	TOP_blela, 0x000000ff,
        	TOP_bltla, 0x000000ff,
        	
        	TOP_bnlla, 0x000000ff,
        	TOP_bnela, 0x000000ff,
        	TOP_bngla, 0x000000ff,
        	
        	TOP_bsola, 0x000000ff,
        	TOP_bnsla, 0x000000ff,
        	TOP_bunla, 0x000000ff,
        	TOP_bnula, 0x000000ff,
        	
        	// branch to lr
        	TOP_beqlrl, 0x000000ff,  
        	TOP_bgelrl, 0x000000ff,
        	TOP_bgtlrl, 0x000000ff,
        	TOP_blelrl, 0x000000ff,
        	TOP_bltlrl, 0x000000ff,
        	
        	TOP_bnllrl, 0x000000ff,
        	TOP_bnelrl, 0x000000ff,
        	TOP_bnglrl, 0x000000ff,
        	
        	TOP_bsolrl, 0x000000ff,
        	TOP_bnslrl, 0x000000ff,
        	TOP_bunlrl, 0x000000ff,
        	TOP_bnulrl, 0x000000ff,
        	
        	// branch to ctr
        	TOP_beqctrl, 0x000000ff,  
        	TOP_bgectrl, 0x000000ff,
        	TOP_bgtctrl, 0x000000ff,
        	TOP_blectrl, 0x000000ff,
        	TOP_bltctrl, 0x000000ff,
        	
        	TOP_bnlctrl, 0x000000ff,
        	TOP_bnectrl, 0x000000ff,
        	TOP_bngctrl, 0x000000ff,
        	
        	TOP_bsoctrl, 0x000000ff,
        	TOP_bnsctrl, 0x000000ff,
        	TOP_bunctrl, 0x000000ff,
        	TOP_bnuctrl, 0x000000ff,
        	
			 TOP_ba, 0x000000ff,
			 TOP_bla, 0x000000ff,
			 TOP_b, 0x000000ff,
			 TOP_bl, 0x000000ff,
			 TOP_blrl, 0x000000ff,
			 TOP_bctrl, 0x000000ff,			 
			 TOP_blr, 0x000000ff,
			 TOP_bctr, 0x000000ff,
//			 TOP_break, 0x000000ff,
			 TOP_sc, 0x000000ff,
			 TOP_tweq, 0x000000ff,
			 TOP_tweqi, 0x000000ff,
			 TOP_twge, 0x000000ff,
			 TOP_twgei, 0x000000ff,
//			 TOP_tgeiu, 0x000000ff,
//			 TOP_tgeu, 0x000000ff,
			 TOP_twlt, 0x000000ff,
			 TOP_twlti, 0x000000ff,
//			 TOP_tltiu, 0x000000ff,
//			 TOP_tltu, 0x000000ff,
			 TOP_twne, 0x000000ff,
			 TOP_twnei, 0x000000ff,
			 TOP_lfs, 0x000000ff,
//	     TOP_lfsu, 0x000000ff,
//	     TOP_lfsux, 0x000000ff,
	     TOP_lfsx, 0x000000ff,
	     TOP_lfd, 0x000000ff,
//	     TOP_lfdu, 0x000000ff,
//	     TOP_lfdux, 0x000000ff,
	     TOP_lfdx, 0x000000ff,
	     TOP_stfs, 0x000000ff,
//	     TOP_stfsu, 0x000000ff,
//	     TOP_stfsux, 0x000000ff,
	     TOP_stfsx, 0x000000ff,
	     TOP_stfd, 0x000000ff,
//	     TOP_stfdu, 0x000000ff,
//	     TOP_stfdux, 0x000000ff,
	     TOP_stfdx, 0x000000ff,
//			 TOP_lwc1, 0x000000ff,
//			 TOP_ldc1, 0x000000ff,
//			 TOP_lwxc1, 0x000000ff,
//			 TOP_ldxc1, 0x000000ff,
//			 TOP_swc1, 0x000000ff,
//			 TOP_sdc1, 0x000000ff,
//			 TOP_swxc1, 0x000000ff,
//			 TOP_sdxc1, 0x000000ff,
//			 TOP_abs_s, 0x000000ff,
			 TOP_fabs, 0x000000ff,
			 TOP_fnabs, 0x000000ff,
//			 TOP_add_s, 0x000000ff,
       TOP_fadds, 0x000000ff,
			 TOP_fadd, 0x000000ff,
//			 TOP_c_f_s, 0x000000ff,
//			 TOP_c_f_d, 0x000000ff,
//			 TOP_c_t_s, 0x000000ff,
//			 TOP_c_t_d, 0x000000ff,
//			 TOP_c_un_s, 0x000000ff,
//			 TOP_c_un_d, 0x000000ff,
//			 TOP_c_or_s, 0x000000ff,
//			 TOP_c_or_d, 0x000000ff,
//			 TOP_c_eq_s, 0x000000ff,
//			 TOP_c_eq_d, 0x000000ff,
//			 TOP_c_neq_s, 0x000000ff,
//			 TOP_c_neq_d, 0x000000ff,
//			 TOP_c_ueq_s, 0x000000ff,
//			 TOP_c_ueq_d, 0x000000ff,
//			 TOP_c_olg_s, 0x000000ff,
//			 TOP_c_olg_d, 0x000000ff,
//			 TOP_c_olt_s, 0x000000ff,
//			 TOP_c_olt_d, 0x000000ff,
//			 TOP_c_uge_s, 0x000000ff,
//			 TOP_c_uge_d, 0x000000ff,
//			 TOP_c_ult_s, 0x000000ff,
//			 TOP_c_ult_d, 0x000000ff,
//			 TOP_c_oge_s, 0x000000ff,
//			 TOP_c_oge_d, 0x000000ff,
//			 TOP_c_ole_s, 0x000000ff,
//			 TOP_c_ole_d, 0x000000ff,
//			 TOP_c_ugt_s, 0x000000ff,
//			 TOP_c_ugt_d, 0x000000ff,
//			 TOP_c_ule_s, 0x000000ff,
//			 TOP_c_ule_d, 0x000000ff,
//			 TOP_c_ogt_s, 0x000000ff,
//			 TOP_c_ogt_d, 0x000000ff,
//			 TOP_c_sf_s, 0x000000ff,
//			 TOP_c_sf_d, 0x000000ff,
//			 TOP_c_st_s, 0x000000ff,
//			 TOP_c_st_d, 0x000000ff,
//			 TOP_c_ngle_s, 0x000000ff,
//			 TOP_c_ngle_d, 0x000000ff,
//			 TOP_c_gle_s, 0x000000ff,
//			 TOP_c_gle_d, 0x000000ff,
//			 TOP_c_seq_s, 0x000000ff,
//			 TOP_c_seq_d, 0x000000ff,
//			 TOP_c_sne_s, 0x000000ff,
//			 TOP_c_sne_d, 0x000000ff,
//			 TOP_c_ngl_s, 0x000000ff,
//			 TOP_c_ngl_d, 0x000000ff,
//			 TOP_c_gl_s, 0x000000ff,
//			 TOP_c_gl_d, 0x000000ff,
//			 TOP_c_lt_s, 0x000000ff,
//			 TOP_c_lt_d, 0x000000ff,
//			 TOP_c_nlt_s, 0x000000ff,
//			 TOP_c_nlt_d, 0x000000ff,
//			 TOP_c_nge_s, 0x000000ff,
//			 TOP_c_nge_d, 0x000000ff,
//			 TOP_c_ge_s, 0x000000ff,
//			 TOP_c_ge_d, 0x000000ff,
//			 TOP_c_le_s, 0x000000ff,
//			 TOP_c_le_d, 0x000000ff,
//			 TOP_c_nle_s, 0x000000ff,
//			 TOP_c_nle_d, 0x000000ff,
//			 TOP_c_ngt_s, 0x000000ff,
//			 TOP_c_ngt_d, 0x000000ff,
//			 TOP_c_gt_s, 0x000000ff,
//			 TOP_c_gt_d, 0x000000ff,
//			 TOP_divwxwxwx_s, 0x000000ff,
       TOP_fdivs, 0x000000ff,
			 TOP_fdiv, 0x000000ff,
//			 TOP_mul_s, 0x000000ff,
       TOP_fmuls, 0x000000ff,
			 TOP_fmul, 0x000000ff,
//			 TOP_neg_s, 0x000000ff,
			 TOP_fneg, 0x000000ff,
//			 TOP_sub_s, 0x000000ff,
       TOP_fsubs, 0x000000ff,
			 TOP_fsub, 0x000000ff,
			 TOP_fmadds, 0x000000ff,
			 TOP_fmadd, 0x000000ff,
			 TOP_fmsubs, 0x000000ff,
			 TOP_fmsub, 0x000000ff,
			 TOP_fnmadds, 0x000000ff,
			 TOP_fnmadd, 0x000000ff,
			 TOP_fnmsubs, 0x000000ff,
			 TOP_fnmsub, 0x000000ff,
			 TOP_fres, 0x000000ff,
//			 TOP_recip_d, 0x000000ff,
			 TOP_fsqrts, 0x000000ff,
			 TOP_fsqrt, 0x000000ff,
			 TOP_frsqrte, 0x000000ff,
			 TOP_fcmpu, 0x000000ff,
		   TOP_fcmpo, 0x000000ff,
		   TOP_fsel, 0x000000ff,
			 TOP_mcrfs, 0x000000ff,
			 TOP_mtfsf, 0x000000ff,
			 TOP_mffs, 0x000000ff,
			 TOP_mflr, 0x000000ff,//			  TOP_mfc1,
			 TOP_mtlr, 0x000000ff,//			  TOP_dmfc1,//			 TOP_mfc1, 
			 TOP_mfctr, 0x000000ff,//			  TOP_mfc1,
			 TOP_mtctr, 0x000000ff,//			  TOP_dmfc1,//			 TOP_mfc1, 
				TOP_mtfsb0, 0x000000ff,
				TOP_mtfsb1, 0x000000ff,
//			 TOP_mtc1, 0x000000ff,
//			 TOP_dmfc1, 0x000000ff,
//			 TOP_dmtc1, 0x000000ff,
//			 TOP_mov_s, 0x000000ff,
			 TOP_fmr, 0x000000ff,
			 TOP_mfcr, 0x000000ff,			 
			 TOP_mcrf, 0x000000ff,
//			 TOP_movf_s, 0x000000ff,
//			 TOP_movf_d, 0x000000ff,
//			 TOP_movn_s, 0x000000ff,
//			 TOP_movn_d, 0x000000ff,
//			 TOP_movt_s, 0x000000ff,
//			 TOP_movt_d, 0x000000ff,
//			 TOP_movz_s, 0x000000ff,
//			 TOP_movz_d, 0x000000ff,
			 TOP_frsp, 0x000000ff,
			 TOP_fctiw, 0x000000ff,
			 TOP_fctiwz, 0x000000ff,
//			 TOP_cvt_d_l, 0x000000ff,
//			 TOP_cvt_l_s, 0x000000ff,
//			 TOP_cvt_l_d, 0x000000ff,
//			 TOP_cvt_s_d, 0x000000ff,
//			 TOP_cvt_s_w, 0x000000ff,
//			 TOP_cvt_s_l, 0x000000ff,
//			 TOP_cvt_w_s, 0x000000ff,
//			 TOP_cvt_w_d, 0x000000ff,
//			 TOP_ceil_w_s, 0x000000ff,
//			 TOP_ceil_w_d, 0x000000ff,
//			 TOP_ceil_l_s, 0x000000ff,
//			 TOP_ceil_l_d, 0x000000ff,
//			 TOP_floor_w_s, 0x000000ff,
//			 TOP_floor_w_d, 0x000000ff,
//			 TOP_floor_l_s, 0x000000ff,
//			 TOP_floor_l_d, 0x000000ff,
//			 TOP_round_w_s, 0x000000ff,
//			 TOP_round_w_d, 0x000000ff,
//			 TOP_round_l_s, 0x000000ff,
//			 TOP_round_l_d, 0x000000ff,
//			 TOP_trunc_w_s, 0x000000ff,
//			 TOP_trunc_w_d, 0x000000ff,
//			 TOP_trunc_l_s, 0x000000ff,
//			 TOP_trunc_l_d, 0x000000ff,
//			 TOP_bc1f, 0x000000ff,
//			 TOP_bc1t, 0x000000ff,
			 TOP_nop, 0x000000ff,             
//             TOP_asm,   0x000000ff,
//             TOP_intrncall,   0x000000ff,
//             TOP_spadjust,   0x000000ff,
             TOP_begin_pregtn,   0x000000ff,
             TOP_end_pregtn,   0x000000ff,
             TOP_bwd_bar,   0x000000ff,
             TOP_fwd_bar,   0x000000ff,
             TOP_label,   0x000000ff,
             TOP_noop,   0x000000ff,
             TOP_crand, 0x000000ff,
                           TOP_cror, 0x000000ff,
                           TOP_crxor, 0x000000ff,
                           TOP_crnand, 0x000000ff,
                           TOP_crnor, 0x000000ff,
                           TOP_creqv, 0x000000ff,
                           TOP_crandc, 0x000000ff,
                           TOP_crorc, 0x000000ff,
			 TOP_UNDEFINED);

  ISA_Pack_End();
}
