/*
 * Copyright (C) 2008-2010 Advanced Micro Devices, Inc.  All Rights Reserved.
 */

/*
 *  Copyright (C) 2007, 2008 PathScale, LLC.  All Rights Reserved.
 */

/*
 *  Copyright (C) 2007 QLogic Corporation.  All Rights Reserved.
 */

/*
 * Copyright 2003, 2004, 2005, 2006 PathScale, Inc.  All Rights Reserved.
 */

/*

  Copyright (C) 2000, 2001 Silicon Graphics, Inc.  All Rights Reserved.

  This program is free software; you can redistribute it and/or modify it
  under the terms of version 2 of the GNU General Public License as
  published by the Free Software Foundation.

  This program is distributed in the hope that it would be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

  Further, this software is distributed without any warranty that it is
  free of the rightful claim of any third person regarding infringement 
  or the like.  Any license provided herein, whether implied or 
  otherwise, applies only to this software file.  Patent licenses, if 
  any, provided herein do not apply to combinations of this program with 
  other software, or any other product whatsoever.  

  You should have received a copy of the GNU General Public License along
  with this program; if not, write the Free Software Foundation, Inc., 59
  Temple Place - Suite 330, Boston MA 02111-1307, USA.

  Contact information:  Silicon Graphics, Inc., 1600 Amphitheatre Pky,
  Mountain View, CA 94043, or:

  http://www.sgi.com

  For further information regarding this notice, see:

  http://oss.sgi.com/projects/GenInfo/NoticeExplan

*/


//
// Group TOPS with similar packing format together. 
/////////////////////////////////////////////////////////
// The instructions are listed by category. The different categories of
// instructions are:
//
//   1. ALU
//   2. Integer
//   3. Memory
//   4. Branch
//   5. Float
//
// Within each Pack_Type instructions are listed in the order as shown
// in the IA-64 instructions formats manual
/////////////////////////////////////

#include <stddef.h>
#include "topcode.h"
#include "isa_pack_gen.h"
 
int main()
{
  ISA_Pack_Begin("x8664", 32);

  ISA_PACK_TYPE p1 = ISA_Pack_Type_Create("p1");
  Result(0, 12, 4);
  Operand(0, 0, 16, 4);
  Operand(1, 0, 20, 4);
  Instruction_Pack_Group(p1,
			 TOP_addxxx32,	0x000000ff,
			 TOP_addxxx64,	0x000000ff,
			 TOP_subxxx32,	0x000000ff,
			 TOP_subxxx64,	0x000000ff,
			 TOP_xorxxx8,	0x000000ff,
			 TOP_xorxxx16,	0x000000ff,
			 TOP_xorxxx32,	0x000000ff,
			 TOP_xorxxx64,	0x000000ff,
			 TOP_orxxx8,	0x000000ff,
			 TOP_orxxx16,	0x000000ff,
			 TOP_orxxx32,	0x000000ff,
			 TOP_orxxx64,	0x000000ff,
			 TOP_andxxx8,	0x000000ff,
			 TOP_andxxx16,	0x000000ff,
			 TOP_andxxx32,	0x000000ff,
			 TOP_andxxx64,	0x000000ff,
			 TOP_divxxxss,	0x000000ff,
			 TOP_divxxxsd,	0x000000ff,
			 TOP_addxxxss,	0x000000ff,
			 TOP_addxxxsd,	0x000000ff,
			 TOP_subxxxss,	0x000000ff,
			 TOP_subxxxsd,	0x000000ff,
			 TOP_mulxxxsd,	0x000000ff,
			 TOP_mulxxxss,	0x000000ff,
			 TOP_cmpxxx8,	0x000000ff,
			 TOP_cmpi8,	0x000000ff,
			 TOP_cmpxi8,	0x000000ff,
			 TOP_cmpxxi8,	0x000000ff,
			 TOP_cmpxxxi8,	0x000000ff,
			 TOP_cmpi16,	0x000000ff,
			 TOP_cmpxi16,	0x000000ff,
			 TOP_cmpxxi16,	0x000000ff,
			 TOP_cmpxxxi16,	0x000000ff,
			 TOP_cmpxi32,	0x000000ff,
			 TOP_cmpxxi32,	0x000000ff,
			 TOP_cmpxxxi32,	0x000000ff,
			 TOP_cmpxi64,	0x000000ff,
			 TOP_cmpxxi64,	0x000000ff,
			 TOP_cmpxxxi64,	0x000000ff,
			 TOP_cmpxr8,	0x000000ff,
			 TOP_cmpxxr8,	0x000000ff,
			 TOP_cmpxxxr8,	0x000000ff,
			 TOP_cmpxr16,	0x000000ff,
			 TOP_cmpxxr16,	0x000000ff,
			 TOP_cmpxxxr16,	0x000000ff,
			 TOP_cmpxr32,	0x000000ff,
			 TOP_cmpxxr32,	0x000000ff,
			 TOP_cmpxxxr32,	0x000000ff,
			 TOP_cmpxr64,	0x000000ff,
			 TOP_cmpxxr64,	0x000000ff,
			 TOP_cmpxxxr64,	0x000000ff,
			 TOP_cmpxxx16,	0x000000ff,
			 TOP_cmpxxx32,	0x000000ff,
			 TOP_cmpxxx64,	0x000000ff,
			 TOP_testxxx8,  0x000000ff,
			 TOP_testxxx16, 0x000000ff,
			 TOP_testxxx32,	0x000000ff,
			 TOP_testxxx64,	0x000000ff,
		    TOP_nop,	0x000000ff,
		    TOP_andnps,	0x000000ff,
		    TOP_andnpd,	0x000000ff,
		    TOP_cmpss,	0x000000ff,
		    TOP_cmpsd,	0x000000ff,
		    TOP_cmpps,	0x000000ff,
		    TOP_cmppd,	0x000000ff,
		    TOP_add8,	0x000000ff,
		    TOP_add16,	0x000000ff,
		    TOP_add32,	0x000000ff,
		    TOP_adc32,	0x000000ff,
		    TOP_add64,	0x000000ff,
		    TOP_addx32,	0x000000ff,
		    TOP_addx64,	0x000000ff,
		    TOP_addxx32,0x000000ff,
		    TOP_addxx64,0x000000ff,
		    TOP_addxr8,	0x000000ff,
		    TOP_addxxr8,	0x000000ff,
		    TOP_addxxxr8,	0x000000ff,
		    TOP_addxr8_n32,	0x000000ff,
		    TOP_addxr16,	0x000000ff,
		    TOP_addxxr16,	0x000000ff,
		    TOP_addxxxr16,	0x000000ff,
		    TOP_addxr16_n32,	0x000000ff,
		    TOP_addxr32,	0x000000ff,
		    TOP_addxxr32,	0x000000ff,
		    TOP_addxxxr32,	0x000000ff,
		    TOP_addxr32_n32,	0x000000ff,
		    TOP_addxr64,	0x000000ff,
		    TOP_addxxr64,	0x000000ff,
		    TOP_addxxxr64,	0x000000ff,
		    TOP_addxr64_off,	0x000000ff,
		    TOP_addixr8,	0x000000ff,
		    TOP_addixxr8,	0x000000ff,
		    TOP_addixxxr8,	0x000000ff,
		    TOP_addixr8_n32,	0x000000ff,
		    TOP_addixr16,	0x000000ff,
		    TOP_addixxr16,	0x000000ff,
		    TOP_addixxxr16,	0x000000ff,
		    TOP_addixr16_n32,	0x000000ff,
		    TOP_addixr32,	0x000000ff,
		    TOP_addixxr32,	0x000000ff,
		    TOP_addixxxr32,	0x000000ff,
		    TOP_addixr32_n32,	0x000000ff,
		    TOP_addixr64,	0x000000ff,
		    TOP_addixxr64,	0x000000ff,
		    TOP_addixxxr64,	0x000000ff,
		    TOP_addixr64_off,	0x000000ff,
		    TOP_andxr8,	0x000000ff,
		    TOP_andxxr8,	0x000000ff,
		    TOP_andxxxr8,	0x000000ff,
		    TOP_andxr8_n32,	0x000000ff,
		    TOP_andxr16,	0x000000ff,
		    TOP_andxxr16,	0x000000ff,
		    TOP_andxxxr16,	0x000000ff,
		    TOP_andxr16_n32,	0x000000ff,
		    TOP_andxr32,	0x000000ff,
		    TOP_andxxr32,	0x000000ff,
		    TOP_andxxxr32,	0x000000ff,
		    TOP_andxr32_n32,	0x000000ff,
		    TOP_andxr64,	0x000000ff,
		    TOP_andxxr64,	0x000000ff,
		    TOP_andxxxr64,	0x000000ff,
		    TOP_andxr64_off,	0x000000ff,
		    TOP_andixr8,	0x000000ff,
		    TOP_andixxr8,	0x000000ff,
		    TOP_andixxxr8,	0x000000ff,
		    TOP_andixr8_n32,	0x000000ff,
		    TOP_andixr16,	0x000000ff,
		    TOP_andixxr16,	0x000000ff,
		    TOP_andixxxr16,	0x000000ff,
		    TOP_andixr16_n32,	0x000000ff,
		    TOP_andixr32,	0x000000ff,
		    TOP_andixxr32,	0x000000ff,
		    TOP_andixxxr32,	0x000000ff,
		    TOP_andixr32_n32,	0x000000ff,
		    TOP_andixr64,	0x000000ff,
		    TOP_andixxr64,	0x000000ff,
		    TOP_andixxxr64,	0x000000ff,
		    TOP_andixr64_off,	0x000000ff,
		    TOP_orxr8,	0x000000ff,
		    TOP_orxxr8,	0x000000ff,
		    TOP_orxxxr8,	0x000000ff,
		    TOP_orxr8_n32,	0x000000ff,
		    TOP_orxr16,	0x000000ff,
		    TOP_orxxr16,	0x000000ff,
		    TOP_orxxxr16,	0x000000ff,
		    TOP_orxr16_n32,	0x000000ff,
		    TOP_orxr32,	0x000000ff,
		    TOP_orxxr32,	0x000000ff,
		    TOP_orxxxr32,	0x000000ff,
		    TOP_orxr32_n32,	0x000000ff,
		    TOP_orxr64,	0x000000ff,
		    TOP_orxxr64,	0x000000ff,
		    TOP_orxxxr64,	0x000000ff,
		    TOP_orxr64_off,	0x000000ff,
		    TOP_orixr8,	0x000000ff,
		    TOP_orixxr8,	0x000000ff,
		    TOP_orixxxr8,	0x000000ff,
		    TOP_orixr8_n32,	0x000000ff,
		    TOP_orixr16,	0x000000ff,
		    TOP_orixxr16,	0x000000ff,
		    TOP_orixxxr16,	0x000000ff,
		    TOP_orixr16_n32,	0x000000ff,
		    TOP_orixr32,	0x000000ff,
		    TOP_orixxr32,	0x000000ff,
		    TOP_orixxxr32,	0x000000ff,
		    TOP_orixr32_n32,	0x000000ff,
		    TOP_orixr64,	0x000000ff,
		    TOP_orixxr64,	0x000000ff,
		    TOP_orixxxr64,	0x000000ff,
		    TOP_orixr64_off,	0x000000ff,
		    TOP_subxr8,	0x000000ff,
		    TOP_subxxr8,	0x000000ff,
		    TOP_subxxxr8,	0x000000ff,
		    TOP_subxr8_n32,	0x000000ff,
		    TOP_subxr16,	0x000000ff,
		    TOP_subxxr16,	0x000000ff,
		    TOP_subxxxr16,	0x000000ff,
		    TOP_subxr16_n32,	0x000000ff,
		    TOP_subxr32,	0x000000ff,
		    TOP_subxxr32,	0x000000ff,
		    TOP_subxxxr32,	0x000000ff,
		    TOP_subxr32_n32,	0x000000ff,
		    TOP_subxr64,	0x000000ff,
		    TOP_subxxr64,	0x000000ff,
		    TOP_subxxxr64,	0x000000ff,
		    TOP_subxr64_off,	0x000000ff,
		    TOP_subixr8,	0x000000ff,
		    TOP_subixxr8,	0x000000ff,
		    TOP_subixxxr8,	0x000000ff,
		    TOP_subixr8_n32,	0x000000ff,
		    TOP_subixr16,	0x000000ff,
		    TOP_subixxr16,	0x000000ff,
		    TOP_subixxxr16,	0x000000ff,
		    TOP_subixr16_n32,	0x000000ff,
		    TOP_subixr32,	0x000000ff,
		    TOP_subixxr32,	0x000000ff,
		    TOP_subixxxr32,	0x000000ff,
		    TOP_subixr32_n32,	0x000000ff,
		    TOP_subixr64,	0x000000ff,
		    TOP_subixxr64,	0x000000ff,
		    TOP_subixxxr64,	0x000000ff,
		    TOP_subixr64_off,	0x000000ff,
		    TOP_xorxr8,	0x000000ff,
		    TOP_xorxxr8,	0x000000ff,
		    TOP_xorxxxr8,	0x000000ff,
		    TOP_xorxr8_n32,	0x000000ff,
		    TOP_xorxr16,	0x000000ff,
		    TOP_xorxxr16,	0x000000ff,
		    TOP_xorxxxr16,	0x000000ff,
		    TOP_xorxr16_n32,	0x000000ff,
		    TOP_xorxr32,	0x000000ff,
		    TOP_xorxxr32,	0x000000ff,
		    TOP_xorxxxr32,	0x000000ff,
		    TOP_xorxr32_n32,	0x000000ff,
		    TOP_xorxr64,	0x000000ff,
		    TOP_xorxxr64,	0x000000ff,
		    TOP_xorxxxr64,	0x000000ff,
		    TOP_xorxr64_off,	0x000000ff,
		    TOP_xorixr8,	0x000000ff,
		    TOP_xorixxr8,	0x000000ff,
		    TOP_xorixxxr8,	0x000000ff,
		    TOP_xorixr8_n32,	0x000000ff,
		    TOP_xorixr16,	0x000000ff,
		    TOP_xorixxr16,	0x000000ff,
		    TOP_xorixxxr16,	0x000000ff,
		    TOP_xorixr16_n32,	0x000000ff,
		    TOP_xorixr32,	0x000000ff,
		    TOP_xorixxr32,	0x000000ff,
		    TOP_xorixxxr32,	0x000000ff,
		    TOP_xorixr32_n32,	0x000000ff,
		    TOP_xorixr64,	0x000000ff,
		    TOP_xorixxr64,	0x000000ff,
		    TOP_xorixxxr64,	0x000000ff,
		    TOP_xorixr64_off,	0x000000ff,
		    TOP_addi8,	0x000000ff,
		    TOP_addi16,	0x000000ff,
		    TOP_addi32,	0x000000ff,
		    TOP_adci32,	0x000000ff,
		    TOP_addi64,	0x000000ff,
		    TOP_inc8,   0x000000ff,
		    TOP_inc16,  0x000000ff,
		    TOP_inc32,  0x000000ff,
		    TOP_inc64,  0x000000ff,
		    TOP_incxr8,	0x000000ff,
		    TOP_incxxr8,	0x000000ff,
		    TOP_incxxxr8,	0x000000ff,
		    TOP_incxr8_n32,	0x000000ff,
		    TOP_incxr16,	0x000000ff,
		    TOP_incxxr16,	0x000000ff,
		    TOP_incxxxr16,	0x000000ff,
		    TOP_incxr16_n32,	0x000000ff,
		    TOP_incxr32,	0x000000ff,
		    TOP_incxxr32,	0x000000ff,
		    TOP_incxxxr32,	0x000000ff,
		    TOP_incxr32_n32,	0x000000ff,
		    TOP_incxr64,	0x000000ff,
		    TOP_incxxr64,	0x000000ff,
		    TOP_incxxxr64,	0x000000ff,
		    TOP_incxr64_off,	0x000000ff,
		    TOP_dec8,   0x000000ff,
		    TOP_dec16,  0x000000ff,
		    TOP_dec32,  0x000000ff,
		    TOP_dec64,  0x000000ff,
		    TOP_decxr8,	0x000000ff,
		    TOP_decxxr8,	0x000000ff,
		    TOP_decxxxr8,	0x000000ff,
		    TOP_decxr8_n32,	0x000000ff,
		    TOP_decxr16,	0x000000ff,
		    TOP_decxxr16,	0x000000ff,
		    TOP_decxxxr16,	0x000000ff,
		    TOP_decxr16_n32,	0x000000ff,
		    TOP_decxr32,	0x000000ff,
		    TOP_decxxr32,	0x000000ff,
		    TOP_decxxxr32,	0x000000ff,
		    TOP_decxr32_n32,	0x000000ff,
		    TOP_decxr64,	0x000000ff,
		    TOP_decxxr64,	0x000000ff,
		    TOP_decxxxr64,	0x000000ff,
		    TOP_decxr64_off,	0x000000ff,
		    TOP_zero32,   0x000000ff,
		    TOP_zero64,   0x000000ff,
		    TOP_xzero32,   0x000000ff,
		    TOP_xzero64,   0x000000ff,
		    TOP_xzero128v32,   0x000000ff,
		    TOP_xzero128v64,   0x000000ff,
		    TOP_mul128v16,	0x000000ff,
		    TOP_add128v8,	0x000000ff,
		    TOP_addx128v8,	0x000000ff,
		    TOP_addxx128v8,	0x000000ff,
		    TOP_addxxx128v8,	0x000000ff,
		    TOP_add128v16,	0x000000ff,
		    TOP_addx128v16,	0x000000ff,
		    TOP_addxx128v16,	0x000000ff,
		    TOP_addxxx128v16,	0x000000ff,
		    TOP_add128v32,	0x000000ff,
		    TOP_addx128v32,	0x000000ff,
		    TOP_addxx128v32,	0x000000ff,
		    TOP_addxxx128v32,	0x000000ff,
		    TOP_add128v64,	0x000000ff,
		    TOP_addx128v64,	0x000000ff,
		    TOP_addxx128v64,	0x000000ff,
		    TOP_addxxx128v64,	0x000000ff,
		    TOP_fadd128v32,	0x000000ff,
		    TOP_faddx128v32,	0x000000ff,
		    TOP_faddxx128v32,	0x000000ff,
		    TOP_faddxxx128v32,	0x000000ff,
		    TOP_fadd128v64,	0x000000ff,
		    TOP_faddx128v64,	0x000000ff,
		    TOP_faddxx128v64,	0x000000ff,
		    TOP_faddxxx128v64,	0x000000ff,
		    TOP_faddsub128v32,	0x000000ff,
		    TOP_faddsubx128v32,	0x000000ff,
		    TOP_faddsubxx128v32,	0x000000ff,
		    TOP_faddsubxxx128v32,	0x000000ff,
		    TOP_faddsub128v64,	0x000000ff,
		    TOP_faddsubx128v64,	0x000000ff,
		    TOP_faddsubxx128v64,	0x000000ff,
		    TOP_faddsubxxx128v64,	0x000000ff,
		    TOP_fhadd128v32,	0x000000ff,
		    TOP_fhaddx128v32,	0x000000ff,
		    TOP_fhaddxx128v32,	0x000000ff,
		    TOP_fhaddxxx128v32,	0x000000ff,
		    TOP_fhadd128v64,	0x000000ff,
		    TOP_fhaddx128v64,	0x000000ff,
		    TOP_fhaddxx128v64,	0x000000ff,
		    TOP_fhaddxxx128v64,	0x000000ff,
		    TOP_and128v8,	0x000000ff,
		    TOP_andx128v8,	0x000000ff,
		    TOP_andxx128v8,	0x000000ff,
		    TOP_andxxx128v8,	0x000000ff,
		    TOP_and128v16,	0x000000ff,
		    TOP_andx128v16,	0x000000ff,
		    TOP_andxx128v16,	0x000000ff,
		    TOP_andxxx128v16,	0x000000ff,
		    TOP_and128v32,	0x000000ff,
		    TOP_andx128v32,	0x000000ff,
		    TOP_andxx128v32,	0x000000ff,
		    TOP_andxxx128v32,	0x000000ff,
		    TOP_and128v64,	0x000000ff,
		    TOP_andx128v64,	0x000000ff,
		    TOP_andxx128v64,	0x000000ff,
		    TOP_andxxx128v64,	0x000000ff,
		    TOP_fand128v32,	0x000000ff,
		    TOP_fandx128v32,	0x000000ff,
		    TOP_fandxx128v32,	0x000000ff,
		    TOP_fandxxx128v32,	0x000000ff,
		    TOP_fand128v64,	0x000000ff,
		    TOP_fandx128v64,	0x000000ff,
		    TOP_fandxx128v64,	0x000000ff,
		    TOP_fandxxx128v64,	0x000000ff,
		    TOP_or128v8,	0x000000ff,
		    TOP_orx128v8,	0x000000ff,
		    TOP_orxx128v8,	0x000000ff,
		    TOP_orxxx128v8,	0x000000ff,
		    TOP_or128v16,	0x000000ff,
		    TOP_orx128v16,	0x000000ff,
		    TOP_orxx128v16,	0x000000ff,
		    TOP_orxxx128v16,	0x000000ff,
		    TOP_or128v32,	0x000000ff,
		    TOP_orx128v32,	0x000000ff,
		    TOP_orxx128v32,	0x000000ff,
		    TOP_orxxx128v32,	0x000000ff,
		    TOP_or128v64,	0x000000ff,
		    TOP_orx128v64,	0x000000ff,
		    TOP_orxx128v64,	0x000000ff,
		    TOP_orxxx128v64,	0x000000ff,
		    TOP_for128v32,	0x000000ff,
		    TOP_forx128v32,	0x000000ff,
		    TOP_forxx128v32,	0x000000ff,
		    TOP_forxxx128v32,	0x000000ff,
		    TOP_for128v64,	0x000000ff,
		    TOP_forx128v64,	0x000000ff,
		    TOP_forxx128v64,	0x000000ff,
		    TOP_forxxx128v64,	0x000000ff,
		    TOP_xor128v8,	0x000000ff,
		    TOP_xorx128v8,	0x000000ff,
		    TOP_xorxx128v8,	0x000000ff,
		    TOP_xorxxx128v8,	0x000000ff,
		    TOP_xor128v16,	0x000000ff,
		    TOP_xorx128v16,	0x000000ff,
		    TOP_xorxx128v16,	0x000000ff,
		    TOP_xorxxx128v16,	0x000000ff,
		    TOP_xor128v32,	0x000000ff,
		    TOP_xorx128v32,	0x000000ff,
		    TOP_xorxx128v32,	0x000000ff,
		    TOP_xorxxx128v32,	0x000000ff,
		    TOP_xor128v64,	0x000000ff,
		    TOP_xorx128v64,	0x000000ff,
		    TOP_xorxx128v64,	0x000000ff,
		    TOP_xorxxx128v64,	0x000000ff,
		    TOP_fxor128v32,	0x000000ff,
		    TOP_fxorx128v32,	0x000000ff,
		    TOP_fxorxx128v32,	0x000000ff,
		    TOP_fxorxxx128v32,	0x000000ff,
		    TOP_fxor128v64,	0x000000ff,			 
		    TOP_fxorx128v64,	0x000000ff,			 
		    TOP_fxorxx128v64,	0x000000ff,			 
		    TOP_fxorxxx128v64,	0x000000ff,			 
		    TOP_xorps,	        0x000000ff,
		    TOP_xorpd,	        0x000000ff,
		    TOP_orps,	        0x000000ff,
		    TOP_orpd,	        0x000000ff,
		    TOP_andps,	        0x000000ff,
		    TOP_andpd,	        0x000000ff,
		    TOP_fmax128v32,	0x000000ff,
		    TOP_fmaxx128v32,	0x000000ff,
		    TOP_fmaxxx128v32,	0x000000ff,
		    TOP_fmaxxxx128v32,	0x000000ff,
		    TOP_fmax128v64,	0x000000ff,
		    TOP_fmaxx128v64,	0x000000ff,
		    TOP_fmaxxx128v64,	0x000000ff,
		    TOP_fmaxxxx128v64,	0x000000ff,
		    TOP_fmin128v32,	0x000000ff,
		    TOP_fminx128v32,	0x000000ff,
		    TOP_fminxx128v32,	0x000000ff,
		    TOP_fminxxx128v32,	0x000000ff,
		    TOP_fmin128v64,	0x000000ff,
		    TOP_fminx128v64,	0x000000ff,
		    TOP_fminxx128v64,	0x000000ff,
		    TOP_fminxxx128v64,	0x000000ff,
		    TOP_fdiv128v32,	0x000000ff,
		    TOP_fdivx128v32,	0x000000ff,
		    TOP_fdivxx128v32,	0x000000ff,
		    TOP_fdivxxx128v32,	0x000000ff,
		    TOP_fdiv128v64,	0x000000ff,
		    TOP_fdivx128v64,	0x000000ff,
		    TOP_fdivxx128v64,	0x000000ff,
		    TOP_fdivxxx128v64,	0x000000ff,
		    TOP_fmul128v32,	0x000000ff,
		    TOP_fmulx128v32,	0x000000ff,
		    TOP_fmulxx128v32,	0x000000ff,
		    TOP_fmulxxx128v32,	0x000000ff,
		    TOP_fmul128v64,	0x000000ff,
		    TOP_fmulx128v64,	0x000000ff,
		    TOP_fmulxx128v64,	0x000000ff,
		    TOP_fmulxxx128v64,	0x000000ff,
		    TOP_frcp128v32,	0x000000ff,
		    TOP_frsqrt128v32,	0x000000ff,
		    TOP_fsqrt128v32,	0x000000ff,
		    TOP_fsqrt128v64,	0x000000ff,
		    TOP_cmpgt128v8,     0x000000ff,
		    TOP_cmpgt128v16,    0x000000ff,
		    TOP_cmpgt128v32,    0x000000ff,
		    TOP_cmpeq128v8,     0x000000ff,
		    TOP_cmpeq128v16,    0x000000ff,
		    TOP_cmpeq128v32,    0x000000ff,
		    TOP_cmpgtx128v8,     0x000000ff,
		    TOP_cmpgtx128v16,    0x000000ff,
		    TOP_cmpgtx128v32,    0x000000ff,
		    TOP_cmpeqx128v8,     0x000000ff,
		    TOP_cmpeqx128v16,    0x000000ff,
		    TOP_cmpeqx128v32,    0x000000ff,
		    TOP_cmpgtxx128v8,     0x000000ff,
		    TOP_cmpgtxx128v16,    0x000000ff,
		    TOP_cmpgtxx128v32,    0x000000ff,
		    TOP_cmpeqxx128v8,     0x000000ff,
		    TOP_cmpeqxx128v16,    0x000000ff,
		    TOP_cmpeqxx128v32,    0x000000ff,
		    TOP_cmpgtxxx128v8,     0x000000ff,
		    TOP_cmpgtxxx128v16,    0x000000ff,
		    TOP_cmpgtxxx128v32,    0x000000ff,
		    TOP_cmpeqxxx128v8,     0x000000ff,
		    TOP_cmpeqxxx128v16,    0x000000ff,
		    TOP_cmpeqxxx128v32,    0x000000ff,
		    TOP_and8,	0x000000ff,
		    TOP_and16,	0x000000ff,
		    TOP_andx8,	0x000000ff,
		    TOP_andx16,	0x000000ff,
		    TOP_andx32,	0x000000ff,
		    TOP_andx64,	0x000000ff,
		    TOP_andxx8,	0x000000ff,
		    TOP_andxx16,0x000000ff,
		    TOP_andxx32,0x000000ff,
		    TOP_andxx64,0x000000ff,
		    TOP_and32,	0x000000ff,
		    TOP_and64,	0x000000ff,
		    TOP_andi8,	0x000000ff,
		    TOP_andi16,	0x000000ff,
		    TOP_andi32,	0x000000ff,
		    TOP_andi64,	0x000000ff,
		    TOP_call,	0x000000ff,
		    TOP_icall,	0x000000ff,
		    TOP_icallx,	0x000000ff,
		    TOP_icallxx,	0x000000ff,
		    TOP_icallxxx,	0x000000ff,
                    TOP_tls_global_dynamic_64,  0x000000ff,
                    TOP_tls_global_dynamic_32,  0x000000ff,
                    TOP_tls_local_dynamic_64,   0x000000ff,
                    TOP_tls_local_dynamic_32,   0x000000ff,
		    TOP_cmp8,	0x000000ff,
		    TOP_cmpx8,	0x000000ff,
		    TOP_cmpxx8,	0x000000ff,
		    TOP_cmpxx32,	0x000000ff,
		    TOP_cmpxx64,	0x000000ff,
		    TOP_cmp16,	0x000000ff,
		    TOP_cmpx16,	0x000000ff,
		    TOP_cmpxx16,0x000000ff,
		    TOP_cmp32,	0x000000ff,
		    TOP_cmpx32,	0x000000ff,
		    TOP_cmpxx32,0x000000ff,
		    TOP_cmp64,	0x000000ff,
		    TOP_cmpx64,	0x000000ff,
		    TOP_cmpi32,	0x000000ff,
		    TOP_cmpi64,	0x000000ff,
		    TOP_cmovb,	0x000000ff,
		    TOP_cmovae,	0x000000ff,
		    TOP_cmovp,	0x000000ff,
		    TOP_cmovnp,	0x000000ff,
		    TOP_cmove,	0x000000ff,
		    TOP_cmovne,	0x000000ff,
		    TOP_cmovbe,	0x000000ff,
		    TOP_cmova,	0x000000ff,
		    TOP_cmovl,	0x000000ff,
		    TOP_cmovge,	0x000000ff,
		    TOP_cmovle,	0x000000ff,
		    TOP_cmovg,	0x000000ff,
		    TOP_cmovs,	0x000000ff,
		    TOP_cmovns,	0x000000ff,
		    TOP_div32,	0x000000ff,
		    TOP_div64,	0x000000ff,
		    TOP_idiv32,	0x000000ff,
		    TOP_idiv64,	0x000000ff,
		    TOP_imul32,	0x000000ff,
		    TOP_imul64,	0x000000ff,
		    TOP_imuli32,0x000000ff,
		    TOP_imuli64,0x000000ff,
		    TOP_imulx64,0x000000ff,
		    TOP_imulx32,0x000000ff,
		    TOP_enter,	0x000000ff,
		    TOP_jb,	0x000000ff,
		    TOP_jae,	0x000000ff,
		    TOP_jp,	0x000000ff,
		    TOP_jnp,	0x000000ff,
		    TOP_je,	0x000000ff,
		    TOP_jne,	0x000000ff,
		    TOP_jbe,	0x000000ff,
		    TOP_ja,	0x000000ff,
		    TOP_jge,	0x000000ff,
		    TOP_jl,	0x000000ff,
		    TOP_jle,	0x000000ff,
		    TOP_jg,	0x000000ff,
		    TOP_jcxz,	0x000000ff,
		    TOP_jecxz,	0x000000ff,
		    TOP_jrcxz,	0x000000ff,
		    TOP_js,	0x000000ff,
		    TOP_jns,	0x000000ff,
		    TOP_jmp,	0x000000ff,
		    TOP_ijmp,	0x000000ff,
		    TOP_ijmpx,	0x000000ff,
		    TOP_ijmpxx,	0x000000ff,
		    TOP_ijmpxxx,	0x000000ff,
		    TOP_lea32,	0x000000ff,
		    TOP_lea64,	0x000000ff,
		    TOP_leax32,	0x000000ff,
		    TOP_leax64,	0x000000ff,
		    TOP_leaxx32,0x000000ff,
		    TOP_leaxx64,0x000000ff,
		    TOP_cltd,0x000000ff,
		    TOP_cqto,0x000000ff,
		    TOP_leave,	0x000000ff,
		    TOP_ld8_32,	0x000000ff,
		    TOP_ldx8_32,	0x000000ff,
		    TOP_ldxx8_32,	0x000000ff,
		    TOP_ldu8_32,	0x000000ff,
		    TOP_ldxu8_32,	0x000000ff,
		    TOP_ldxxu8_32,	0x000000ff,
		    TOP_ld16_32,	0x000000ff,
		    TOP_ldx16_32,	0x000000ff,
		    TOP_ldxx16_32,	0x000000ff,
		    TOP_ldu16_32,	0x000000ff,
		    TOP_ldxu16_32,	0x000000ff,
		    TOP_ldxxu16_32,	0x000000ff,
		    TOP_ld8_64,	0x000000ff,
		    TOP_ldx8_64,	0x000000ff,
		    TOP_ldxx8_64,	0x000000ff,
		    TOP_ld8_64_off,	0x000000ff,
		    TOP_ldu8_64,	0x000000ff,
		    TOP_ldxu8_64,	0x000000ff,
		    TOP_ldxxu8_64,	0x000000ff,
		    TOP_ldu8_64_off,	0x000000ff,
		    TOP_ld16_64,	0x000000ff,
		    TOP_ldx16_64,	0x000000ff,
		    TOP_ldxx16_64,	0x000000ff,
		    TOP_ld16_64_off,	0x000000ff,
		    TOP_ldu16_64,	0x000000ff,
		    TOP_ldxu16_64,	0x000000ff,
		    TOP_ldxxu16_64,	0x000000ff,
		    TOP_ldu16_64_off,	0x000000ff,
		    TOP_ld32,	0x000000ff,
		    TOP_ldx32,	0x000000ff,
		    TOP_ldxx32,	0x000000ff,
		    TOP_ld32_64,	0x000000ff,
		    TOP_ldx32_64,	0x000000ff,
		    TOP_ldxx32_64,	0x000000ff,
		    TOP_ld64,	0x000000ff,
		    TOP_ldx64,	0x000000ff,
		    TOP_ldxx64,	0x000000ff,
		    TOP_ldc32,	0x000000ff,
		    TOP_ldc64,	0x000000ff,
		    TOP_movabsq,0x000000ff,
		    TOP_maxsd,	0x000000ff,
		    TOP_maxss,	0x000000ff,
		    TOP_minsd,	0x000000ff,
		    TOP_minss,	0x000000ff,
		    TOP_mov32,	0x000000ff,
		    TOP_mov64,	0x000000ff,
		    TOP_movsbl,	0x000000ff,
		    TOP_movzbl,	0x000000ff,
		    TOP_movswl,	0x000000ff,
		    TOP_movzwl,	0x000000ff,
		    TOP_movsbq,	0x000000ff,
		    TOP_movzbq,	0x000000ff,
		    TOP_movswq,	0x000000ff,
		    TOP_movzwq,	0x000000ff,
		    TOP_movslq,	0x000000ff,
		    TOP_movzlq,	0x000000ff,
		    TOP_mul32,  0x000000ff,
		    TOP_mulx64, 0x000000ff,
		    TOP_neg8,	0x000000ff,
		    TOP_neg16,	0x000000ff,
		    TOP_neg32,	0x000000ff,
		    TOP_neg64,	0x000000ff,
		    TOP_negxr8,	0x000000ff,
		    TOP_negxxr8,	0x000000ff,
		    TOP_negxxxr8,	0x000000ff,
		    TOP_negxr8_n32,	0x000000ff,
		    TOP_negxr16,	0x000000ff,
		    TOP_negxxr16,	0x000000ff,
		    TOP_negxxxr16,	0x000000ff,
		    TOP_negxr16_n32,	0x000000ff,
		    TOP_negxr32,	0x000000ff,
		    TOP_negxxr32,	0x000000ff,
		    TOP_negxxxr32,	0x000000ff,
		    TOP_negxr32_n32,	0x000000ff,
		    TOP_negxr64,	0x000000ff,
		    TOP_negxxr64,	0x000000ff,
		    TOP_negxxxr64,	0x000000ff,
		    TOP_negxr64_off,	0x000000ff,
		    TOP_not8,	0x000000ff,
		    TOP_not16,	0x000000ff,
		    TOP_not32,	0x000000ff,
		    TOP_not64,	0x000000ff,
		    TOP_notxr8,	0x000000ff,
		    TOP_notxxr8,	0x000000ff,
		    TOP_notxxxr8,	0x000000ff,
		    TOP_notxr8_n32,	0x000000ff,
		    TOP_notxr16,	0x000000ff,
		    TOP_notxxr16,	0x000000ff,
		    TOP_notxxxr16,	0x000000ff,
		    TOP_notxr16_n32,	0x000000ff,
		    TOP_notxr32,	0x000000ff,
		    TOP_notxxr32,	0x000000ff,
		    TOP_notxxxr32,	0x000000ff,
		    TOP_notxr32_n32,	0x000000ff,
		    TOP_notxr64,	0x000000ff,
		    TOP_notxxr64,	0x000000ff,
		    TOP_notxxxr64,	0x000000ff,
		    TOP_notxr64_off,	0x000000ff,
		    TOP_or8,	0x000000ff,
		    TOP_or16,	0x000000ff,
		    TOP_orx8,	0x000000ff,
		    TOP_orx16,	0x000000ff,
		    TOP_orx32,	0x000000ff,
		    TOP_orx64,	0x000000ff,
		    TOP_orxx8,	0x000000ff,
		    TOP_orxx16,	0x000000ff,
		    TOP_orxx32,	0x000000ff,
		    TOP_orxx64,	0x000000ff,
		    TOP_or32,	0x000000ff,
		    TOP_or64,	0x000000ff,
		    TOP_ori8,	0x000000ff,
		    TOP_ori16,	0x000000ff,
		    TOP_ori32,	0x000000ff,
		    TOP_ori64,	0x000000ff,
		    TOP_prefetch,	0x000000ff,
		    TOP_prefetchw,	0x000000ff,
		    TOP_prefetcht0,	0x000000ff,
		    TOP_prefetcht1,	0x000000ff,
		    TOP_prefetchnta,    0x000000ff,
		    TOP_prefetchx,	0x000000ff,
		    TOP_prefetchwx,	0x000000ff,
		    TOP_prefetcht0x,	0x000000ff,
		    TOP_prefetcht1x,	0x000000ff,
		    TOP_prefetchntax,   0x000000ff,
		    TOP_prefetchxx,	0x000000ff,
		    TOP_prefetchwxx,	0x000000ff,
		    TOP_prefetcht0xx,	0x000000ff,
		    TOP_prefetcht1xx,	0x000000ff,
		    TOP_prefetchntaxx,  0x000000ff,
		    TOP_popl,	0x000000ff,
		    TOP_popq,	0x000000ff,
		    TOP_pushl,	0x000000ff,
		    TOP_pushq,	0x000000ff,
		    TOP_ret,	0x000000ff,
		    TOP_reti,	0x000000ff,
		    TOP_ror8,	0x000000ff,
		    TOP_ror16,	0x000000ff,
		    TOP_ror32,	0x000000ff,
		    TOP_ror64,	0x000000ff,
		    TOP_rori8,	0x000000ff,
		    TOP_rori16,	0x000000ff,
		    TOP_rori32,	0x000000ff,
		    TOP_rori64,	0x000000ff,
		    TOP_rol8,	0x000000ff,
		    TOP_rol16,	0x000000ff,
		    TOP_rol32,	0x000000ff,
		    TOP_rol64,	0x000000ff,
		    TOP_roli8,	0x000000ff,
		    TOP_roli16,	0x000000ff,
		    TOP_roli32,	0x000000ff,
		    TOP_roli64,	0x000000ff,
		    TOP_setb,	0x000000ff,
		    TOP_setae,	0x000000ff,
		    TOP_setp,	0x000000ff,
		    TOP_setnp,	0x000000ff,
		    TOP_sete,	0x000000ff,
		    TOP_setne,	0x000000ff,
		    TOP_setbe,	0x000000ff,
		    TOP_seta,	0x000000ff,
		    TOP_setl,	0x000000ff,
		    TOP_setge,	0x000000ff,
		    TOP_setle,	0x000000ff,
		    TOP_setg,	0x000000ff,
		    TOP_setc,	0x000000ff,
		    TOP_seto,	0x000000ff,
		    TOP_sets,	0x000000ff,
		    TOP_setz,	0x000000ff,
		    TOP_store8,	0x000000ff,
		    TOP_storex8,	0x000000ff,
		    TOP_storexx8,	0x000000ff,
		    TOP_storei8,	0x000000ff,
		    TOP_storeix8,	0x000000ff,
		    TOP_storeixx8,	0x000000ff,
		    TOP_store16,	0x000000ff,
		    TOP_storex16,	0x000000ff,
		    TOP_storexx16,	0x000000ff,
		    TOP_storei16,	0x000000ff,
		    TOP_storeix16,	0x000000ff,
		    TOP_storeixx16,	0x000000ff,
		    TOP_store32,	0x000000ff,
		    TOP_storex32,	0x000000ff,
		    TOP_storexx32,	0x000000ff,
		    TOP_storei32,	0x000000ff,
		    TOP_storeix32,	0x000000ff,
		    TOP_storeixx32,	0x000000ff,
		    TOP_store64,	0x000000ff,
		    TOP_storex64,	0x000000ff,
		    TOP_storexx64,	0x000000ff,
		    TOP_storei64,	0x000000ff,
		    TOP_storeix64,	0x000000ff,
		    TOP_storeixx64,	0x000000ff,
		    TOP_storenti32,	0x000000ff,
		    TOP_storentix32,	0x000000ff,
		    TOP_storentixx32,	0x000000ff,
		    TOP_storenti64,	0x000000ff,
		    TOP_storentix64,	0x000000ff,
		    TOP_storentixx64,	0x000000ff,
		    TOP_sar32,	0x000000ff,
		    TOP_sar64,	0x000000ff,
		    TOP_sari32,	0x000000ff,
		    TOP_sari64,	0x000000ff,
		    TOP_shl32,	0x000000ff,
		    TOP_shld32,	0x000000ff,
		    TOP_shldi32,	0x000000ff,
		    TOP_shrd32,	0x000000ff,
		    TOP_shrdi32,	0x000000ff,
		    TOP_shl64,	0x000000ff,
		    TOP_shli32,	0x000000ff,
		    TOP_shli64,	0x000000ff,
		    TOP_shr32,	0x000000ff,
		    TOP_shr64,	0x000000ff,
		    TOP_shri32,	0x000000ff,
		    TOP_shri64,	0x000000ff,
		    TOP_sub8,	0x000000ff,
		    TOP_sub16,	0x000000ff,
		    TOP_sub32,	0x000000ff,
		    TOP_sbb32,	0x000000ff,
		    TOP_sub64,	0x000000ff,
		    TOP_subx32,	0x000000ff,
		    TOP_subx64,	0x000000ff,
		    TOP_subxx32,0x000000ff,
		    TOP_subxx64,0x000000ff,
		    TOP_subi8,	0x000000ff,
		    TOP_subi16,	0x000000ff,
		    TOP_subi32,	0x000000ff,
		    TOP_sbbi32,	0x000000ff,
		    TOP_subi64,	0x000000ff,
		    TOP_sub128v8,	0x000000ff,
		    TOP_subx128v8,	0x000000ff,
		    TOP_subxx128v8,	0x000000ff,
		    TOP_subxxx128v8,	0x000000ff,
		    TOP_sub128v16,	0x000000ff,
		    TOP_subx128v16,	0x000000ff,
		    TOP_subxx128v16,	0x000000ff,
		    TOP_subxxx128v16,	0x000000ff,
		    TOP_sub128v32,	0x000000ff,
		    TOP_subx128v32,	0x000000ff,
		    TOP_subxx128v32,	0x000000ff,
		    TOP_subxxx128v32,	0x000000ff,
		    TOP_sub128v64,	0x000000ff,
		    TOP_subx128v64,	0x000000ff,
		    TOP_subxx128v64,	0x000000ff,
		    TOP_subxxx128v64,	0x000000ff,
		    TOP_fsub128v32,	0x000000ff,
		    TOP_fsubx128v32,	0x000000ff,
		    TOP_fsubxx128v32,	0x000000ff,
		    TOP_fsubxxx128v32,	0x000000ff,
		    TOP_fsub128v64,	0x000000ff,
		    TOP_fsubx128v64,	0x000000ff,
		    TOP_fsubxx128v64,	0x000000ff,
		    TOP_fsubxxx128v64,	0x000000ff,
		    TOP_fhsub128v32,	0x000000ff,
		    TOP_fhsubx128v32,	0x000000ff,
		    TOP_fhsubxx128v32,	0x000000ff,
		    TOP_fhsubxxx128v32,	0x000000ff,
		    TOP_fhsub128v64,	0x000000ff,
		    TOP_fhsubx128v64,	0x000000ff,
		    TOP_fhsubxx128v64,	0x000000ff,
		    TOP_fhsubxxx128v64,	0x000000ff,
		    TOP_fmovsldup,      0x000000ff,
		    TOP_fmovsldupx,     0x000000ff,
		    TOP_fmovsldupxx,    0x000000ff,
		    TOP_fmovsldupxxx,   0x000000ff,
		    TOP_fmovshdup,      0x000000ff,
		    TOP_fmovshdupx,     0x000000ff,
		    TOP_fmovshdupxx,    0x000000ff,
		    TOP_fmovshdupxxx,   0x000000ff,
		    TOP_fmovddup,      0x000000ff,
		    TOP_fmovddupx,     0x000000ff,
		    TOP_fmovddupxx,    0x000000ff,
		    TOP_fmovddupxxx,   0x000000ff,
		    TOP_test8,	       0x000000ff,
		    TOP_testx8,	       0x000000ff,
		    TOP_testxx8,	   0x000000ff,
		    TOP_test16,	       0x000000ff,
		    TOP_testx16,	   0x000000ff,
		    TOP_testxx16,	   0x000000ff,
		    TOP_test32,	0x000000ff,
		    TOP_testx32,	0x000000ff,
		    TOP_testxx32,	0x000000ff,
		    TOP_testx64,	0x000000ff,
		    TOP_testxx64,	0x000000ff,
		    TOP_test64,	0x000000ff,
		    TOP_testi8,	0x000000ff,
		    TOP_testi16,	0x000000ff,
		    TOP_testi32,	0x000000ff,
		    TOP_testi64,	0x000000ff,
		    TOP_xor8,	0x000000ff,
		    TOP_xor16,	0x000000ff,
		    TOP_xorx8,	0x000000ff,
		    TOP_xorx16,	0x000000ff,
		    TOP_xorx32,	0x000000ff,
		    TOP_xorx64,	0x000000ff,
		    TOP_xorxx8,	0x000000ff,
		    TOP_xorxx16,0x000000ff,
		    TOP_xorxx32,0x000000ff,
		    TOP_xorxx64,0x000000ff,
		    TOP_xor32,	0x000000ff,
		    TOP_xor64,	0x000000ff,
		    TOP_xori8,	0x000000ff,
		    TOP_xori16,	0x000000ff,
		    TOP_xori32,	0x000000ff,
		    TOP_xori64,	0x000000ff,
		    TOP_addsd,	0x000000ff,
		    TOP_addss,	0x000000ff,
		    TOP_addxsd,	0x000000ff,
		    TOP_addxss,	0x000000ff,
		    TOP_addxxsd,0x000000ff,
		    TOP_addxxss,0x000000ff,
		    TOP_divsd,	0x000000ff,
		    TOP_divxsd,	0x000000ff,
		    TOP_divxxsd,	0x000000ff,
		    TOP_divss,	0x000000ff,
		    TOP_divxss,	0x000000ff,
		    TOP_divxxss,	0x000000ff,
		    TOP_mulsd,	0x000000ff,
		    TOP_mulss,	0x000000ff,
		    TOP_mulxsd,	0x000000ff,
		    TOP_mulxss,	0x000000ff,
		    TOP_mulxxsd,	0x000000ff,
		    TOP_mulxxss,	0x000000ff,
		    TOP_rcpss,	0x000000ff,
		    TOP_sqrtsd,	0x000000ff,
		    TOP_sqrtss,	0x000000ff,
		    TOP_rsqrtss,	0x000000ff,
		    TOP_cvtdq2pd,       0x000000ff,
		    TOP_cvtdq2ps,       0x000000ff,
		    TOP_cvtps2pd,       0x000000ff,
		    TOP_cvtpd2ps,       0x000000ff,
		    TOP_cvtss2sd,	0x000000ff,
		    TOP_cvtsd2ss,	0x000000ff,
		    TOP_cvtss2si,	0x000000ff,
		    TOP_cvtsd2si,	0x000000ff,
		    TOP_cvtss2siq,	0x000000ff,
		    TOP_cvtsd2siq,	0x000000ff,
		    TOP_cvttss2si,	0x000000ff,
		    TOP_cvttsd2si,	0x000000ff,
		    TOP_cvttss2siq,	0x000000ff,
		    TOP_cvttsd2siq,	0x000000ff,
		    TOP_cvtsi2sd,	0x000000ff,
		    TOP_cvtsi2ss,	0x000000ff,
		    TOP_cvtsi2sdq,	0x000000ff,
		    TOP_cvtsi2ssq,	0x000000ff,
		    TOP_cvtps2dq,      0x000000ff,
		    TOP_cvttps2dq,      0x000000ff,
		    TOP_cvtpd2dq,      0x000000ff,
		    TOP_cvttpd2dq,      0x000000ff,
		    TOP_cvtdq2pd_x,     0x000000ff,
		    TOP_cvtdq2ps_x,     0x000000ff,
		    TOP_cvtps2pd_x,     0x000000ff,
                    TOP_cvtpd2dq_x,     0x000000ff,
		    TOP_cvtpd2ps_x,     0x000000ff,
		    TOP_cvttpd2dq_x,    0x000000ff,
		    TOP_cvtps2dq_x,    0x000000ff,			 
		    TOP_cvttps2dq_x,    0x000000ff,			 
		    TOP_cvtdq2pd_xx,     0x000000ff,
		    TOP_cvtdq2ps_xx,     0x000000ff,
		    TOP_cvtps2pd_xx,     0x000000ff,
                    TOP_cvtpd2dq_xx,     0x000000ff,
		    TOP_cvtpd2ps_xx,     0x000000ff,
		    TOP_cvttpd2dq_xx,    0x000000ff,
		    TOP_cvtps2dq_xx,    0x000000ff,			 
		    TOP_cvttps2dq_xx,    0x000000ff,			 
		    TOP_cvtdq2pd_xxx,     0x000000ff,
		    TOP_cvtdq2ps_xxx,     0x000000ff,
		    TOP_cvtps2pd_xxx,     0x000000ff,
		    TOP_cvtpd2dq_xxx,     0x000000ff,
		    TOP_cvtpd2ps_xxx,     0x000000ff,
		    TOP_cvttpd2dq_xxx,    0x000000ff,
		    TOP_cvtps2dq_xxx,    0x000000ff,			 
		    TOP_cvttps2dq_xxx,    0x000000ff,			 
		    TOP_vcvtph2ps,    0x000000ff,			 
		    TOP_vcvtph2psx,    0x000000ff,			 
		    TOP_vcvtph2psxx,    0x000000ff,			 
		    TOP_vcvtph2psxxx,    0x000000ff,			 
		    TOP_vcvtps2ph,    0x000000ff,			 
		    TOP_vcvtps2phx,    0x000000ff,			 
		    TOP_vcvtps2phxx,    0x000000ff,			 
		    TOP_vcvtps2phxxx,    0x000000ff,			 
		    TOP_cvtpi2ps,    0x000000ff,			 
		    TOP_cvtps2pi,    0x000000ff,			 
		    TOP_cvttps2pi,    0x000000ff,			 
		    TOP_cvtpi2pd,    0x000000ff,			 
		    TOP_cvtpd2pi,    0x000000ff,			 
		    TOP_cvttpd2pi,    0x000000ff,			 
		    TOP_lddqa,	0x000000ff,
		    TOP_stdqa,	0x000000ff,
		    TOP_ldapd,  0x000000ff,
		    TOP_ldaps,  0x000000ff,
		    TOP_ldupd,  0x000000ff,
		    TOP_ldups,  0x000000ff,
		    TOP_ldupsx,  0x000000ff,
		    TOP_ldupsxx,  0x000000ff,
		    TOP_stapd,  0x000000ff,
		    TOP_staps,  0x000000ff,
		    TOP_stupd,  0x000000ff,
		    TOP_stupdx,  0x000000ff,
		    TOP_stupdxx, 0x000000ff,
                    TOP_stupd_n32,     0x000000ff,
		    TOP_stups,  0x000000ff,
		    TOP_stupsx,  0x000000ff,
		    TOP_stupsxx, 0x000000ff,
                    TOP_stups_n32,     0x000000ff,
		    TOP_stntpd, 0x000000ff,
		    TOP_stntps, 0x000000ff,
		    TOP_storenti128, 0x000000ff,
		    TOP_storent64_fm, 0x000000ff,
		    TOP_lddqu,	0x000000ff,
		    TOP_stdqu,	0x000000ff,
		    TOP_ldlpd,	0x000000ff,
		    TOP_stlpd,	0x000000ff,
		    TOP_storelpd,	0x000000ff,
		    TOP_ldlps,	0x000000ff,
		    TOP_stlps,	0x000000ff,
		    TOP_ldhpd,	0x000000ff,
		    TOP_sthpd,	0x000000ff,
		    TOP_ldhps,	0x000000ff,
		    TOP_sthps,	0x000000ff,
		    TOP_lddqax,	0x000000ff,
		    TOP_stdqax,	0x000000ff,
		    TOP_ldapdx,  0x000000ff,
		    TOP_ldapsx,  0x000000ff,
		    TOP_stapdx,  0x000000ff,
		    TOP_stapsx,  0x000000ff,
		    TOP_stntpdx,0x000000ff,
		    TOP_stntpsx,0x000000ff,
		    TOP_ldupdx,  0x000000ff,
		    TOP_lddqux,	0x000000ff,
		    TOP_stdqux,	0x000000ff,
		    TOP_ldlpdx,	0x000000ff,
		    TOP_stlpdx,	0x000000ff,
		    TOP_ldlpsx,	0x000000ff,
		    TOP_stlpsx,	0x000000ff,
		    TOP_ldhpdx,	0x000000ff,
		    TOP_sthpdx,	0x000000ff,
		    TOP_ldhpsx,	0x000000ff,
		    TOP_sthpsx,	0x000000ff,
		    TOP_lddqaxx,	0x000000ff,
		    TOP_stdqaxx,	0x000000ff,
		    TOP_ldapdxx,  0x000000ff,
		    TOP_ldapsxx,  0x000000ff,
		    TOP_stapdxx,  0x000000ff,
		    TOP_stapsxx,  0x000000ff,
		    TOP_stntpdxx,       0x000000ff,
		    TOP_stntpsxx,       0x000000ff,
		    TOP_ldupdxx,  0x000000ff,
		    TOP_lddquxx,	0x000000ff,
		    TOP_stdquxx,	0x000000ff,
		    TOP_ldlpdxx,	0x000000ff,
		    TOP_stlpdxx,	0x000000ff,
		    TOP_ldlpsxx,	0x000000ff,
		    TOP_stlpsxx,	0x000000ff,
		    TOP_ldhpdxx,	0x000000ff,
		    TOP_sthpdxx,	0x000000ff,
		    TOP_ldhpsxx,	0x000000ff,
		    TOP_sthpsxx,	0x000000ff,
		    TOP_ldsd_n32,	0x000000ff,
		    TOP_ldss_n32,	0x000000ff,
		    TOP_ldsd,	0x000000ff,
		    TOP_ldss,	0x000000ff,
		    TOP_ldsdx,	0x000000ff,
		    TOP_ldsdxx,	0x000000ff,
		    TOP_ldssx,	0x000000ff,
		    TOP_ldssxx,	0x000000ff,
		    TOP_movg2x64,	0x000000ff,
		    TOP_movg2x,	0x000000ff,
		    TOP_movx2g64,	0x000000ff,
		    TOP_movx2g,	0x000000ff,
		    TOP_movsd,	0x000000ff,
		    TOP_movss,	0x000000ff,
		    TOP_movdq,  0x000000ff,
		    TOP_movapd, 0x000000ff,
		    TOP_movaps, 0x000000ff,
		    TOP_movq2dq, 0x000000ff,
		    TOP_movdq2q, 0x000000ff,
		    TOP_subsd,	0x000000ff,
		    TOP_subss,	0x000000ff,
		    TOP_subxsd,	0x000000ff,
		    TOP_subxss,	0x000000ff,
		    TOP_subxxsd,0x000000ff,
		    TOP_subxxss,0x000000ff,
                    TOP_ucomisd,       0x000000ff,
                    TOP_ucomixsd,      0x000000ff,
                    TOP_ucomixxsd,     0x000000ff,
                    TOP_ucomixxxsd,    0x000000ff,
                    TOP_ucomiss,       0x000000ff,
                    TOP_ucomixss,      0x000000ff,
                    TOP_ucomixxss,     0x000000ff,
                    TOP_ucomixxxss,    0x000000ff,
		    TOP_stss_n32,	0x000000ff,
		    TOP_stsd_n32,	0x000000ff,
		    TOP_stss,	0x000000ff,
		    TOP_stsd,	0x000000ff,
		    TOP_stntss, 0x000000ff,
		    TOP_stntsd, 0x000000ff,
		    TOP_stssx,	0x000000ff,
		    TOP_stssxx,	0x000000ff,
		    TOP_stsdx,	0x000000ff,
		    TOP_stsdxx,	0x000000ff,
		    TOP_stntssx,  0x000000ff,
		    TOP_stntssxx, 0x000000ff,
		    TOP_stntsdx,  0x000000ff,
		    TOP_stntsdxx, 0x000000ff,
		    TOP_comisd,	0x000000ff,
		    TOP_comixsd,	0x000000ff,
		    TOP_comixxsd,	0x000000ff,
		    TOP_comixxxsd,	0x000000ff,
		    TOP_comiss,	        0x000000ff,
		    TOP_comixss,	0x000000ff,
		    TOP_comixxss,	0x000000ff,
		    TOP_comixxxss,	0x000000ff,
		    TOP_unpckhpd,       0x000000ff,
		    TOP_unpckhps,       0x000000ff,
		    TOP_unpcklpd,       0x000000ff,
		    TOP_unpcklps,       0x000000ff,
		    TOP_pshufd,		0x000000ff,
		    TOP_pshufw,		0x000000ff,
		    TOP_pshuflw,	0x000000ff,
		    TOP_pshufhw,	0x000000ff,
		    TOP_shufpd,         0x000000ff,
		    TOP_shufps,         0x000000ff,
		    TOP_movhlps,        0x000000ff,
		    TOP_movlhps,        0x000000ff,
		    TOP_psrldq,         0x000000ff,
		    TOP_psrlq128v64,    0x000000ff,
		    TOP_pslldq,         0x000000ff,
		    TOP_psllw,          0x000000ff,
		    TOP_psllwi,         0x000000ff,
		    TOP_pslld,          0x000000ff,
		    TOP_pslldi,         0x000000ff,
		    TOP_psllq,          0x000000ff,
		    TOP_psllqi,         0x000000ff,
		    TOP_psrlw,          0x000000ff,
		    TOP_psrlwi,         0x000000ff,
		    TOP_psrld,          0x000000ff,
		    TOP_psrldi,         0x000000ff,
		    TOP_psrlq,          0x000000ff,
		    TOP_psrlqi,         0x000000ff,
		    TOP_psraw,          0x000000ff,
		    TOP_psrawi,         0x000000ff,
		    TOP_psrad,          0x000000ff,
		    TOP_psradi,         0x000000ff,
  		    TOP_psllw_mmx,      0x000000ff,
  		    TOP_psllwi_mmx,     0x000000ff,
  		    TOP_pslld_mmx,      0x000000ff,
  		    TOP_pslldi_mmx,     0x000000ff,
  		    TOP_psllq_mmx,      0x000000ff,
  		    TOP_psllqi_mmx,     0x000000ff,
  		    TOP_psrlw_mmx,      0x000000ff,
  		    TOP_psrlwi_mmx,     0x000000ff,
  		    TOP_psrld_mmx,      0x000000ff,
  		    TOP_psrldi_mmx,     0x000000ff,
  		    TOP_psrlq_mmx,      0x000000ff,
  		    TOP_psrlqi_mmx,     0x000000ff,
  		    TOP_psraw_mmx,      0x000000ff,
  		    TOP_psrawi_mmx,     0x000000ff,
  		    TOP_psrad_mmx,      0x000000ff,
  		    TOP_psradi_mmx,     0x000000ff,
  		    TOP_pand_mmx,       0x000000ff,
  		    TOP_pandn_mmx,      0x000000ff,
  		    TOP_por_mmx,        0x000000ff,
  		    TOP_pxor_mmx,       0x000000ff,
		    TOP_mfence,         0x000000ff,
		    TOP_lfence,         0x000000ff,
		    TOP_sfence,         0x000000ff,
		    TOP_ld32_64_off,    0x000000ff,
		    TOP_ld64_off,       0x000000ff,
		    TOP_store64_off,    0x000000ff,
		    TOP_storei64_off,   0x000000ff,
		    TOP_ld8_32_n32,     0x000000ff,
		    TOP_ldu8_32_n32,    0x000000ff,
		    TOP_ld16_32_n32,    0x000000ff,
		    TOP_ldu16_32_n32,   0x000000ff,
		    TOP_ld32_n32,       0x000000ff,
		    TOP_store8_n32,     0x000000ff,
		    TOP_store16_n32,    0x000000ff,
		    TOP_store32_n32,    0x000000ff,
		    TOP_storei8_n32,    0x000000ff,
		    TOP_storei16_n32,   0x000000ff,
		    TOP_storei32_n32,   0x000000ff,
		    TOP_fadd,     0x000000ff,
		    TOP_faddp,    0x000000ff,
		    TOP_fsub,     0x000000ff,
		    TOP_fsubp,    0x000000ff,
		    TOP_fsubr,    0x000000ff,
		    TOP_fsubrp,   0x000000ff,
		    TOP_fld,      0x000000ff,
		    TOP_flds,     0x000000ff,
		    TOP_flds_n32, 0x000000ff,
		    TOP_fldl,     0x000000ff,
		    TOP_fldl_n32, 0x000000ff,
		    TOP_fldt,     0x000000ff,
		    TOP_fldt_n32, 0x000000ff,
		    TOP_fstp,     0x000000ff,
		    TOP_fstps,    0x000000ff,
		    TOP_fstps_n32,0x000000ff,
		    TOP_fstpl,    0x000000ff,
		    TOP_fstpl_n32,0x000000ff,
		    TOP_fst,    0x000000ff,
		    TOP_fsts,    0x000000ff,
		    TOP_fsts_n32,0x000000ff,
		    TOP_fstl,    0x000000ff,
		    TOP_fstl_n32,0x000000ff,
		    TOP_fstpt,    0x000000ff,
		    TOP_fstpt_n32,0x000000ff,
		    TOP_fxch,     0x000000ff,
		    TOP_fmov,     0x000000ff,
		    TOP_fmul,     0x000000ff,
		    TOP_fmulp,    0x000000ff,
		    TOP_fdiv,     0x000000ff,
		    TOP_fdivp,    0x000000ff,
		    TOP_fdivr,    0x000000ff,
		    TOP_fdivrp,   0x000000ff,
		    TOP_fucomi,   0x000000ff,
		    TOP_fucomip,  0x000000ff,
		    TOP_fchs,     0x000000ff,
		    TOP_frndint,  0x000000ff,
		    TOP_fnstcw,   0x000000ff,
		    TOP_fldcw,    0x000000ff,
		    TOP_fistps,   0x000000ff,
		    TOP_fistpl,   0x000000ff,
		    TOP_fists,    0x000000ff,
		    TOP_fistl,    0x000000ff,
		    TOP_fistpll,  0x000000ff,
		    TOP_fisttps,  0x000000ff,
		    TOP_fisttpl,  0x000000ff,
		    TOP_fisttpll, 0x000000ff,
		    TOP_filds,    0x000000ff,
		    TOP_fildl,    0x000000ff,
		    TOP_fildll,   0x000000ff,
		    TOP_fabs,     0x000000ff,
		    TOP_fsqrt,    0x000000ff,
		    TOP_fcmovb,   0x000000ff,
		    TOP_fcmovbe,  0x000000ff,
		    TOP_fcmovnb,  0x000000ff,
		    TOP_fcmovnbe, 0x000000ff,
		    TOP_fcmove,   0x000000ff,
		    TOP_fcmovne,  0x000000ff,
		    TOP_fcmovu,   0x000000ff,
		    TOP_fcmovnu,  0x000000ff,
		    TOP_fldz,     0x000000ff,
		    TOP_fcos,     0x000000ff,
		    TOP_fsin,     0x000000ff,
		    TOP_subus128v16,	0x000000ff,
		    TOP_ldaps_n32,	0x000000ff,
		    TOP_ldups_n32,	0x000000ff,
		    TOP_ldapd_n32,	0x000000ff,
		    TOP_ldupd_n32,	0x000000ff,
		    TOP_lddqa_n32,	0x000000ff,
		    TOP_lddqu_n32,	0x000000ff,
		    TOP_ldlps_n32,	0x000000ff,
		    TOP_ldhps_n32,	0x000000ff,
		    TOP_ldlpd_n32,	0x000000ff,
		    TOP_ldhpd_n32,	0x000000ff,
		    TOP_staps_n32,	0x000000ff,
		    TOP_stapd_n32,	0x000000ff,
		    TOP_stdqa_n32,	0x000000ff,
		    TOP_stdqu_n32,	0x000000ff,
		    TOP_stlps_n32,	0x000000ff,
		    TOP_sthps_n32,	0x000000ff,
		    TOP_stlpd_n32,	0x000000ff,
		    TOP_sthpd_n32,	0x000000ff,
		    TOP_store8_abs,	0x000000ff,
		    TOP_store16_abs,	0x000000ff,
		    TOP_store32_abs,	0x000000ff,
		    TOP_store64_abs,	0x000000ff,
		    TOP_ld8_abs,	0x000000ff,
		    TOP_ld16_abs,	0x000000ff,
		    TOP_ld32_abs,	0x000000ff,
		    TOP_ld64_abs,	0x000000ff,
		    TOP_ld32_gs_seg_off,	0x000000ff,
		    TOP_ld64_fs_seg_off,	0x000000ff,
		    TOP_lock_add8,      0x000000ff,
		    TOP_lock_add16,     0x000000ff,
		    TOP_lock_add32,     0x000000ff,
		    TOP_lock_adc32,     0x000000ff,
		    TOP_lock_add64,     0x000000ff,
		    TOP_lock_xadd8,     0x000000ff,
		    TOP_lock_xadd16,    0x000000ff,
		    TOP_lock_xadd32,    0x000000ff,
		    TOP_lock_xadd64,    0x000000ff,
		    TOP_lock_xchg8,     0x000000ff,
		    TOP_lock_xchg16,    0x000000ff,
		    TOP_lock_xchg32,    0x000000ff,
		    TOP_lock_xchg64,    0x000000ff,
		    TOP_cvtsd2ss_x,	0x000000ff,
		    TOP_cvtsd2ss_xx,	0x000000ff,
		    TOP_cvtsd2ss_xxx,	0x000000ff,
		    TOP_cvtsi2sd_x,	0x000000ff,
		    TOP_cvtsi2sd_xx,	0x000000ff,
		    TOP_cvtsi2sd_xxx,	0x000000ff,
		    TOP_cvtsi2ss_x,	0x000000ff,
		    TOP_cvtsi2ss_xx,	0x000000ff,
		    TOP_cvtsi2ss_xxx,	0x000000ff,
		    TOP_cvtsi2sdq_x,	0x000000ff,
		    TOP_cvtsi2sdq_xx,	0x000000ff,
		    TOP_cvtsi2sdq_xxx,	0x000000ff,
		    TOP_cvtsi2ssq_x,	0x000000ff,
		    TOP_cvtsi2ssq_xx,	0x000000ff,
		    TOP_cvtsi2ssq_xxx,	0x000000ff,
		    TOP_lock_cmpxchg8,  0x000000ff,
		    TOP_lock_cmpxchg16, 0x000000ff,
		    TOP_lock_cmpxchg32, 0x000000ff,
		    TOP_lock_cmpxchg64, 0x000000ff,
		    TOP_lock_and8,  0x000000ff,
		    TOP_lock_and16, 0x000000ff,
		    TOP_lock_and32, 0x000000ff,
		    TOP_lock_and64, 0x000000ff,
		    TOP_lock_or8,  0x000000ff,
		    TOP_lock_or16, 0x000000ff,
		    TOP_lock_or32, 0x000000ff,
		    TOP_lock_or64, 0x000000ff,
		    TOP_lock_xor8,  0x000000ff,
		    TOP_lock_xor16, 0x000000ff,
		    TOP_lock_xor32, 0x000000ff,
		    TOP_lock_xor64, 0x000000ff,
		    TOP_lock_sub8,  0x000000ff,
		    TOP_lock_sub16, 0x000000ff,
		    TOP_lock_sub32, 0x000000ff,
		    TOP_lock_sub64, 0x000000ff,
		    TOP_bsf32, 0x000000ff,
		    TOP_bsf64, 0x000000ff,
		    TOP_bsr32, 0x000000ff,
		    TOP_bsr64, 0x000000ff,
		    TOP_ld64_2m, 0x000000ff,
		    TOP_ld64_2m_n32, 0x000000ff,
		    TOP_store64_fm, 0x000000ff,
		    TOP_store64_fm_n32, 0x000000ff,
		    TOP_ld64_2sse, 0x000000ff,
		    TOP_ld64_2sse_n32, 0x000000ff,
		    TOP_store64_fsse, 0x000000ff,
		    TOP_store64_fsse_n32, 0x000000ff,
		    TOP_mov64_m, 0x000000ff,
		    TOP_add64v8, 0x000000ff,
		    TOP_add64v16, 0x000000ff,
		    TOP_add64v32, 0x000000ff,
		    TOP_sub64v8, 0x000000ff,
		    TOP_sub64v16, 0x000000ff,
		    TOP_sub64v32, 0x000000ff,
		    TOP_paddsb, 0x000000ff,
		    TOP_paddsw, 0x000000ff,
		    TOP_paddq, 0x000000ff,
		    TOP_psubsb, 0x000000ff,
		    TOP_psubsw, 0x000000ff,
		    TOP_psubq, 0x000000ff,
		    TOP_paddusb, 0x000000ff,
		    TOP_paddusw, 0x000000ff,
		    TOP_psubusb, 0x000000ff,
		    TOP_psubusw, 0x000000ff,
		    TOP_pmullw, 0x000000ff,
		    TOP_pmulhw, 0x000000ff,
		    TOP_pmulhuw, 0x000000ff,
		    TOP_pmuludq, 0x000000ff,
		    TOP_pmaddwd, 0x000000ff,
		    TOP_pavgb, 0x000000ff,
		    TOP_pavgw, 0x000000ff,
		    TOP_psadbw, 0x000000ff,
		    TOP_paddsb128, 0x000000ff,
		    TOP_paddsw128, 0x000000ff,
		    TOP_paddq128, 0x000000ff,
		    TOP_psubsb128, 0x000000ff,
		    TOP_psubsw128, 0x000000ff,
		    TOP_psubq128, 0x000000ff,
		    TOP_paddusb128, 0x000000ff,
		    TOP_paddusw128, 0x000000ff,
		    TOP_psubusb128, 0x000000ff,
		    TOP_psubusw128, 0x000000ff,
		    TOP_pmullw128, 0x000000ff,
		    TOP_pmulhw128, 0x000000ff,
		    TOP_pmulhuw128, 0x000000ff,
		    TOP_pmuludq128, 0x000000ff,
		    TOP_pmaddwd128, 0x000000ff,
		    TOP_pavgb128, 0x000000ff,
		    TOP_pavgw128, 0x000000ff,
		    TOP_psadbw128, 0x000000ff,
		    TOP_pand, 0x000000ff,
		    TOP_pandn, 0x000000ff,
		    TOP_por, 0x000000ff,
		    TOP_pxor, 0x000000ff,
		    TOP_pcmpeqb, 0x000000ff,
		    TOP_pcmpeqw, 0x000000ff,
		    TOP_pcmpeqd, 0x000000ff,
		    TOP_pcmpgtb, 0x000000ff,
		    TOP_pcmpgtw, 0x000000ff,
		    TOP_pcmpgtd, 0x000000ff,
		    TOP_punpckhbw, 0x000000ff,
		    TOP_punpckhwd, 0x000000ff,
		    TOP_punpckhdq, 0x000000ff,
		    TOP_punpckhbw128, 0x000000ff,
		    TOP_punpckhwd128, 0x000000ff,
		    TOP_punpckhdq128, 0x000000ff,
		    TOP_punpcklbw, 0x000000ff,
		    TOP_punpcklwd, 0x000000ff,
		    TOP_punpckldq, 0x000000ff,
		    TOP_punpcklbw128, 0x000000ff,
		    TOP_punpcklwd128, 0x000000ff,
		    TOP_punpckldq128, 0x000000ff,
		    TOP_punpckhqdq, 0x000000ff,
		    TOP_punpcklqdq, 0x000000ff,
		    TOP_packsswb, 0x000000ff,
		    TOP_packssdw, 0x000000ff,
		    TOP_packuswb, 0x000000ff,
		    TOP_packsswb128, 0x000000ff,
		    TOP_packssdw128, 0x000000ff,
		    TOP_packuswb128, 0x000000ff,
		    TOP_max64v8, 0x000000ff,
		    TOP_max64v16, 0x000000ff,
		    TOP_min64v8, 0x000000ff,
		    TOP_min64v16, 0x000000ff,
		    TOP_pextrw, 0x000000ff,
		    TOP_pinsrw, 0x000000ff,
		    TOP_pmovmskb, 0x000000ff,
		    TOP_pmovmskb128, 0x000000ff,
		    TOP_cmpeqpd, 0x000000ff,
		    TOP_cmpltpd, 0x000000ff,
		    TOP_cmplepd, 0x000000ff,
		    TOP_cmpunordpd, 0x000000ff,
		    TOP_cmpneqpd, 0x000000ff,
		    TOP_cmpnltpd, 0x000000ff,
		    TOP_cmpnlepd, 0x000000ff,
		    TOP_cmpordpd, 0x000000ff,
		    TOP_cmpeqps, 0x000000ff,
		    TOP_cmpltps, 0x000000ff,
		    TOP_cmpleps, 0x000000ff,
		    TOP_cmpunordps, 0x000000ff,
		    TOP_cmpneqps, 0x000000ff,
		    TOP_cmpnltps, 0x000000ff,
		    TOP_cmpnleps, 0x000000ff,
		    TOP_cmpordps, 0x000000ff,
		    TOP_cmpeqsd, 0x000000ff,
		    TOP_cmpltsd, 0x000000ff,
		    TOP_cmplesd, 0x000000ff,
		    TOP_cmpunordsd, 0x000000ff,
		    TOP_cmpneqsd, 0x000000ff,
		    TOP_cmpnltsd, 0x000000ff,
		    TOP_cmpnlesd, 0x000000ff,
		    TOP_cmpordsd, 0x000000ff,
		    TOP_cmpeqss, 0x000000ff,
		    TOP_cmpltss, 0x000000ff,
		    TOP_cmpless, 0x000000ff,
		    TOP_cmpunordss, 0x000000ff,
		    TOP_cmpneqss, 0x000000ff,
		    TOP_cmpnltss, 0x000000ff,
		    TOP_cmpnless, 0x000000ff,
		    TOP_cmpordss, 0x000000ff,
		    TOP_emms, 0x000000ff,
		    TOP_stmxcsr, 0x000000ff,
		    TOP_ldmxcsr, 0x000000ff,
		    TOP_clflush, 0x000000ff,
		    TOP_movi32_2m, 0x000000ff,
		    TOP_movi64_2m, 0x000000ff,
		    TOP_movm_2i32, 0x000000ff,
		    TOP_movm_2i64, 0x000000ff,
		    TOP_pshufw64v16, 0x000000ff,
		    TOP_movmskps, 0x000000ff,
		    TOP_movmskpd, 0x000000ff,
		    TOP_maskmovdqu, 0x000000ff,
		    TOP_maskmovq, 0x000000ff,
                    TOP_extrq,   0x000000ff,
                    TOP_insertq,   0x000000ff,

                    TOP_blcfill32,      0x000000ff,
                    TOP_blcfillx32,     0x000000ff,
                    TOP_blcfillxx32,    0x000000ff,
                    TOP_blcfillxxx32,   0x000000ff,
                    TOP_blcfill64,      0x000000ff,
                    TOP_blcfillx64,     0x000000ff,
                    TOP_blcfillxx64,    0x000000ff,
                    TOP_blcfillxxx64,   0x000000ff,
                    TOP_blci32,         0x000000ff,
                    TOP_blcix32,        0x000000ff,
                    TOP_blcixx32,       0x000000ff,
                    TOP_blcixxx32,      0x000000ff,
                    TOP_blci64,         0x000000ff,
                    TOP_blcix64,        0x000000ff,
                    TOP_blcixx64,       0x000000ff,
                    TOP_blcixxx64,      0x000000ff,
                    TOP_blcic32,        0x000000ff,
                    TOP_blcicx32,       0x000000ff,
                    TOP_blcicxx32,      0x000000ff,
                    TOP_blcicxxx32,     0x000000ff,
                    TOP_blcic64,        0x000000ff,
                    TOP_blcicx64,       0x000000ff,
                    TOP_blcicxx64,      0x000000ff,
                    TOP_blcicxxx64,     0x000000ff,
                    TOP_blcmsk32,       0x000000ff,
                    TOP_blcmskx32,      0x000000ff,
                    TOP_blcmskxx32,     0x000000ff,
                    TOP_blcmskxxx32,    0x000000ff,
                    TOP_blcmsk64,       0x000000ff,
                    TOP_blcmskx64,      0x000000ff,
                    TOP_blcmskxx64,     0x000000ff,
                    TOP_blcmskxxx64,    0x000000ff,
                    TOP_blcs32,         0x000000ff,
                    TOP_blcsx32,        0x000000ff,
                    TOP_blcsxx32,       0x000000ff,
                    TOP_blcsxxx32,      0x000000ff,
                    TOP_blcs64,         0x000000ff,
                    TOP_blcsx64,        0x000000ff,
                    TOP_blcsxx64,       0x000000ff,
                    TOP_blcsxxx64,      0x000000ff,
                    TOP_blsfill32,      0x000000ff,
                    TOP_blsfillx32,     0x000000ff,
                    TOP_blsfillxx32,    0x000000ff,
                    TOP_blsfillxxx32,   0x000000ff,
                    TOP_blsfill64,      0x000000ff,
                    TOP_blsfillx64,     0x000000ff,
                    TOP_blsfillxx64,    0x000000ff,
                    TOP_blsfillxxx64,   0x000000ff,
                    TOP_blsic32,        0x000000ff,
                    TOP_blsicx32,       0x000000ff,
                    TOP_blsicxx32,      0x000000ff,
                    TOP_blsicxxx32,     0x000000ff,
                    TOP_blsic64,        0x000000ff,
                    TOP_blsicx64,       0x000000ff,
                    TOP_blsicxx64,      0x000000ff,
                    TOP_blsicxxx64,     0x000000ff,
                    TOP_t1mskc32,       0x000000ff,
                    TOP_t1mskcx32,      0x000000ff,
                    TOP_t1mskcxx32,     0x000000ff,
                    TOP_t1mskcxxx32,    0x000000ff,
                    TOP_t1mskc64,       0x000000ff,
                    TOP_t1mskcx64,      0x000000ff,
                    TOP_t1mskcxx64,     0x000000ff,
                    TOP_t1mskcxxx64,    0x000000ff,
                    TOP_tzmsk32,        0x000000ff,
                    TOP_tzmskx32,       0x000000ff,
                    TOP_tzmskxx32,      0x000000ff,
                    TOP_tzmskxxx32,     0x000000ff,
                    TOP_tzmsk64,        0x000000ff,
                    TOP_tzmskx64,       0x000000ff,
                    TOP_tzmskxx64,      0x000000ff,
                    TOP_tzmskxxx64,     0x000000ff,
		    TOP_bextr32,          0x000000ff,
                    TOP_bextrx32,         0x000000ff,
                    TOP_bextrxx32,                0x000000ff,
                    TOP_bextrxxx32,               0x000000ff,
                    TOP_bextr64,                0x000000ff,
                    TOP_bextrx64,               0x000000ff,
                    TOP_bextrxx64,              0x000000ff,
                    TOP_bextrxxx64,             0x000000ff,
                    TOP_bextri32,         0x000000ff,
                    TOP_bextrix32,                0x000000ff,
                    TOP_bextrixx32,               0x000000ff,
                    TOP_bextrixxx32,              0x000000ff,
                    TOP_bextri64,               0x000000ff,
                    TOP_bextrix64,              0x000000ff,
                    TOP_bextrixx64,             0x000000ff,
                    TOP_bextrixxx64,            0x000000ff,
                    TOP_andn32,           0x000000ff,
                    TOP_andnx32,          0x000000ff,
                    TOP_andnxx32,         0x000000ff,
                    TOP_andnxxx32,                0x000000ff,
                    TOP_andn64,         0x000000ff,
                    TOP_andnx64,                0x000000ff,
                    TOP_andnxx64,               0x000000ff,
                    TOP_andnxxx64,              0x000000ff,
                    TOP_blsi32,       0x000000ff,
                    TOP_blsix32,       0x000000ff,
                    TOP_blsixx32,       0x000000ff,
                    TOP_blsixxx32,       0x000000ff,
                    TOP_blsi64,       0x000000ff,
                    TOP_blsix64,       0x000000ff,
                    TOP_blsixx64,       0x000000ff,
                    TOP_blsixxx64,       0x000000ff,
                    TOP_blsmsk32,       0x000000ff,
                    TOP_blsmskx32,       0x000000ff,
                    TOP_blsmskxx32,       0x000000ff,
	             TOP_blsmskxxx32,       0x000000ff,
                    TOP_blsmsk64,       0x000000ff,
                    TOP_blsmskx64,       0x000000ff,
                    TOP_blsmskxx64,       0x000000ff,
                    TOP_blsmskxxx64,       0x000000ff,
                    TOP_blsr32,       0x000000ff,
                    TOP_blsrx32,       0x000000ff,
                    TOP_blsrxx32,       0x000000ff,
                    TOP_blsrxxx32,       0x000000ff,
                    TOP_blsr64,       0x000000ff,
                    TOP_blsrx64,       0x000000ff,
                    TOP_blsrxx64,       0x000000ff,
                    TOP_blsrxxx64,       0x000000ff,
                    TOP_lzcnt16,        0x000000ff,
                    TOP_lzcntx16,        0x000000ff,
                    TOP_lzcntxx16,        0x000000ff,
                    TOP_lzcntxxx16,        0x000000ff,
                    TOP_lzcnt32,        0x000000ff,
                    TOP_lzcntx32,        0x000000ff,
                    TOP_lzcntxx32,        0x000000ff,
                    TOP_lzcntxxx32,        0x000000ff,
                    TOP_lzcnt64,        0x000000ff,
                    TOP_lzcntx64,        0x000000ff,
                    TOP_lzcntxx64,        0x000000ff,
                    TOP_lzcntxxx64,        0x000000ff,
                    TOP_tzcnt16,        0x000000ff,
                    TOP_tzcntx16,        0x000000ff,
                    TOP_tzcntxx16,        0x000000ff,
                    TOP_tzcntxxx16,        0x000000ff,
                    TOP_tzcnt32,        0x000000ff,
                    TOP_tzcntx32,        0x000000ff,
                    TOP_tzcntxx32,        0x000000ff,
                    TOP_tzcntxxx32,        0x000000ff,
                    TOP_tzcnt64,        0x000000ff,
                    TOP_tzcntx64,        0x000000ff,
                    TOP_tzcntxx64,        0x000000ff,
                    TOP_tzcntxxx64,        0x000000ff,


		    TOP_vfmaddss,	0x000000ff,
                    TOP_vfmaddxss,	0x000000ff,
                    TOP_vfmaddxxss,	0x000000ff,
                    TOP_vfmaddxxxss,	0x000000ff,
                    TOP_vfmaddxrss,	0x000000ff,
                    TOP_vfmaddxxrss,	0x000000ff,
                    TOP_vfmaddxxxrss,	0x000000ff,
                    TOP_vfmaddsd,	0x000000ff,
                    TOP_vfmaddxsd,	0x000000ff,
                    TOP_vfmaddxxsd,	0x000000ff,
                    TOP_vfmaddxxxsd,	0x000000ff,
                    TOP_vfmaddxrsd,	0x000000ff,
                    TOP_vfmaddxxrsd,	0x000000ff,
                    TOP_vfmaddxxxrsd,	0x000000ff,
                    TOP_vfnmaddss,	0x000000ff,
                    TOP_vfnmaddxss,	0x000000ff,
                    TOP_vfnmaddxxss,	0x000000ff,
                    TOP_vfnmaddxxxss,	0x000000ff,
                    TOP_vfnmaddxrss,	0x000000ff,
                    TOP_vfnmaddxxrss,	0x000000ff,
                    TOP_vfnmaddxxxrss,	0x000000ff,
                    TOP_vfnmaddsd,	0x000000ff,
                    TOP_vfnmaddxsd,	0x000000ff,
                    TOP_vfnmaddxxsd,	0x000000ff,
                    TOP_vfnmaddxxxsd,	0x000000ff,
                    TOP_vfnmaddxrsd,	0x000000ff,
                    TOP_vfnmaddxxrsd,	0x000000ff,
                    TOP_vfnmaddxxxrsd,	0x000000ff,
                    TOP_vfmaddps,	0x000000ff,
                    TOP_vfmaddxps,	0x000000ff,
                    TOP_vfmaddxxps,	0x000000ff,
                    TOP_vfmaddxxxps,	0x000000ff,
                    TOP_vfmaddxrps,	0x000000ff,
                    TOP_vfmaddxxrps,	0x000000ff,
                    TOP_vfmaddxxxrps,	0x000000ff,
                    TOP_vfmaddpd,	0x000000ff,
                    TOP_vfmaddxpd,	0x000000ff,
                    TOP_vfmaddxxpd,	0x000000ff,
                    TOP_vfmaddxxxpd,	0x000000ff,
                    TOP_vfmaddxrpd,	0x000000ff,
                    TOP_vfmaddxxrpd,	0x000000ff,
                    TOP_vfmaddxxxrpd,	0x000000ff,
                    TOP_vfmaddsubps,	0x000000ff,
                    TOP_vfmaddsubxps,	0x000000ff,
                    TOP_vfmaddsubxxps,	0x000000ff,
                    TOP_vfmaddsubxxxps,	0x000000ff,
                    TOP_vfmaddsubxrps,	0x000000ff,
                    TOP_vfmaddsubxxrps,	0x000000ff,
                    TOP_vfmaddsubxxxrps,	0x000000ff,
                    TOP_vfmaddsubpd,	0x000000ff,
                    TOP_vfmaddsubxpd,	0x000000ff,
                    TOP_vfmaddsubxxpd,	0x000000ff,
                    TOP_vfmaddsubxxxpd,	0x000000ff,
                    TOP_vfmaddsubxrpd,	0x000000ff,
                    TOP_vfmaddsubxxrpd,	0x000000ff,
                    TOP_vfmaddsubxxxrpd,	0x000000ff,
                    TOP_vfnmaddps,	0x000000ff,
                    TOP_vfnmaddxps,	0x000000ff,
                    TOP_vfnmaddxxps,	0x000000ff,
                    TOP_vfnmaddxxxps,	0x000000ff,
                    TOP_vfnmaddxrps,	0x000000ff,
                    TOP_vfnmaddxxrps,	0x000000ff,
                    TOP_vfnmaddxxxrps,	0x000000ff,
                    TOP_vfnmaddpd,	0x000000ff,
                    TOP_vfnmaddxpd,	0x000000ff,
                    TOP_vfnmaddxxpd,	0x000000ff,
                    TOP_vfnmaddxxxpd,	0x000000ff,
                    TOP_vfnmaddxrpd,	0x000000ff,
                    TOP_vfnmaddxxrpd,	0x000000ff,
                    TOP_vfnmaddxxxrpd,	0x000000ff,
		    TOP_vfmsubss,	0x000000ff,
                    TOP_vfmsubxss,	0x000000ff,
                    TOP_vfmsubxxss,	0x000000ff,
                    TOP_vfmsubxxxss,	0x000000ff,
                    TOP_vfmsubxrss,	0x000000ff,
                    TOP_vfmsubxxrss,	0x000000ff,
                    TOP_vfmsubxxxrss,	0x000000ff,
                    TOP_vfmsubsd,	0x000000ff,
                    TOP_vfmsubxsd,	0x000000ff,
                    TOP_vfmsubxxsd,	0x000000ff,
                    TOP_vfmsubxxxsd,	0x000000ff,
                    TOP_vfmsubxrsd,	0x000000ff,
                    TOP_vfmsubxxrsd,	0x000000ff,
                    TOP_vfmsubxxxrsd,	0x000000ff,
                    TOP_vfnmsubss,	0x000000ff,
                    TOP_vfnmsubxss,	0x000000ff,
                    TOP_vfnmsubxxss,	0x000000ff,
                    TOP_vfnmsubxxxss,	0x000000ff,
                    TOP_vfnmsubxrss,	0x000000ff,
                    TOP_vfnmsubxxrss,	0x000000ff,
                    TOP_vfnmsubxxxrss,	0x000000ff,
                    TOP_vfnmsubsd,	0x000000ff,
                    TOP_vfnmsubxsd,	0x000000ff,
                    TOP_vfnmsubxxsd,	0x000000ff,
                    TOP_vfnmsubxxxsd,	0x000000ff,
                    TOP_vfnmsubxrsd,	0x000000ff,
                    TOP_vfnmsubxxrsd,	0x000000ff,
                    TOP_vfnmsubxxxrsd,	0x000000ff,
                    TOP_vfmsubps,	0x000000ff,
                    TOP_vfmsubxps,	0x000000ff,
                    TOP_vfmsubxxps,	0x000000ff,
                    TOP_vfmsubxxxps,	0x000000ff,
                    TOP_vfmsubxrps,	0x000000ff,
                    TOP_vfmsubxxrps,	0x000000ff,
                    TOP_vfmsubxxxrps,	0x000000ff,
                    TOP_vfmsubpd,	0x000000ff,
                    TOP_vfmsubxpd,	0x000000ff,
                    TOP_vfmsubxxpd,	0x000000ff,
                    TOP_vfmsubxxxpd,	0x000000ff,
                    TOP_vfmsubxrpd,	0x000000ff,
                    TOP_vfmsubxxrpd,	0x000000ff,
                    TOP_vfmsubxxxrpd,	0x000000ff,
                    TOP_vfmsubaddps,	0x000000ff,
                    TOP_vfmsubaddxps,	0x000000ff,
                    TOP_vfmsubaddxxps,	0x000000ff,
                    TOP_vfmsubaddxxxps,	0x000000ff,
                    TOP_vfmsubaddxrps,	0x000000ff,
                    TOP_vfmsubaddxxrps,	0x000000ff,
                    TOP_vfmsubaddxxxrps,	0x000000ff,
                    TOP_vfmsubaddpd,	0x000000ff,
                    TOP_vfmsubaddxpd,	0x000000ff,
                    TOP_vfmsubaddxxpd,	0x000000ff,
                    TOP_vfmsubaddxxxpd,	0x000000ff,
                    TOP_vfmsubaddxrpd,	0x000000ff,
                    TOP_vfmsubaddxxrpd,	0x000000ff,
                    TOP_vfmsubaddxxxrpd,	0x000000ff,
                    TOP_vfnmsubps,	0x000000ff,
                    TOP_vfnmsubxps,	0x000000ff,
                    TOP_vfnmsubxxps,	0x000000ff,
                    TOP_vfnmsubxxxps,	0x000000ff,
                    TOP_vfnmsubxrps,	0x000000ff,
                    TOP_vfnmsubxxrps,	0x000000ff,
                    TOP_vfnmsubxxxrps,	0x000000ff,
                    TOP_vfnmsubpd,	0x000000ff,
                    TOP_vfnmsubxpd,	0x000000ff,
                    TOP_vfnmsubxxpd,	0x000000ff,
                    TOP_vfnmsubxxxpd,	0x000000ff,
                    TOP_vfnmsubxrpd,	0x000000ff,
                    TOP_vfnmsubxxrpd,	0x000000ff,
                    TOP_vfnmsubxxxrpd,	0x000000ff,
                    TOP_vzeroupper,	0x000000ff,
                    /* SSE3 instructions */
                    TOP_monitor,        0x000000ff,
                    TOP_mwait,          0x000000ff,
                    /* SSSE3 instructions */
                    TOP_pabs128v8,      0x000000ff,
                    TOP_pabsx128v8,     0x000000ff,
                    TOP_pabsxx128v8,    0x000000ff,
                    TOP_pabsxxx128v8,   0x000000ff,
                    TOP_pabs128v16,     0x000000ff,
                    TOP_pabsx128v16,    0x000000ff,
                    TOP_pabsxx128v16,   0x000000ff,
                    TOP_pabsxxx128v16,  0x000000ff,
                    TOP_pabs128v32,     0x000000ff,
                    TOP_pabsx128v32,    0x000000ff,
                    TOP_pabsxx128v32,   0x000000ff,
                    TOP_pabsxxx128v32,  0x000000ff,
                    TOP_psign128v8,     0x000000ff,
                    TOP_psignx128v8,    0x000000ff,
                    TOP_psignxx128v8,   0x000000ff,
                    TOP_psignxxx128v8,  0x000000ff,
                    TOP_psign128v16,    0x000000ff,
                    TOP_psignx128v16,   0x000000ff,
                    TOP_psignxx128v16,  0x000000ff,
                    TOP_psignxxx128v16, 0x000000ff,
                    TOP_psign128v32,    0x000000ff,
                    TOP_psignx128v32,   0x000000ff,
                    TOP_psignxx128v32,  0x000000ff,
                    TOP_psignxxx128v32, 0x000000ff,
                    TOP_pshuf128v8,     0x000000ff,
                    TOP_pshufx128v8,    0x000000ff,
                    TOP_pshufxx128v8,   0x000000ff,
                    TOP_pshufxxx128v8,  0x000000ff,
                    TOP_phsub128v16,    0x000000ff,
                    TOP_phsubx128v16,   0x000000ff,
                    TOP_phsubxx128v16,  0x000000ff,
                    TOP_phsubxxx128v16, 0x000000ff,
                    TOP_phsub128v32,    0x000000ff,
                    TOP_phsubx128v32,   0x000000ff,
                    TOP_phsubxx128v32,  0x000000ff,
                    TOP_phsubxxx128v32, 0x000000ff,
                    TOP_phsubs128v16,   0x000000ff,
                    TOP_phsubsx128v16,  0x000000ff,
                    TOP_phsubsxx128v16, 0x000000ff,
                    TOP_phsubsxxx128v16,        0x000000ff,
                    TOP_phadd128v16,    0x000000ff,
                    TOP_phaddx128v16,   0x000000ff,
                    TOP_phaddxx128v16,  0x000000ff,
                    TOP_phaddxxx128v16, 0x000000ff,
                    TOP_phadd128v32,    0x000000ff,
                    TOP_phaddx128v32,   0x000000ff,
                    TOP_phaddxx128v32,  0x000000ff,
                    TOP_phaddxxx128v32, 0x000000ff,
                    TOP_phadds128v16,   0x000000ff,
                    TOP_phaddsx128v16,  0x000000ff,
                    TOP_phaddsxx128v16, 0x000000ff,
                    TOP_phaddsxxx128v16,        0x000000ff,
                    TOP_pmulhrsw128,     0x000000ff,
                    TOP_pmulhrswx128,    0x000000ff,
                    TOP_pmulhrswxx128,   0x000000ff,
                    TOP_pmulhrswxxx128,  0x000000ff,
                    TOP_pmaddubsw128,    0x000000ff,
                    TOP_pmaddubswx128,   0x000000ff,
                    TOP_pmaddubswxx128,  0x000000ff,
                    TOP_pmaddubswxxx128, 0x000000ff,
                    TOP_palignr128,     0x000000ff,
                    TOP_palignrx128,    0x000000ff,
                    TOP_palignrxx128,   0x000000ff,
                    TOP_palignrxxx128,  0x000000ff,
                    /* SSE4.1 instructions */
                    TOP_muldq,  0x000000ff,
                    TOP_muldqx, 0x000000ff,
                    TOP_muldqxx,        0x000000ff,
                    TOP_muldqxxx,       0x000000ff,
                    TOP_ldntdqa,        0x000000ff,
                    TOP_ldntdqax,       0x000000ff,
                    TOP_ldntdqaxx,      0x000000ff,
                    TOP_stntdq,         0x000000ff,
                    TOP_stntdqx,        0x000000ff,
                    TOP_stntdqxx,       0x000000ff,
                    TOP_minu128v8,      0x000000ff,
                    TOP_minux128v8,     0x000000ff,
                    TOP_minuxx128v8,    0x000000ff,
                    TOP_minuxxx128v8,   0x000000ff,
                    TOP_mins128v8,      0x000000ff,
                    TOP_minsx128v8,     0x000000ff,
                    TOP_minsxx128v8,    0x000000ff,
                    TOP_minsxxx128v8,   0x000000ff,
                    TOP_maxu128v8,      0x000000ff,
                    TOP_maxux128v8,     0x000000ff,
                    TOP_maxuxx128v8,    0x000000ff,
                    TOP_maxuxxx128v8,   0x000000ff,
                    TOP_maxs128v8,      0x000000ff,
                    TOP_maxsx128v8,     0x000000ff,
                    TOP_maxsxx128v8,    0x000000ff,
                    TOP_maxsxxx128v8,   0x000000ff,
                    TOP_minu128v16,     0x000000ff,
                    TOP_minux128v16,    0x000000ff,
                    TOP_minuxx128v16,   0x000000ff,
                    TOP_minuxxx128v16,  0x000000ff,
                    TOP_mins128v16,     0x000000ff,
                    TOP_minsx128v16,    0x000000ff,
                    TOP_minsxx128v16,   0x000000ff,
                    TOP_minsxxx128v16,  0x000000ff,
                    TOP_maxu128v16,     0x000000ff,
                    TOP_maxux128v16,    0x000000ff,
                    TOP_maxuxx128v16,   0x000000ff,
                    TOP_maxuxxx128v16,  0x000000ff,
                    TOP_maxs128v16,     0x000000ff,
                    TOP_maxsx128v16,    0x000000ff,
                    TOP_maxsxx128v16,   0x000000ff,
                    TOP_maxsxxx128v16,  0x000000ff,
                    TOP_minu128v32,     0x000000ff,
                    TOP_minux128v32,    0x000000ff,
                    TOP_minuxx128v32,   0x000000ff,
                    TOP_minuxxx128v32,  0x000000ff,
                    TOP_maxu128v32,     0x000000ff,
                    TOP_maxux128v32,    0x000000ff,
                    TOP_maxuxx128v32,   0x000000ff,
                    TOP_maxuxxx128v32,  0x000000ff,
                    TOP_mins128v32,     0x000000ff,
                    TOP_minsx128v32,    0x000000ff,
                    TOP_minsxx128v32,   0x000000ff,
                    TOP_minsxxx128v32,  0x000000ff,
                    TOP_maxs128v32,     0x000000ff,
                    TOP_maxsx128v32,    0x000000ff,
                    TOP_maxsxx128v32,   0x000000ff,
                    TOP_maxsxxx128v32,  0x000000ff,
                    TOP_pmovsxbw,       0x000000ff,
                    TOP_pmovsxbwx,      0x000000ff,
                    TOP_pmovsxbwxx,     0x000000ff,
                    TOP_pmovsxbwxxx,    0x000000ff,
                    TOP_pmovzxbw,       0x000000ff,
                    TOP_pmovzxbwx,      0x000000ff,
                    TOP_pmovzxbwxx,     0x000000ff,
                    TOP_pmovzxbwxxx,    0x000000ff,
                    TOP_pmovsxbd,       0x000000ff,
                    TOP_pmovsxbdx,      0x000000ff,
                    TOP_pmovsxbdxx,     0x000000ff,
                    TOP_pmovsxbdxxx,    0x000000ff,
                    TOP_pmovzxbd,       0x000000ff,
                    TOP_pmovzxbdx,      0x000000ff,
                    TOP_pmovzxbdxx,     0x000000ff,
                    TOP_pmovzxbdxxx,    0x000000ff,
                    TOP_pmovsxbq,       0x000000ff,
                    TOP_pmovsxbqx,      0x000000ff,
                    TOP_pmovsxbqxx,     0x000000ff,
                    TOP_pmovsxbqxxx,    0x000000ff,
                    TOP_pmovzxbq,       0x000000ff,
                    TOP_pmovzxbqx,      0x000000ff,
                    TOP_pmovzxbqxx,     0x000000ff,
                    TOP_pmovzxbqxxx,    0x000000ff,
                    TOP_pmovsxwd,       0x000000ff,
                    TOP_pmovsxwdx,      0x000000ff,
                    TOP_pmovsxwdxx,     0x000000ff,
                    TOP_pmovsxwdxxx,    0x000000ff,
                    TOP_pmovzxwd,       0x000000ff,
                    TOP_pmovzxwdx,      0x000000ff,
                    TOP_pmovzxwdxx,     0x000000ff,
                    TOP_pmovzxwdxxx,    0x000000ff,
                    TOP_pmovsxwq,       0x000000ff,
                    TOP_pmovsxwqx,      0x000000ff,
                    TOP_pmovsxwqxx,     0x000000ff,
                    TOP_pmovsxwqxxx,    0x000000ff,
                    TOP_pmovzxwq,       0x000000ff,
                    TOP_pmovzxwqx,      0x000000ff,
                    TOP_pmovzxwqxx,     0x000000ff,
                    TOP_pmovzxwqxxx,    0x000000ff,
                    TOP_pmovsxdq,       0x000000ff,
                    TOP_pmovsxdqx,      0x000000ff,
                    TOP_pmovsxdqxx,     0x000000ff,
                    TOP_pmovsxdqxxx,    0x000000ff,
                    TOP_pmovzxdq,       0x000000ff,
                    TOP_pmovzxdqx,      0x000000ff,
                    TOP_pmovzxdqxx,     0x000000ff,
                    TOP_pmovzxdqxxx,    0x000000ff,
                    TOP_mul128v32,      0x000000ff,
                    TOP_mulx128v32,     0x000000ff,
                    TOP_mulxx128v32,    0x000000ff,
                    TOP_mulxxx128v32,   0x000000ff,
                    TOP_cmpeq128v64,    0x000000ff,
                    TOP_cmpeqx128v64,   0x000000ff,
                    TOP_cmpeqxx128v64,  0x000000ff,
                    TOP_cmpeqxxx128v64, 0x000000ff,
                    TOP_packusdw,       0x000000ff,
                    TOP_packusdwx,      0x000000ff,
                    TOP_packusdwxx,     0x000000ff,
                    TOP_packusdwxxx,    0x000000ff,
                    TOP_phminposuw,     0x000000ff,
                    TOP_phminposuwx,    0x000000ff,
                    TOP_phminposuwxx,   0x000000ff,
                    TOP_phminposuwxxx,  0x000000ff,
                    TOP_ptest128,       0x000000ff,
                    TOP_ptestx128,      0x000000ff,
                    TOP_ptestxx128,     0x000000ff,
                    TOP_ptestxxx128,    0x000000ff,
                    TOP_roundsd,        0x000000ff,
                    TOP_roundxsd,       0x000000ff,
                    TOP_roundxxsd,      0x000000ff,
                    TOP_roundxxxsd,     0x000000ff,
                    TOP_mpsadbw,        0x000000ff,
                    TOP_mpsadbwx,       0x000000ff,
                    TOP_mpsadbwxx,      0x000000ff,
                    TOP_mpsadbwxxx,     0x000000ff,
                    TOP_insr128v8,      0x000000ff,
                    TOP_insrx128v8,     0x000000ff,
                    TOP_insrxx128v8,    0x000000ff,
                    TOP_insrxxx128v8,   0x000000ff,
                    TOP_insr128v16,     0x000000ff,
                    TOP_insrx128v16,    0x000000ff,
                    TOP_insrxx128v16,   0x000000ff,
                    TOP_insrxxx128v16,  0x000000ff,
                    TOP_insr128v32,     0x000000ff,
                    TOP_insrx128v32,    0x000000ff,
                    TOP_insrxx128v32,   0x000000ff,
                    TOP_insrxxx128v32,  0x000000ff,
                    TOP_insr128v64,     0x000000ff,
                    TOP_insrx128v64,    0x000000ff,
                    TOP_insrxx128v64,   0x000000ff,
                    TOP_insrxxx128v64,  0x000000ff,
                    TOP_extr128v8,      0x000000ff,
                    TOP_extrx128v8,     0x000000ff,
                    TOP_extrxx128v8,    0x000000ff,
                    TOP_extrxxx128v8,   0x000000ff,
                    TOP_extr128v16,     0x000000ff,
                    TOP_extrx128v16,    0x000000ff,
                    TOP_extrxx128v16,   0x000000ff,
                    TOP_extrxxx128v16,  0x000000ff,
                    TOP_extr128v32,     0x000000ff,
                    TOP_extrx128v32,    0x000000ff,
                    TOP_extrxx128v32,   0x000000ff,
                    TOP_extrxxx128v32,  0x000000ff,
                    TOP_extr128v64,     0x000000ff,
                    TOP_extrx128v64,    0x000000ff,
                    TOP_extrxx128v64,   0x000000ff,
                    TOP_extrxxx128v64,  0x000000ff,
                    TOP_finsr128v32,    0x000000ff,
                    TOP_finsrx128v32,   0x000000ff,
                    TOP_finsrxx128v32,  0x000000ff,
                    TOP_finsrxxx128v32, 0x000000ff,
                    TOP_fextr128v32,    0x000000ff,
                    TOP_fextrx128v32,   0x000000ff,
                    TOP_fextrxx128v32,  0x000000ff,
                    TOP_fextrxxx128v32, 0x000000ff,
                    TOP_fblendv128v32,  0x000000ff,
                    TOP_fblendvx128v32, 0x000000ff,
                    TOP_fblendvxx128v32,        0x000000ff,
                    TOP_fblendvxxx128v32,       0x000000ff,
                    TOP_fblendv128v64,  0x000000ff,
                    TOP_fblendvx128v64, 0x000000ff,
                    TOP_fblendvxx128v64,        0x000000ff,
                    TOP_fblendvxxx128v64,       0x000000ff,
                    TOP_blendv128v8,    0x000000ff,
                    TOP_blendvx128v8,   0x000000ff,
                    TOP_blendvxx128v8,  0x000000ff,
                    TOP_blendvxxx128v8, 0x000000ff,
                    TOP_round128v32,    0x000000ff,
                    TOP_roundx128v32,   0x000000ff,
                    TOP_roundxx128v32,  0x000000ff,
                    TOP_roundxxx128v32, 0x000000ff,
                    TOP_roundss,        0x000000ff,
                    TOP_roundxss,       0x000000ff,
                    TOP_roundxxss,      0x000000ff,
                    TOP_roundxxxss,     0x000000ff,
                    TOP_fblend128v64,   0x000000ff,
                    TOP_fblendx128v64,  0x000000ff,
                    TOP_fblendxx128v64, 0x000000ff,
                    TOP_fblendxxx128v64,        0x000000ff,
                    TOP_blend128v16,    0x000000ff,
                    TOP_blendx128v16,   0x000000ff,
                    TOP_blendxx128v16,  0x000000ff,
                    TOP_blendxxx128v16, 0x000000ff,
                    TOP_fdp128v32,      0x000000ff,
                    TOP_fdpx128v32,     0x000000ff,
                    TOP_fdpxx128v32,    0x000000ff,
                    TOP_fdpxxx128v32,   0x000000ff,
                    TOP_fdp128v64,      0x000000ff,
                    TOP_fdpx128v64,     0x000000ff,
                    TOP_fdpxx128v64,    0x000000ff,
                    TOP_fdpxxx128v64,   0x000000ff,
                    TOP_round128v64,    0x000000ff,
                    TOP_roundx128v64,   0x000000ff,
                    TOP_roundxx128v64,  0x000000ff,
                    TOP_roundxxx128v64, 0x000000ff,
                    TOP_fblend128v32,   0x000000ff,
                    TOP_fblendx128v32,  0x000000ff,
                    TOP_fblendxx128v32, 0x000000ff,
                    TOP_fblendxxx128v32,        0x000000ff,
                    /* SSE4.2 instructions */
                    TOP_cmpgt128v64,    0x000000ff,
                    TOP_cmpgtx128v64,   0x000000ff,
                    TOP_cmpgtxx128v64,  0x000000ff,
                    TOP_cmpgtxxx128v64, 0x000000ff,
                    TOP_crc32w, 0x000000ff,
                    TOP_crc32wx,        0x000000ff,
                    TOP_crc32wxx,       0x000000ff,
                    TOP_crc32wxxx,      0x000000ff,
                    TOP_crc32d, 0x000000ff,
                    TOP_crc32dx,        0x000000ff,
                    TOP_crc32dxx,       0x000000ff,
                    TOP_crc32dxxx,      0x000000ff,
                    TOP_crc32q, 0x000000ff,
                    TOP_crc32qx,        0x000000ff,
                    TOP_crc32qxx,       0x000000ff,
                    TOP_crc32qxxx,      0x000000ff,
                    TOP_crc32b, 0x000000ff,
                    TOP_crc32bx,        0x000000ff,
                    TOP_crc32bxx,       0x000000ff,
                    TOP_crc32bxxx,      0x000000ff,
                    TOP_cmpestrm,       0x000000ff,
                    TOP_cmpestrmx,      0x000000ff,
                    TOP_cmpestrmxx,     0x000000ff,
                    TOP_cmpestrmxxx,    0x000000ff,
                    TOP_cmpestri,       0x000000ff,
                    TOP_cmpestrix,      0x000000ff,
                    TOP_cmpestrixx,     0x000000ff,
                    TOP_cmpestrixxx,    0x000000ff,
                    TOP_cmpistrm,       0x000000ff,
                    TOP_cmpistrmx,      0x000000ff,
                    TOP_cmpistrmxx,     0x000000ff,
                    TOP_cmpistrmxxx,    0x000000ff,
                    TOP_cmpistri,       0x000000ff,
                    TOP_cmpistrix,      0x000000ff,
                    TOP_cmpistrixx,     0x000000ff,
                    TOP_cmpistrixxx,    0x000000ff,
                    TOP_popcnt16,       0x000000ff,
                    TOP_popcntx16,      0x000000ff,
                    TOP_popcntxx16,     0x000000ff,
                    TOP_popcntxxx16,    0x000000ff,
                    TOP_popcnt32,       0x000000ff,
                    TOP_popcntx32,      0x000000ff,
                    TOP_popcntxx32,     0x000000ff,
                    TOP_popcntxxx32,    0x000000ff,
                    TOP_popcnt64,       0x000000ff,
                    TOP_popcntx64,      0x000000ff,
                    TOP_popcntxx64,     0x000000ff,
                    TOP_popcntxxx64,    0x000000ff,
                    /* AES instructions */
                    TOP_aesimc,        0x000000ff,
                    TOP_aesimcx,       0x000000ff,
                    TOP_aesimcxx,      0x000000ff,
                    TOP_aesimcxxx,     0x000000ff,
                    TOP_aeskeygenassist,       0x000000ff,
                    TOP_aeskeygenassistx,      0x000000ff,
                    TOP_aeskeygenassistxx,     0x000000ff,
                    TOP_aeskeygenassistxxx,    0x000000ff,
                    TOP_aesenc,        0x000000ff,
                    TOP_aesencx,       0x000000ff,
                    TOP_aesencxx,      0x000000ff,
                    TOP_aesencxxx,     0x000000ff,
                    TOP_aesenclast,    0x000000ff,
                    TOP_aesenclastx,   0x000000ff,
                    TOP_aesenclastxx,  0x000000ff,
                    TOP_aesenclastxxx, 0x000000ff,
                    TOP_aesdec,        0x000000ff,
                    TOP_aesdecx,       0x000000ff,
                    TOP_aesdecxx,      0x000000ff,
                    TOP_aesdecxxx,     0x000000ff,
                    TOP_aesdeclast,    0x000000ff,
                    TOP_aesdeclastx,   0x000000ff,
                    TOP_aesdeclastxx,  0x000000ff,
                    TOP_aesdeclastxxx, 0x000000ff,
                    TOP_pclmulqdq,     0x000000ff,
                    TOP_pclmulqdqx,    0x000000ff,
                    TOP_pclmulqdqxx,   0x000000ff,
                    TOP_pclmulqdqxxx,  0x000000ff,
                    /* XOP instructions */
                    TOP_vphaddbd,       0x000000ff,
                    TOP_vphaddbdx,      0x000000ff,
                    TOP_vphaddbdxx,     0x000000ff,
                    TOP_vphaddbdxxx,    0x000000ff,
                    TOP_vphaddbq,       0x000000ff,
                    TOP_vphaddbqx,      0x000000ff,
                    TOP_vphaddbqxx,     0x000000ff,
                    TOP_vphaddbqxxx,    0x000000ff,
                    TOP_vphaddbw,       0x000000ff,
                    TOP_vphaddbwx,      0x000000ff,
                    TOP_vphaddbwxx,     0x000000ff,
                    TOP_vphaddbwxxx,    0x000000ff,
                    TOP_vphadddq,       0x000000ff,
                    TOP_vphadddqx,      0x000000ff,
                    TOP_vphadddqxx,     0x000000ff,
                    TOP_vphadddqxxx,    0x000000ff,
                    TOP_vphaddubd,      0x000000ff,
                    TOP_vphaddubdx,     0x000000ff,
                    TOP_vphaddubdxx,    0x000000ff,
                    TOP_vphaddubdxxx,   0x000000ff,
                    TOP_vphaddubq,      0x000000ff,
                    TOP_vphaddubqx,     0x000000ff,
                    TOP_vphaddubqxx,    0x000000ff,
                    TOP_vphaddubqxxx,   0x000000ff,
                    TOP_vphaddubw,      0x000000ff,
                    TOP_vphaddubwx,     0x000000ff,
                    TOP_vphaddubwxx,    0x000000ff,
                    TOP_vphaddubwxxx,   0x000000ff,
                    TOP_vphaddudq,      0x000000ff,
                    TOP_vphaddudqx,     0x000000ff,
                    TOP_vphaddudqxx,    0x000000ff,
                    TOP_vphaddudqxxx,   0x000000ff,
                    TOP_vphadduwd,      0x000000ff,
                    TOP_vphadduwdx,     0x000000ff,
                    TOP_vphadduwdxx,    0x000000ff,
                    TOP_vphadduwdxxx,   0x000000ff,
                    TOP_vphadduwq,      0x000000ff,
                    TOP_vphadduwqx,     0x000000ff,
                    TOP_vphadduwqxx,    0x000000ff,
                    TOP_vphadduwqxxx,   0x000000ff,
                    TOP_vphaddwd,       0x000000ff,
                    TOP_vphaddwdx,      0x000000ff,
                    TOP_vphaddwdxx,     0x000000ff,
                    TOP_vphaddwdxxx,    0x000000ff,
                    TOP_vphaddwq,       0x000000ff,
                    TOP_vphaddwqx,      0x000000ff,
                    TOP_vphaddwqxx,     0x000000ff,
                    TOP_vphaddwqxxx,    0x000000ff,
                    TOP_vphsubbw,       0x000000ff,
                    TOP_vphsubbwx,      0x000000ff,
                    TOP_vphsubbwxx,     0x000000ff,
                    TOP_vphsubbwxxx,    0x000000ff,
                    TOP_vphsubdq,       0x000000ff,
                    TOP_vphsubdqx,      0x000000ff,
                    TOP_vphsubdqxx,     0x000000ff,
                    TOP_vphsubdqxxx,    0x000000ff,
                    TOP_vphsubwd,       0x000000ff,
                    TOP_vphsubwdx,      0x000000ff,
                    TOP_vphsubwdxx,     0x000000ff,
                    TOP_vphsubwdxxx,    0x000000ff,
                    TOP_vfrczpd,        0x000000ff,
                    TOP_vfrczpdx,       0x000000ff,
                    TOP_vfrczpdxx,      0x000000ff,
                    TOP_vfrczpdxxx,     0x000000ff,
                    TOP_vfrczps,        0x000000ff,
                    TOP_vfrczpsx,       0x000000ff,
                    TOP_vfrczpsxx,      0x000000ff,
                    TOP_vfrczpsxxx,     0x000000ff,
                    TOP_vfrczsd,        0x000000ff,
                    TOP_vfrczsdx,       0x000000ff,
                    TOP_vfrczsdxx,      0x000000ff,
                    TOP_vfrczsdxxx,     0x000000ff,
                    TOP_vfrczss,        0x000000ff,
                    TOP_vfrczssx,       0x000000ff,
                    TOP_vfrczssxx,      0x000000ff,
                    TOP_vfrczssxxx,     0x000000ff,
                    TOP_vprotbi,        0x000000ff,
                    TOP_vprotbix,       0x000000ff,
                    TOP_vprotbixx,      0x000000ff,
                    TOP_vprotbixxx,     0x000000ff,
                    TOP_vprotdi,        0x000000ff,
                    TOP_vprotdix,       0x000000ff,
                    TOP_vprotdixx,      0x000000ff,
                    TOP_vprotdixxx,     0x000000ff,
                    TOP_vprotqi,        0x000000ff,
                    TOP_vprotqix,       0x000000ff,
                    TOP_vprotqixx,      0x000000ff,
                    TOP_vprotqixxx,     0x000000ff,
                    TOP_vprotwi,        0x000000ff,
                    TOP_vprotwix,       0x000000ff,
                    TOP_vprotwixx,      0x000000ff,
                    TOP_vprotwixxx,     0x000000ff,
                    TOP_vpcomb, 0x000000ff,
                    TOP_vpcombx,        0x000000ff,
                    TOP_vpcombxx,       0x000000ff,
                    TOP_vpcombxxx,      0x000000ff,
                    TOP_vpcomd, 0x000000ff,
                    TOP_vpcomdx,        0x000000ff,
                    TOP_vpcomdxx,       0x000000ff,
                    TOP_vpcomdxxx,      0x000000ff,
                    TOP_vpcomq, 0x000000ff,
                    TOP_vpcomqx,        0x000000ff,
                    TOP_vpcomqxx,       0x000000ff,
                    TOP_vpcomqxxx,      0x000000ff,
                    TOP_vpcomw, 0x000000ff,
                    TOP_vpcomwx,        0x000000ff,
                    TOP_vpcomwxx,       0x000000ff,
                    TOP_vpcomwxxx,      0x000000ff,
                    TOP_vpcomub,        0x000000ff,
                    TOP_vpcomubx,       0x000000ff,
                    TOP_vpcomubxx,      0x000000ff,
                    TOP_vpcomubxxx,     0x000000ff,
                    TOP_vpcomud,        0x000000ff,
                    TOP_vpcomudx,       0x000000ff,
                    TOP_vpcomudxx,      0x000000ff,
                    TOP_vpcomudxxx,     0x000000ff,
                    TOP_vpcomuq,        0x000000ff,
                    TOP_vpcomuqx,       0x000000ff,
                    TOP_vpcomuqxx,      0x000000ff,
                    TOP_vpcomuqxxx,     0x000000ff,
                    TOP_vpcomuw,        0x000000ff,
                    TOP_vpcomuwx,       0x000000ff,
                    TOP_vpcomuwxx,      0x000000ff,
                    TOP_vpcomuwxxx,     0x000000ff,
                    TOP_vpperm, 0x000000ff,
                    TOP_vppermx,        0x000000ff,
                    TOP_vppermxx,       0x000000ff,
                    TOP_vppermxxx,      0x000000ff,
                    TOP_vppermxr,       0x000000ff,
                    TOP_vppermxxr,      0x000000ff,
                    TOP_vppermxxxr,     0x000000ff,
                    TOP_vprotb, 0x000000ff,
                    TOP_vprotbx,        0x000000ff,
                    TOP_vprotbxx,       0x000000ff,
                    TOP_vprotbxxx,      0x000000ff,
                    TOP_vprotbxr,       0x000000ff,
                    TOP_vprotbxxr,      0x000000ff,
                    TOP_vprotbxxxr,     0x000000ff,
                    TOP_vprotd, 0x000000ff,
                    TOP_vprotdx,        0x000000ff,
                    TOP_vprotdxx,       0x000000ff,
                    TOP_vprotdxxx,      0x000000ff,
                    TOP_vprotdxr,       0x000000ff,
                    TOP_vprotdxxr,      0x000000ff,
                    TOP_vprotdxxxr,     0x000000ff,
                    TOP_vprotq, 0x000000ff,
                    TOP_vprotqx,        0x000000ff,
                    TOP_vprotqxx,       0x000000ff,
                    TOP_vprotqxxx,      0x000000ff,
                    TOP_vprotqxr,       0x000000ff,
                    TOP_vprotqxxr,      0x000000ff,
                    TOP_vprotqxxxr,     0x000000ff,
                    TOP_vprotw, 0x000000ff,
                    TOP_vprotwx,        0x000000ff,
                    TOP_vprotwxx,       0x000000ff,
                    TOP_vprotwxxx,      0x000000ff,
                    TOP_vprotwxr,       0x000000ff,
                    TOP_vprotwxxr,      0x000000ff,
                    TOP_vprotwxxxr,     0x000000ff,
                    TOP_vpshab, 0x000000ff,
                    TOP_vpshabx,        0x000000ff,
                    TOP_vpshabxx,       0x000000ff,
                    TOP_vpshabxxx,      0x000000ff,
                    TOP_vpshabxr,       0x000000ff,
                    TOP_vpshabxxr,      0x000000ff,
                    TOP_vpshabxxxr,     0x000000ff,
                    TOP_vpshad, 0x000000ff,
                    TOP_vpshadx,        0x000000ff,
                    TOP_vpshadxx,       0x000000ff,
                    TOP_vpshadxxx,      0x000000ff,
                    TOP_vpshadxr,       0x000000ff,
                    TOP_vpshadxxr,      0x000000ff,
                    TOP_vpshadxxxr,     0x000000ff,
                    TOP_vpshaq, 0x000000ff,
                    TOP_vpshaqx,        0x000000ff,
                    TOP_vpshaqxx,       0x000000ff,
                    TOP_vpshaqxxx,      0x000000ff,
                    TOP_vpshaqxr,       0x000000ff,
                    TOP_vpshaqxxr,      0x000000ff,
                    TOP_vpshaqxxxr,     0x000000ff,
                    TOP_vpshaw, 0x000000ff,
                    TOP_vpshawx,        0x000000ff,
                    TOP_vpshawxx,       0x000000ff,
                    TOP_vpshawxxx,      0x000000ff,
                    TOP_vpshawxr,       0x000000ff,
                    TOP_vpshawxxr,      0x000000ff,
                    TOP_vpshawxxxr,     0x000000ff,
                    TOP_vpshlb, 0x000000ff,
                    TOP_vpshlbx,        0x000000ff,
                    TOP_vpshlbxx,       0x000000ff,
                    TOP_vpshlbxxx,      0x000000ff,
                    TOP_vpshlbxr,       0x000000ff,
                    TOP_vpshlbxxr,      0x000000ff,
                    TOP_vpshlbxxxr,     0x000000ff,
                    TOP_vpshld, 0x000000ff,
                    TOP_vpshldx,        0x000000ff,
                    TOP_vpshldxx,       0x000000ff,
                    TOP_vpshldxxx,      0x000000ff,
                    TOP_vpshldxr,       0x000000ff,
                    TOP_vpshldxxr,      0x000000ff,
                    TOP_vpshldxxxr,     0x000000ff,
                    TOP_vpshlq, 0x000000ff,
                    TOP_vpshlqx,        0x000000ff,
                    TOP_vpshlqxx,       0x000000ff,
                    TOP_vpshlqxxx,      0x000000ff,
                    TOP_vpshlqxr,       0x000000ff,
                    TOP_vpshlqxxr,      0x000000ff,
                    TOP_vpshlqxxxr,     0x000000ff,
                    TOP_vpshlw, 0x000000ff,
                    TOP_vpshlwx,        0x000000ff,
                    TOP_vpshlwxx,       0x000000ff,
                    TOP_vpshlwxxx,      0x000000ff,
                    TOP_vpshlwxr,       0x000000ff,
                    TOP_vpshlwxxr,      0x000000ff,
                    TOP_vpshlwxxxr,     0x000000ff,
                    TOP_vpcmov, 0x000000ff,
                    TOP_vpcmovx,        0x000000ff,
                    TOP_vpcmovxx,       0x000000ff,
                    TOP_vpcmovxxx,      0x000000ff,
                    TOP_vpcmovxr,       0x000000ff,
                    TOP_vpcmovxxr,      0x000000ff,
                    TOP_vpcmovxxxr,     0x000000ff,
                    TOP_vpmacsdd,       0x000000ff,
                    TOP_vpmacsddx,      0x000000ff,
                    TOP_vpmacsddxx,     0x000000ff,
                    TOP_vpmacsddxxx,    0x000000ff,
                    TOP_vpmacsdqh,      0x000000ff,
                    TOP_vpmacsdqhx,     0x000000ff,
                    TOP_vpmacsdqhxx,    0x000000ff,
                    TOP_vpmacsdqhxxx,   0x000000ff,
                    TOP_vpmacsdql,      0x000000ff,
                    TOP_vpmacsdqlx,     0x000000ff,
                    TOP_vpmacsdqlxx,    0x000000ff,
                    TOP_vpmacsdqlxxx,   0x000000ff,
                    TOP_vpmacssdd,      0x000000ff,
                    TOP_vpmacssddx,     0x000000ff,
                    TOP_vpmacssddxx,    0x000000ff,
                    TOP_vpmacssddxxx,   0x000000ff,
                    TOP_vpmacssdqh,     0x000000ff,
                    TOP_vpmacssdqhx,    0x000000ff,
                    TOP_vpmacssdqhxx,   0x000000ff,
                    TOP_vpmacssdqhxxx,  0x000000ff,
                    TOP_vpmacssdql,     0x000000ff,
                    TOP_vpmacssdqlx,    0x000000ff,
                    TOP_vpmacssdqlxx,   0x000000ff,
                    TOP_vpmacssdqlxxx,  0x000000ff,
                    TOP_vpmacsswd,      0x000000ff,
                    TOP_vpmacsswdx,     0x000000ff,
                    TOP_vpmacsswdxx,    0x000000ff,
                    TOP_vpmacsswdxxx,   0x000000ff,
                    TOP_vpmacssww,      0x000000ff,
                    TOP_vpmacsswwx,     0x000000ff,
                    TOP_vpmacsswwxx,    0x000000ff,
                    TOP_vpmacsswwxxx,   0x000000ff,
                    TOP_vpmacswd,       0x000000ff,
                    TOP_vpmacswdx,      0x000000ff,
                    TOP_vpmacswdxx,     0x000000ff,
                    TOP_vpmacswdxxx,    0x000000ff,
                    TOP_vpmacsww,       0x000000ff,
                    TOP_vpmacswwx,      0x000000ff,
                    TOP_vpmacswwxx,     0x000000ff,
                    TOP_vpmacswwxxx,    0x000000ff,
                    TOP_vpmadcsswd,     0x000000ff,
                    TOP_vpmadcsswdx,    0x000000ff,
                    TOP_vpmadcsswdxx,   0x000000ff,
                    TOP_vpmadcsswdxxx,  0x000000ff,
                    TOP_vpmadcswd,      0x000000ff,
                    TOP_vpmadcswdx,     0x000000ff,
                    TOP_vpmadcswdxx,    0x000000ff,
                    TOP_vpmadcswdxxx,   0x000000ff,
                    /* AVX instructions */
                    TOP_vfadd128v64,    0x000000ff,
                    TOP_vfaddx128v64,   0x000000ff,
                    TOP_vfaddxx128v64,  0x000000ff,
                    TOP_vfaddxxx128v64, 0x000000ff,
                    TOP_vfadd128v32,    0x000000ff,
                    TOP_vfaddx128v32,   0x000000ff,
                    TOP_vfaddxx128v32,  0x000000ff,
                    TOP_vfaddxxx128v32, 0x000000ff,
                    TOP_vfaddsd,        0x000000ff,
                    TOP_vfaddxsd,       0x000000ff,
                    TOP_vfaddxxsd,      0x000000ff,
                    TOP_vfaddxxxsd,     0x000000ff,
                    TOP_vfaddss,        0x000000ff,
                    TOP_vfaddxss,       0x000000ff,
                    TOP_vfaddxxss,      0x000000ff,
                    TOP_vfaddxxxss,     0x000000ff,
                    TOP_vfaddsub128v64, 0x000000ff,
                    TOP_vfaddsubx128v64,        0x000000ff,
                    TOP_vfaddsubxx128v64,       0x000000ff,
                    TOP_vfaddsubxxx128v64,      0x000000ff,
                    TOP_vfaddsub128v32, 0x000000ff,
                    TOP_vfaddsubx128v32,        0x000000ff,
                    TOP_vfaddsubxx128v32,       0x000000ff,
                    TOP_vfaddsubxxx128v32,      0x000000ff,
                    TOP_vaesenc,        0x000000ff,
                    TOP_vaesencx,       0x000000ff,
                    TOP_vaesencxx,      0x000000ff,
                    TOP_vaesencxxx,     0x000000ff,
                    TOP_vaesenclast,    0x000000ff,
                    TOP_vaesenclastx,   0x000000ff,
                    TOP_vaesenclastxx,  0x000000ff,
                    TOP_vaesenclastxxx, 0x000000ff,
                    TOP_vaesdec,        0x000000ff,
                    TOP_vaesdecx,       0x000000ff,
                    TOP_vaesdecxx,      0x000000ff,
                    TOP_vaesdecxxx,     0x000000ff,
                    TOP_vaesdeclast,    0x000000ff,
                    TOP_vaesdeclastx,   0x000000ff,
                    TOP_vaesdeclastxx,  0x000000ff,
                    TOP_vaesdeclastxxx, 0x000000ff,
                    TOP_vaesimc,        0x000000ff,
                    TOP_vaesimcx,       0x000000ff,
                    TOP_vaesimcxx,      0x000000ff,
                    TOP_vaesimcxxx,     0x000000ff,
                    TOP_vaeskeygenassist,       0x000000ff,
                    TOP_vaeskeygenassistx,      0x000000ff,
                    TOP_vaeskeygenassistxx,     0x000000ff,
                    TOP_vaeskeygenassistxxx,    0x000000ff,
                    TOP_vandpd,         0x000000ff,
                    TOP_vfand128v64,    0x000000ff,
                    TOP_vfandx128v64,   0x000000ff,
                    TOP_vfandxx128v64,  0x000000ff,
                    TOP_vfandxxx128v64, 0x000000ff,
                    TOP_vandps,         0x000000ff,
                    TOP_vfand128v32,    0x000000ff,
                    TOP_vfandx128v32,   0x000000ff,
                    TOP_vfandxx128v32,  0x000000ff,
                    TOP_vfandxxx128v32, 0x000000ff,
                    TOP_vandnpd,        0x000000ff,
                    TOP_vfandn128v64,   0x000000ff,
                    TOP_vfandnx128v64,  0x000000ff,
                    TOP_vfandnxx128v64, 0x000000ff,
                    TOP_vfandnxxx128v64,        0x000000ff,
                    TOP_vandnps,        0x000000ff,
                    TOP_vfandn128v32,   0x000000ff,
                    TOP_vfandnx128v32,  0x000000ff,
                    TOP_vfandnxx128v32, 0x000000ff,
                    TOP_vfandnxxx128v32,        0x000000ff,
                    TOP_vfblend128v64,  0x000000ff,
                    TOP_vfblendx128v64, 0x000000ff,
                    TOP_vfblendxx128v64,        0x000000ff,
                    TOP_vfblendxxx128v64,       0x000000ff,
                    TOP_vfblend128v32,  0x000000ff,
                    TOP_vfblendx128v32, 0x000000ff,
                    TOP_vfblendxx128v32,        0x000000ff,
                    TOP_vfblendxxx128v32,       0x000000ff,
                    TOP_vfblendv128v64, 0x000000ff,
                    TOP_vfblendvx128v64,        0x000000ff,
                    TOP_vfblendvxx128v64,       0x000000ff,
                    TOP_vfblendvxxx128v64,      0x000000ff,
                    TOP_vfblendv128v32, 0x000000ff,
                    TOP_vfblendvx128v32,        0x000000ff,
                    TOP_vfblendvxx128v32,       0x000000ff,
                    TOP_vfblendvxxx128v32,      0x000000ff,
                    TOP_vfbroadcastss,  0x000000ff,
                    TOP_vfbroadcastxss, 0x000000ff,
                    TOP_vfbroadcastxxss,        0x000000ff,
                    TOP_vfbroadcastsd,  0x000000ff,
                    TOP_vfbroadcastxsd, 0x000000ff,
                    TOP_vfbroadcastxxsd,        0x000000ff,
                    TOP_vfbroadcastf128,        0x000000ff,
                    TOP_vfbroadcastxf128,       0x000000ff,
                    TOP_vfbroadcastxxf128,      0x000000ff,
                    TOP_vcmppd,         0x000000ff,
                    TOP_vfcmp128v64,    0x000000ff,
                    TOP_vfcmpx128v64,   0x000000ff,
                    TOP_vfcmpxx128v64,  0x000000ff,
                    TOP_vfcmpxxx128v64, 0x000000ff,
                    TOP_vcmpps,         0x000000ff,
                    TOP_vfcmp128v32,    0x000000ff,
                    TOP_vfcmpx128v32,   0x000000ff,
                    TOP_vfcmpxx128v32,  0x000000ff,
                    TOP_vfcmpxxx128v32, 0x000000ff,
                    TOP_vcmpeqpd,       0x000000ff,
                    TOP_vcmpltpd,       0x000000ff,
                    TOP_vcmplepd,       0x000000ff,
                    TOP_vcmpunordpd,    0x000000ff,
                    TOP_vcmpneqpd,      0x000000ff,
                    TOP_vcmpnltpd,      0x000000ff,
                    TOP_vcmpnlepd,      0x000000ff,
                    TOP_vcmpordpd,      0x000000ff,
                    TOP_vcmpeqps,       0x000000ff,
                    TOP_vcmpltps,       0x000000ff,
                    TOP_vcmpleps,       0x000000ff,
                    TOP_vcmpunordps,    0x000000ff,
                    TOP_vcmpneqps,      0x000000ff,
                    TOP_vcmpnltps,      0x000000ff,
                    TOP_vcmpnleps,      0x000000ff,
                    TOP_vcmpordps,      0x000000ff,
                    TOP_vcmpeqss,       0x000000ff,
                    TOP_vcmpltss,       0x000000ff,
                    TOP_vcmpless,       0x000000ff,
                    TOP_vcmpunordss,    0x000000ff,
                    TOP_vcmpneqss,      0x000000ff,
                    TOP_vcmpnltss,      0x000000ff,
                    TOP_vcmpnless,      0x000000ff,
                    TOP_vcmpordss,      0x000000ff,
                    TOP_vcmpeqsd,       0x000000ff,
                    TOP_vcmpltsd,       0x000000ff,
                    TOP_vcmplesd,       0x000000ff,
                    TOP_vcmpunordsd,    0x000000ff,
                    TOP_vcmpneqsd,      0x000000ff,
                    TOP_vcmpnltsd,      0x000000ff,
                    TOP_vcmpnlesd,      0x000000ff,
                    TOP_vcmpordsd,      0x000000ff,
                    TOP_vcmpsd,         0x000000ff,
                    TOP_vcmpxsd,        0x000000ff,
                    TOP_vcmpxxsd,       0x000000ff,
                    TOP_vcmpxxxsd,      0x000000ff,
                    TOP_vcmpss,         0x000000ff,
                    TOP_vcmpxss,        0x000000ff,
                    TOP_vcmpxxss,       0x000000ff,
                    TOP_vcmpxxxss,      0x000000ff,
                    TOP_vcomisd,        0x000000ff,
                    TOP_vcomixsd,       0x000000ff,
                    TOP_vcomixxsd,      0x000000ff,
                    TOP_vcomixxxsd,     0x000000ff,
                    TOP_vcomiss,        0x000000ff,
                    TOP_vcomixss,       0x000000ff,
                    TOP_vcomixxss,      0x000000ff,
                    TOP_vcomixxxss,     0x000000ff,
                    TOP_vcvtdq2pd,      0x000000ff,
                    TOP_vcvtdq2pdx,     0x000000ff,
                    TOP_vcvtdq2pdxx,    0x000000ff,
                    TOP_vcvtdq2pdxxx,   0x000000ff,
                    TOP_vcvtdq2ps,      0x000000ff,
                    TOP_vcvtdq2psx,     0x000000ff,
                    TOP_vcvtdq2psxx,    0x000000ff,
                    TOP_vcvtdq2psxxx,   0x000000ff,
                    TOP_vcvtpd2dq,      0x000000ff,
                    TOP_vcvtpd2dqx,     0x000000ff,
                    TOP_vcvtpd2dqxx,    0x000000ff,
                    TOP_vcvtpd2dqxxx,   0x000000ff,
                    TOP_vcvtpd2dqy,     0x000000ff,
                    TOP_vcvtpd2dqyx,    0x000000ff,
                    TOP_vcvtpd2dqyxx,   0x000000ff,
                    TOP_vcvtpd2dqyxxx,  0x000000ff,
                    TOP_vcvtpd2ps,      0x000000ff,
                    TOP_vcvtpd2psx,     0x000000ff,
                    TOP_vcvtpd2psxx,    0x000000ff,
                    TOP_vcvtpd2psxxx,   0x000000ff,
                    TOP_vcvtpd2psy,     0x000000ff,
                    TOP_vcvtpd2psyx,    0x000000ff,
                    TOP_vcvtpd2psyxx,   0x000000ff,
                    TOP_vcvtpd2psyxxx,  0x000000ff,
                    TOP_vcvtps2dq,      0x000000ff,
                    TOP_vcvtps2dqx,     0x000000ff,
                    TOP_vcvtps2dqxx,    0x000000ff,
                    TOP_vcvtps2dqxxx,   0x000000ff,
                    TOP_vcvtps2pd,      0x000000ff,
                    TOP_vcvtps2pdx,     0x000000ff,
                    TOP_vcvtps2pdxx,    0x000000ff,
                    TOP_vcvtps2pdxxx,   0x000000ff,
                    TOP_vcvtsd2si,      0x000000ff,
                    TOP_vcvtsd2siq,     0x000000ff,
                    TOP_vcvtsd2ss,      0x000000ff,
                    TOP_vcvtsd2ssx,     0x000000ff,
                    TOP_vcvtsd2ssxx,    0x000000ff,
                    TOP_vcvtsd2ssxxx,   0x000000ff,
                    TOP_vcvtsi2sd,      0x000000ff,
                    TOP_vcvtsi2sdx,     0x000000ff,
                    TOP_vcvtsi2sdxx,    0x000000ff,
                    TOP_vcvtsi2sdxxx,   0x000000ff,
                    TOP_vcvtsi2sdq,     0x000000ff,
                    TOP_vcvtsi2sdqx,    0x000000ff,
                    TOP_vcvtsi2sdqxx,   0x000000ff,
                    TOP_vcvtsi2sdqxxx,  0x000000ff,
                    TOP_vcvtsi2ss,      0x000000ff,
                    TOP_vcvtsi2ssx,     0x000000ff,
                    TOP_vcvtsi2ssxx,    0x000000ff,
                    TOP_vcvtsi2ssxxx,   0x000000ff,
                    TOP_vcvtsi2ssq,     0x000000ff,
                    TOP_vcvtsi2ssqx,    0x000000ff,
                    TOP_vcvtsi2ssqxx,   0x000000ff,
                    TOP_vcvtsi2ssqxxx,  0x000000ff,
                    TOP_vcvtss2sd,      0x000000ff,
                    TOP_vcvtss2sdx,     0x000000ff,
                    TOP_vcvtss2sdxx,    0x000000ff,
                    TOP_vcvtss2sdxxx,   0x000000ff,
                    TOP_vcvtss2si,      0x000000ff,
                    TOP_vcvtss2siq,     0x000000ff,
                    TOP_vcvttpd2dq,     0x000000ff,
                    TOP_vcvttpd2dqx,    0x000000ff,
                    TOP_vcvttpd2dqxx,   0x000000ff,
                    TOP_vcvttpd2dqxxx,  0x000000ff,
                    TOP_vcvttpd2dqy,    0x000000ff,
                    TOP_vcvttpd2dqyx,   0x000000ff,
                    TOP_vcvttpd2dqyxx,  0x000000ff,
                    TOP_vcvttpd2dqyxxx, 0x000000ff,
                    TOP_vcvttps2dq,     0x000000ff,
                    TOP_vcvttps2dqx,    0x000000ff,
                    TOP_vcvttps2dqxx,   0x000000ff,
                    TOP_vcvttps2dqxxx,  0x000000ff,
                    TOP_vcvttsd2si,     0x000000ff,
                    TOP_vcvttsd2siq,    0x000000ff,
                    TOP_vcvttss2si,     0x000000ff,
                    TOP_vcvttss2siq,     0x000000ff,
                    TOP_vfdiv128v64,    0x000000ff,
                    TOP_vfdivx128v64,   0x000000ff,
                    TOP_vfdivxx128v64,  0x000000ff,
                    TOP_vfdivxxx128v64, 0x000000ff,
                    TOP_vfdiv128v32,    0x000000ff,
                    TOP_vfdivx128v32,   0x000000ff,
                    TOP_vfdivxx128v32,  0x000000ff,
                    TOP_vfdivxxx128v32, 0x000000ff,
                    TOP_vdivsd, 0x000000ff,
                    TOP_vdivxsd,        0x000000ff,
                    TOP_vdivxxsd,       0x000000ff,
                    TOP_vdivxxxsd,      0x000000ff,
                    TOP_vdivss, 0x000000ff,
                    TOP_vdivxss,        0x000000ff,
                    TOP_vdivxxss,       0x000000ff,
                    TOP_vdivxxxss,      0x000000ff,
                    TOP_vfdp128v64,     0x000000ff,
                    TOP_vfdpx128v64,    0x000000ff,
                    TOP_vfdpxx128v64,   0x000000ff,
                    TOP_vfdpxxx128v64,  0x000000ff,
                    TOP_vfdp128v32,     0x000000ff,
                    TOP_vfdpx128v32,    0x000000ff,
                    TOP_vfdpxx128v32,   0x000000ff,
                    TOP_vfdpxxx128v32,  0x000000ff,
                    TOP_vfextrf128,     0x000000ff,
                    TOP_vfextrxf128,    0x000000ff,
                    TOP_vfextrxxf128,   0x000000ff,
                    TOP_vfextrxxxf128,  0x000000ff,
                    TOP_vfextr128v32,   0x000000ff,
                    TOP_vfextrx128v32,  0x000000ff,
                    TOP_vfextrxx128v32, 0x000000ff,
                    TOP_vfextrxxx128v32,        0x000000ff,
                    TOP_vfhadd128v64,   0x000000ff,
                    TOP_vfhaddx128v64,  0x000000ff,
                    TOP_vfhaddxx128v64, 0x000000ff,
                    TOP_vfhaddxxx128v64,        0x000000ff,
                    TOP_vfhadd128v32,   0x000000ff,
                    TOP_vfhaddx128v32,  0x000000ff,
                    TOP_vfhaddxx128v32, 0x000000ff,
                    TOP_vfhaddxxx128v32,        0x000000ff,
                    TOP_vfhsub128v64,    0x000000ff,
                    TOP_vfhsubx128v64,   0x000000ff,
                    TOP_vfhsubxx128v64,  0x000000ff,
                    TOP_vfhsubxxx128v64, 0x000000ff,
                    TOP_vfhsub128v32,    0x000000ff,
                    TOP_vfhsubx128v32,   0x000000ff,
                    TOP_vfhsubxx128v32,  0x000000ff,
                    TOP_vfhsubxxx128v32, 0x000000ff,
                    TOP_vfinsrf128,     0x000000ff,
                    TOP_vfinsrxf128,    0x000000ff,
                    TOP_vfinsrxxf128,   0x000000ff,
                    TOP_vfinsrxxxf128,  0x000000ff,
                    TOP_vfinsr128v32,   0x000000ff,
                    TOP_vfinsrx128v32,  0x000000ff,
                    TOP_vfinsrxx128v32, 0x000000ff,
                    TOP_vfinsrxxx128v32,        0x000000ff,
                    TOP_vlddqu, 0x000000ff,
                    TOP_vlddqux,        0x000000ff,
                    TOP_vlddquxx,       0x000000ff,
                    TOP_vlddqu_n32,     0x000000ff,
                    TOP_vldmxcsr,       0x000000ff,
                    TOP_vmaskmovdqu,    0x000000ff,
                    TOP_vfmaskld128v32, 0x000000ff,
                    TOP_vfmaskldx128v32,       0x000000ff,
                    TOP_vfmaskldxx128v32,      0x000000ff,
                    TOP_vfmaskld128v64, 0x000000ff,
                    TOP_vfmaskldx128v64,       0x000000ff,
                    TOP_vfmaskldxx128v64,      0x000000ff,
                    TOP_vfmaskst128v32, 0x000000ff,
                    TOP_vfmaskstx128v32,       0x000000ff,
                    TOP_vfmaskstxx128v32,      0x000000ff,
                    TOP_vfmaskst128v64, 0x000000ff,
                    TOP_vfmaskstx128v64,       0x000000ff,
                    TOP_vfmaskstxx128v64,      0x000000ff,
                    TOP_vfmax128v64,    0x000000ff,
                    TOP_vfmaxx128v64,   0x000000ff,
                    TOP_vfmaxxx128v64,  0x000000ff,
                    TOP_vfmaxxxx128v64, 0x000000ff,
                    TOP_vfmax128v32,    0x000000ff,
                    TOP_vfmaxx128v32,   0x000000ff,
                    TOP_vfmaxxx128v32,  0x000000ff,
                    TOP_vfmaxxxx128v32, 0x000000ff,
                    TOP_vfmaxsd,        0x000000ff,
                    TOP_vfmaxxsd,       0x000000ff,
                    TOP_vfmaxxxsd,      0x000000ff,
                    TOP_vfmaxxxxsd,     0x000000ff,
                    TOP_vfmaxss,        0x000000ff,
                    TOP_vfmaxxss,       0x000000ff,
                    TOP_vfmaxxxss,      0x000000ff,
                    TOP_vfmaxxxxss,     0x000000ff,
                    TOP_vfmin128v64,    0x000000ff,
                    TOP_vfminx128v64,   0x000000ff,
                    TOP_vfminxx128v64,  0x000000ff,
                    TOP_vfminxxx128v64, 0x000000ff,
                    TOP_vfmin128v32,    0x000000ff,
                    TOP_vfminx128v32,   0x000000ff,
                    TOP_vfminxx128v32,  0x000000ff,
                    TOP_vfminxxx128v32, 0x000000ff,
                    TOP_vfminsd,        0x000000ff,
                    TOP_vfminxsd,       0x000000ff,
                    TOP_vfminxxsd,      0x000000ff,
                    TOP_vfminxxxsd,     0x000000ff,
                    TOP_vfminss,        0x000000ff,
                    TOP_vfminxss,       0x000000ff,
                    TOP_vfminxxss,      0x000000ff,
                    TOP_vfminxxxss,     0x000000ff,
                    TOP_vldapd, 0x000000ff,
                    TOP_vldapdx,        0x000000ff,
                    TOP_vldapdxx,       0x000000ff,
                    TOP_vldapd_n32,     0x000000ff,
                    TOP_vstapd, 0x000000ff,
                    TOP_vstapdx,        0x000000ff,
                    TOP_vstapdxx,       0x000000ff,
                    TOP_vstapd_n32,     0x000000ff,
                    TOP_vldaps, 0x000000ff,
                    TOP_vldapsx,        0x000000ff,
                    TOP_vldapsxx,       0x000000ff,
                    TOP_vldaps_n32,     0x000000ff,
                    TOP_vstaps, 0x000000ff,
                    TOP_vstapsx,        0x000000ff,
                    TOP_vstapsxx,       0x000000ff,
                    TOP_vstaps_n32,     0x000000ff,
                    TOP_vmovg2x,        0x000000ff,
                    TOP_vmovg2x64,      0x000000ff,
                    TOP_vmovx2g,        0x000000ff,
                    TOP_vmovx2g64,      0x000000ff,
                    TOP_vld64_2sse,     0x000000ff,
                    TOP_vldx64_2sse,    0x000000ff,
                    TOP_vldxx64_2sse,   0x000000ff,
                    TOP_vld64_2sse_n32, 0x000000ff,
                    TOP_vst64_fsse,     0x000000ff,
                    TOP_vstx64_fsse,    0x000000ff,
                    TOP_vstxx64_fsse,   0x000000ff,
                    TOP_vst64_fsse_n32, 0x000000ff,
                    TOP_vmovddup,       0x000000ff,
                    TOP_vmovddupx,      0x000000ff,
                    TOP_vmovddupxx,     0x000000ff,
                    TOP_vmovddupxxx,    0x000000ff,
                    TOP_vmovshdup,      0x000000ff,
                    TOP_vmovshdupx,     0x000000ff,
                    TOP_vmovshdupxx,    0x000000ff,
                    TOP_vmovshdupxxx,   0x000000ff,
                    TOP_vmovsldup,      0x000000ff,
                    TOP_vmovsldupx,     0x000000ff,
                    TOP_vmovsldupxx,    0x000000ff,
                    TOP_vmovsldupxxx,   0x000000ff,
                    TOP_vlddqa, 0x000000ff,
                    TOP_vlddqax,        0x000000ff,
                    TOP_vlddqaxx,       0x000000ff,
                    TOP_vlddqa_n32,     0x000000ff,
                    TOP_vmovdqa, 0x000000ff,
                    TOP_vmovapd, 0x000000ff,
                    TOP_vmovaps, 0x000000ff,
                    TOP_vstdqa, 0x000000ff,
                    TOP_vstdqax,        0x000000ff,
                    TOP_vstdqaxx,       0x000000ff,
                    TOP_vstdqa_n32,     0x000000ff,
                    TOP_vstdqu, 0x000000ff,
                    TOP_vstdqux,        0x000000ff,
                    TOP_vstdquxx,       0x000000ff,
                    TOP_vstdqu_n32,     0x000000ff,
                    TOP_vldhpd, 0x000000ff,
                    TOP_vldhpdx,        0x000000ff,
                    TOP_vldhpdxx,       0x000000ff,
                    TOP_vldhpd_n32,     0x000000ff,
                    TOP_vsthpd, 0x000000ff,
                    TOP_vsthpdx,        0x000000ff,
                    TOP_vsthpdxx,       0x000000ff,
                    TOP_vsthpd_n32,     0x000000ff,
                    TOP_vldhps, 0x000000ff,
                    TOP_vldhpsx,        0x000000ff,
                    TOP_vldhpsxx,       0x000000ff,
                    TOP_vldhps_n32,     0x000000ff,
                    TOP_vsthps, 0x000000ff,
                    TOP_vsthpsx,        0x000000ff,
                    TOP_vsthpsxx,       0x000000ff,
                    TOP_vsthps_n32,     0x000000ff,
                    TOP_vldlpd, 0x000000ff,
                    TOP_vldlpdx,        0x000000ff,
                    TOP_vldlpdxx,       0x000000ff,
                    TOP_vldlpd_n32,     0x000000ff,
                    TOP_vstorelpd,      0x000000ff,
                    TOP_vstlpd, 0x000000ff,
                    TOP_vstlpdx,        0x000000ff,
                    TOP_vstlpdxx,       0x000000ff,
                    TOP_vstlpd_n32,     0x000000ff,
                    TOP_vldlps, 0x000000ff,
                    TOP_vldlpsx,        0x000000ff,
                    TOP_vldlpsxx,       0x000000ff,
                    TOP_vldlps_n32,     0x000000ff,
                    TOP_vstlps, 0x000000ff,
                    TOP_vstlpsx,        0x000000ff,
                    TOP_vstlpsxx,       0x000000ff,
                    TOP_vstlps_n32,     0x000000ff,
                    TOP_vstorenti128,   0x000000ff,
                    TOP_vstorentxi128,  0x000000ff,
                    TOP_vstorentxxi128, 0x000000ff,
                    TOP_vmovmskpd,      0x000000ff,
                    TOP_vmovmskps,      0x000000ff,
                    TOP_vldntdqa,       0x000000ff,
                    TOP_vldntdqax,      0x000000ff,
                    TOP_vldntdqaxx,     0x000000ff,
                    TOP_vstntdq,        0x000000ff,
                    TOP_vstntdqx,       0x000000ff,
                    TOP_vstntdqxx,      0x000000ff,
                    TOP_vstntpd,        0x000000ff,
                    TOP_vstntpdx,       0x000000ff,
                    TOP_vstntpdxx,      0x000000ff,
                    TOP_vstntps,        0x000000ff,
                    TOP_vstntpsx,       0x000000ff,
                    TOP_vstntpsxx,      0x000000ff,
                    TOP_vstntsd,        0x000000ff,
                    TOP_vstntsdx,       0x000000ff,
                    TOP_vstntsdxx,      0x000000ff,
                    TOP_vstntss,        0x000000ff,
                    TOP_vstntssx,       0x000000ff,
                    TOP_vstntssxx,      0x000000ff,
                    TOP_vmovlhps,       0x000000ff,
                    TOP_vmovhlps,       0x000000ff,
                    TOP_vmovsd, 0x000000ff,
                    TOP_vldsd,  0x000000ff,
                    TOP_vldsdx, 0x000000ff,
                    TOP_vldsdxx,        0x000000ff,
                    TOP_vldsd_n32,      0x000000ff,
                    TOP_vstsd,  0x000000ff,
                    TOP_vstsdx, 0x000000ff,
                    TOP_vstsdxx,        0x000000ff,
                    TOP_vstsd_n32,      0x000000ff,
                    TOP_vmovss, 0x000000ff,
                    TOP_vldss,  0x000000ff,
                    TOP_vldssx, 0x000000ff,
                    TOP_vldssxx,        0x000000ff,
                    TOP_vldss_n32,      0x000000ff,
                    TOP_vstss,  0x000000ff,
                    TOP_vstssx, 0x000000ff,
                    TOP_vstssxx,        0x000000ff,
                    TOP_vstss_n32,      0x000000ff,
                    TOP_vldupd, 0x000000ff,
                    TOP_vldupdx,        0x000000ff,
                    TOP_vldupdxx,       0x000000ff,
                    TOP_vldupd_n32,     0x000000ff,
                    TOP_vstupd, 0x000000ff,
                    TOP_vstupdx,        0x000000ff,
                    TOP_vstupdxx,       0x000000ff,
                    TOP_vstupd_n32,     0x000000ff,
                    TOP_vldups, 0x000000ff,
                    TOP_vldupsx,        0x000000ff,
                    TOP_vldupsxx,       0x000000ff,
                    TOP_vldups_n32,     0x000000ff,
                    TOP_vstups, 0x000000ff,
                    TOP_vstupsx,        0x000000ff,
                    TOP_vstupsxx,       0x000000ff,
                    TOP_vstups_n32,     0x000000ff,
                    TOP_vmpsadbw,       0x000000ff,
                    TOP_vmpsadbwx,      0x000000ff,
                    TOP_vmpsadbwxx,     0x000000ff,
                    TOP_vmpsadbwxxx,    0x000000ff,
                    TOP_vfmul128v64,    0x000000ff,
                    TOP_vfmulx128v64,   0x000000ff,
                    TOP_vfmulxx128v64,  0x000000ff,
                    TOP_vfmulxxx128v64, 0x000000ff,
                    TOP_vfmul128v32,    0x000000ff,
                    TOP_vfmulx128v32,   0x000000ff,
                    TOP_vfmulxx128v32,  0x000000ff,
                    TOP_vfmulxxx128v32, 0x000000ff,
                    TOP_vmulsd, 0x000000ff,
                    TOP_vmulxsd,        0x000000ff,
                    TOP_vmulxxsd,       0x000000ff,
                    TOP_vmulxxxsd,      0x000000ff,
                    TOP_vmulss, 0x000000ff,
                    TOP_vmulxss,        0x000000ff,
                    TOP_vmulxxss,       0x000000ff,
                    TOP_vmulxxxss,      0x000000ff,
                    TOP_vorpd,          0x000000ff,
                    TOP_vfor128v64,     0x000000ff,
                    TOP_vforx128v64,    0x000000ff,
                    TOP_vforxx128v64,   0x000000ff,
                    TOP_vforxxx128v64,  0x000000ff,
                    TOP_vorps,          0x000000ff,
                    TOP_vfor128v32,     0x000000ff,
                    TOP_vforx128v32,    0x000000ff,
                    TOP_vforxx128v32,   0x000000ff,
                    TOP_vforxxx128v32,  0x000000ff,
                    TOP_vabs128v8,      0x000000ff,
                    TOP_vabsx128v8,     0x000000ff,
                    TOP_vabsxx128v8,    0x000000ff,
                    TOP_vabsxxx128v8,   0x000000ff,
                    TOP_vabs128v32,     0x000000ff,
                    TOP_vabsx128v32,    0x000000ff,
                    TOP_vabsxx128v32,   0x000000ff,
                    TOP_vabsxxx128v32,  0x000000ff,
                    TOP_vabs128v16,     0x000000ff,
                    TOP_vabsx128v16,    0x000000ff,
                    TOP_vabsxx128v16,   0x000000ff,
                    TOP_vabsxxx128v16,  0x000000ff,
                    TOP_vpackssdw,      0x000000ff,
                    TOP_vpackssdwx,     0x000000ff,
                    TOP_vpackssdwxx,    0x000000ff,
                    TOP_vpackssdwxxx,   0x000000ff,
                    TOP_vpacksswb,      0x000000ff,
                    TOP_vpacksswbx,     0x000000ff,
                    TOP_vpacksswbxx,    0x000000ff,
                    TOP_vpacksswbxxx,   0x000000ff,
                    TOP_vpackusdw,      0x000000ff,
                    TOP_vpackusdwx,     0x000000ff,
                    TOP_vpackusdwxx,    0x000000ff,
                    TOP_vpackusdwxxx,   0x000000ff,
                    TOP_vpackuswb,      0x000000ff,
                    TOP_vpackuswbx,     0x000000ff,
                    TOP_vpackuswbxx,    0x000000ff,
                    TOP_vpackuswbxxx,   0x000000ff,
                    TOP_vadd128v8,      0x000000ff,
                    TOP_vaddx128v8,     0x000000ff,
                    TOP_vaddxx128v8,    0x000000ff,
                    TOP_vaddxxx128v8,   0x000000ff,
                    TOP_vadd128v32,     0x000000ff,
                    TOP_vaddx128v32,    0x000000ff,
                    TOP_vaddxx128v32,   0x000000ff,
                    TOP_vaddxxx128v32,  0x000000ff,
                    TOP_vadd128v64,     0x000000ff,
                    TOP_vaddx128v64,    0x000000ff,
                    TOP_vaddxx128v64,   0x000000ff,
                    TOP_vaddxxx128v64,  0x000000ff,
                    TOP_vadd128v16,     0x000000ff,
                    TOP_vaddx128v16,    0x000000ff,
                    TOP_vaddxx128v16,   0x000000ff,
                    TOP_vaddxxx128v16,  0x000000ff,
                    TOP_vadds128v8,     0x000000ff,
                    TOP_vaddsx128v8,    0x000000ff,
                    TOP_vaddsxx128v8,   0x000000ff,
                    TOP_vaddsxxx128v8,  0x000000ff,
                    TOP_vadds128v16,    0x000000ff,
                    TOP_vaddsx128v16,   0x000000ff,
                    TOP_vaddsxx128v16,  0x000000ff,
                    TOP_vaddsxxx128v16, 0x000000ff,
                    TOP_vaddus128v8,    0x000000ff,
                    TOP_vaddusx128v8,   0x000000ff,
                    TOP_vaddusxx128v8,  0x000000ff,
                    TOP_vaddusxxx128v8, 0x000000ff,
                    TOP_vaddus128v16,   0x000000ff,
                    TOP_vaddusx128v16,  0x000000ff,
                    TOP_vaddusxx128v16, 0x000000ff,
                    TOP_vaddusxxx128v16,        0x000000ff,
                    TOP_vpalignr128,    0x000000ff,
                    TOP_vpalignrx128,   0x000000ff,
                    TOP_vpalignrxx128,  0x000000ff,
                    TOP_vpalignrxxx128, 0x000000ff,
                    TOP_vand128v8,      0x000000ff,
                    TOP_vandx128v8,     0x000000ff,
                    TOP_vandxx128v8,    0x000000ff,
                    TOP_vandxxx128v8,           0x000000ff,
                    TOP_vand128v16,     0x000000ff,
                    TOP_vandx128v16,    0x000000ff,
                    TOP_vandxx128v16,   0x000000ff,
                    TOP_vandxxx128v16,          0x000000ff,
                    TOP_vand128v32,     0x000000ff,
                    TOP_vandx128v32,    0x000000ff,
                    TOP_vandxx128v32,   0x000000ff,
                    TOP_vandxxx128v32,          0x000000ff,
                    TOP_vand128v64,     0x000000ff,
                    TOP_vandx128v64,    0x000000ff,
                    TOP_vandxx128v64,   0x000000ff,
                    TOP_vandxxx128v64,          0x000000ff,
                    TOP_vandn128v8,     0x000000ff,
                    TOP_vandnx128v8,    0x000000ff,
                    TOP_vandnxx128v8,           0x000000ff,
                    TOP_vandnxxx128v8,          0x000000ff,
                    TOP_vandn128v16,    0x000000ff,
                    TOP_vandnx128v16,   0x000000ff,
                    TOP_vandnxx128v16,          0x000000ff,
                    TOP_vandnxxx128v16,         0x000000ff,
                    TOP_vandn128v32,    0x000000ff,
                    TOP_vandnx128v32,   0x000000ff,
                    TOP_vandnxx128v32,          0x000000ff,
                    TOP_vandnxxx128v32,         0x000000ff,
                    TOP_vandn128v64,    0x000000ff,
                    TOP_vandnx128v64,   0x000000ff,
                    TOP_vandnxx128v64,          0x000000ff,
                    TOP_vandnxxx128v64,         0x000000ff,
                    TOP_vpavgb,         0x000000ff,
                    TOP_vpavgbx,        0x000000ff,
                    TOP_vpavgbxx,       0x000000ff,
                    TOP_vpavgbxxx,      0x000000ff,
                    TOP_vpavgw,         0x000000ff,
                    TOP_vpavgwx,        0x000000ff,
                    TOP_vpavgwxx,       0x000000ff,
                    TOP_vpavgwxxx,      0x000000ff,
                    TOP_vblendv128v8,   0x000000ff,
                    TOP_vblendvx128v8,  0x000000ff,
                    TOP_vblendvxx128v8, 0x000000ff,
                    TOP_vblendvxxx128v8,        0x000000ff,
                    TOP_vblend128v16,   0x000000ff,
                    TOP_vblendx128v16,  0x000000ff,
                    TOP_vblendxx128v16, 0x000000ff,
                    TOP_vblendxxx128v16,        0x000000ff,
                    TOP_vpclmulqdq,     0x000000ff,
                    TOP_vpclmulqdqx,    0x000000ff,
                    TOP_vpclmulqdqxx,   0x000000ff,
                    TOP_vpclmulqdqxxx,  0x000000ff,
                    TOP_vcmpeq128v8,    0x000000ff,
                    TOP_vcmpeqx128v8,   0x000000ff,
                    TOP_vcmpeqxx128v8,  0x000000ff,
                    TOP_vcmpeqxxx128v8, 0x000000ff,
                    TOP_vcmpeq128v32,   0x000000ff,
                    TOP_vcmpeqx128v32,  0x000000ff,
                    TOP_vcmpeqxx128v32, 0x000000ff,
                    TOP_vcmpeqxxx128v32,        0x000000ff,
                    TOP_vcmpeq128v64,   0x000000ff,
                    TOP_vcmpeqx128v64,  0x000000ff,
                    TOP_vcmpeqxx128v64, 0x000000ff,
                    TOP_vcmpeqxxx128v64,        0x000000ff,
                    TOP_vcmpeq128v16,   0x000000ff,
                    TOP_vcmpeqx128v16,  0x000000ff,
                    TOP_vcmpeqxx128v16, 0x000000ff,
                    TOP_vcmpeqxxx128v16,        0x000000ff,
                    TOP_vcmpestri,      0x000000ff,
                    TOP_vcmpestrix,     0x000000ff,
                    TOP_vcmpestrixx,    0x000000ff,
                    TOP_vcmpestrixxx,   0x000000ff,
                    TOP_vcmpestrm,      0x000000ff,
                    TOP_vcmpestrmx,     0x000000ff,
                    TOP_vcmpestrmxx,    0x000000ff,
                    TOP_vcmpestrmxxx,   0x000000ff,
                    TOP_vcmpgt128v8,    0x000000ff,
                    TOP_vcmpgtx128v8,   0x000000ff,
                    TOP_vcmpgtxx128v8,  0x000000ff,
                    TOP_vcmpgtxxx128v8, 0x000000ff,
                    TOP_vcmpgt128v32,   0x000000ff,
                    TOP_vcmpgtx128v32,  0x000000ff,
                    TOP_vcmpgtxx128v32, 0x000000ff,
                    TOP_vcmpgtxxx128v32,        0x000000ff,
                    TOP_vcmpgt128v64,   0x000000ff,
                    TOP_vcmpgtx128v64,  0x000000ff,
                    TOP_vcmpgtxx128v64, 0x000000ff,
                    TOP_vcmpgtxxx128v64,        0x000000ff,
                    TOP_vcmpgt128v16,   0x000000ff,
                    TOP_vcmpgtx128v16,  0x000000ff,
                    TOP_vcmpgtxx128v16, 0x000000ff,
                    TOP_vcmpgtxxx128v16,        0x000000ff,
                    TOP_vcmpistri,      0x000000ff,
                    TOP_vcmpistrix,     0x000000ff,
                    TOP_vcmpistrixx,    0x000000ff,
                    TOP_vcmpistrixxx,   0x000000ff,
                    TOP_vcmpistrm,      0x000000ff,
                    TOP_vcmpistrmx,     0x000000ff,
                    TOP_vcmpistrmxx,    0x000000ff,
                    TOP_vcmpistrmxxx,   0x000000ff,
                    TOP_vfperm128v64,   0x000000ff,
                    TOP_vfpermx128v64,  0x000000ff,
                    TOP_vfpermxx128v64, 0x000000ff,
                    TOP_vfpermxxx128v64,        0x000000ff,
                    TOP_vfpermi128v64,  0x000000ff,
                    TOP_vfpermix128v64, 0x000000ff,
                    TOP_vfpermixx128v64,        0x000000ff,
                    TOP_vfpermixxx128v64,       0x000000ff,
                    TOP_vfperm128v32,   0x000000ff,
                    TOP_vfpermx128v32,  0x000000ff,
                    TOP_vfpermxx128v32, 0x000000ff,
                    TOP_vfpermxxx128v32,        0x000000ff,
                    TOP_vfpermi128v32,  0x000000ff,
                    TOP_vfpermix128v32, 0x000000ff,
                    TOP_vfpermixx128v32,        0x000000ff,
                    TOP_vfpermixxx128v32,       0x000000ff,
                    TOP_vfperm2f128,    0x000000ff,
                    TOP_vfperm2xf128,   0x000000ff,
                    TOP_vfperm2xxf128,  0x000000ff,
                    TOP_vfperm2xxxf128, 0x000000ff,
                    TOP_vextr128v8,     0x000000ff,
                    TOP_vextrx128v8,    0x000000ff,
                    TOP_vextrxx128v8,   0x000000ff,
                    TOP_vextrxxx128v8,  0x000000ff,
                    TOP_vextr128v32,    0x000000ff,
                    TOP_vextrx128v32,   0x000000ff,
                    TOP_vextrxx128v32,  0x000000ff,
                    TOP_vextrxxx128v32, 0x000000ff,
                    TOP_vextr128v64,    0x000000ff,
                    TOP_vextrx128v64,   0x000000ff,
                    TOP_vextrxx128v64,  0x000000ff,
                    TOP_vextrxxx128v64, 0x000000ff,
                    TOP_vextr128v16,    0x000000ff,
                    TOP_vextrx128v16,   0x000000ff,
                    TOP_vextrxx128v16,  0x000000ff,
                    TOP_vextrxxx128v16, 0x000000ff,
                    TOP_vphadd128v32,   0x000000ff,
                    TOP_vphaddx128v32,  0x000000ff,
                    TOP_vphaddxx128v32, 0x000000ff,
                    TOP_vphaddxxx128v32,        0x000000ff,
                    TOP_vphadds128v16,  0x000000ff,
                    TOP_vphaddsx128v16, 0x000000ff,
                    TOP_vphaddsxx128v16,        0x000000ff,
                    TOP_vphaddsxxx128v16,       0x000000ff,
                    TOP_vphadd128v16,   0x000000ff,
                    TOP_vphaddx128v16,  0x000000ff,
                    TOP_vphaddxx128v16, 0x000000ff,
                    TOP_vphaddxxx128v16,        0x000000ff,
                    TOP_vphminposuw,    0x000000ff,
                    TOP_vphminposuwx,   0x000000ff,
                    TOP_vphminposuwxx,  0x000000ff,
                    TOP_vphminposuwxxx, 0x000000ff,
                    TOP_vphsub128v32,   0x000000ff,
                    TOP_vphsubx128v32,  0x000000ff,
                    TOP_vphsubxx128v32, 0x000000ff,
                    TOP_vphsubxxx128v32,        0x000000ff,
                    TOP_vphsubs128v16,  0x000000ff,
                    TOP_vphsubsx128v16, 0x000000ff,
                    TOP_vphsubsxx128v16,        0x000000ff,
                    TOP_vphsubsxxx128v16,       0x000000ff,
                    TOP_vphsub128v16,   0x000000ff,
                    TOP_vphsubx128v16,  0x000000ff,
                    TOP_vphsubxx128v16, 0x000000ff,
                    TOP_vphsubxxx128v16,        0x000000ff,
                    TOP_vinsr128v8,     0x000000ff,
                    TOP_vinsrx128v8,    0x000000ff,
                    TOP_vinsrxx128v8,   0x000000ff,
                    TOP_vinsrxxx128v8,  0x000000ff,
                    TOP_vinsr128v32,    0x000000ff,
                    TOP_vinsrx128v32,   0x000000ff,
                    TOP_vinsrxx128v32,  0x000000ff,
                    TOP_vinsrxxx128v32, 0x000000ff,
                    TOP_vinsr128v64,    0x000000ff,
                    TOP_vinsrx128v64,   0x000000ff,
                    TOP_vinsrxx128v64,  0x000000ff,
                    TOP_vinsrxxx128v64, 0x000000ff,
                    TOP_vinsr128v16,    0x000000ff,
                    TOP_vinsrx128v16,   0x000000ff,
                    TOP_vinsrxx128v16,  0x000000ff,
                    TOP_vinsrxxx128v16, 0x000000ff,
                    TOP_vpmaddwd,       0x000000ff,
                    TOP_vpmaddwdx,      0x000000ff,
                    TOP_vpmaddwdxx,     0x000000ff,
                    TOP_vpmaddwdxxx,    0x000000ff,
                    TOP_vpmaddubsw128,  0x000000ff,
                    TOP_vpmaddubswx128, 0x000000ff,
                    TOP_vpmaddubswxx128,        0x000000ff,
                    TOP_vpmaddubswxxx128,       0x000000ff,
                    TOP_vmaxs128v8,     0x000000ff,
                    TOP_vmaxsx128v8,    0x000000ff,
                    TOP_vmaxsxx128v8,   0x000000ff,
                    TOP_vmaxsxxx128v8,  0x000000ff,
                    TOP_vmaxs128v32,    0x000000ff,
                    TOP_vmaxsx128v32,   0x000000ff,
                    TOP_vmaxsxx128v32,  0x000000ff,
                    TOP_vmaxsxxx128v32, 0x000000ff,
                    TOP_vmaxs128v16,    0x000000ff,
                    TOP_vmaxsx128v16,   0x000000ff,
                    TOP_vmaxsxx128v16,  0x000000ff,
                    TOP_vmaxsxxx128v16, 0x000000ff,
                    TOP_vmaxu128v8,     0x000000ff,
                    TOP_vmaxux128v8,    0x000000ff,
                    TOP_vmaxuxx128v8,   0x000000ff,
                    TOP_vmaxuxxx128v8,  0x000000ff,
                    TOP_vmaxu128v32,    0x000000ff,
                    TOP_vmaxux128v32,   0x000000ff,
                    TOP_vmaxuxx128v32,  0x000000ff,
                    TOP_vmaxuxxx128v32, 0x000000ff,
                    TOP_vmaxu128v16,    0x000000ff,
                    TOP_vmaxux128v16,   0x000000ff,
                    TOP_vmaxuxx128v16,  0x000000ff,
                    TOP_vmaxuxxx128v16, 0x000000ff,
                    TOP_vmins128v8,     0x000000ff,
                    TOP_vminsx128v8,    0x000000ff,
                    TOP_vminsxx128v8,   0x000000ff,
                    TOP_vminsxxx128v8,  0x000000ff,
                    TOP_vmins128v32,    0x000000ff,
                    TOP_vminsx128v32,   0x000000ff,
                    TOP_vminsxx128v32,  0x000000ff,
                    TOP_vminsxxx128v32, 0x000000ff,
                    TOP_vmins128v16,    0x000000ff,
                    TOP_vminsx128v16,   0x000000ff,
                    TOP_vminsxx128v16,  0x000000ff,
                    TOP_vminsxxx128v16, 0x000000ff,
                    TOP_vminu128v8,     0x000000ff,
                    TOP_vminux128v8,    0x000000ff,
                    TOP_vminuxx128v8,   0x000000ff,
                    TOP_vminuxxx128v8,  0x000000ff,
                    TOP_vminu128v32,    0x000000ff,
                    TOP_vminux128v32,   0x000000ff,
                    TOP_vminuxx128v32,  0x000000ff,
                    TOP_vminuxxx128v32, 0x000000ff,
                    TOP_vminu128v16,    0x000000ff,
                    TOP_vminux128v16,   0x000000ff,
                    TOP_vminuxx128v16,  0x000000ff,
                    TOP_vminuxxx128v16, 0x000000ff,
                    TOP_vpmovmskb128,   0x000000ff,
                    TOP_vpmovsxbd,      0x000000ff,
                    TOP_vpmovsxbdx,     0x000000ff,
                    TOP_vpmovsxbdxx,    0x000000ff,
                    TOP_vpmovsxbdxxx,   0x000000ff,
                    TOP_vpmovsxbq,      0x000000ff,
                    TOP_vpmovsxbqx,     0x000000ff,
                    TOP_vpmovsxbqxx,    0x000000ff,
                    TOP_vpmovsxbqxxx,   0x000000ff,
                    TOP_vpmovsxbw,      0x000000ff,
                    TOP_vpmovsxbwx,     0x000000ff,
                    TOP_vpmovsxbwxx,    0x000000ff,
                    TOP_vpmovsxbwxxx,   0x000000ff,
                    TOP_vpmovsxdq,      0x000000ff,
                    TOP_vpmovsxdqx,     0x000000ff,
                    TOP_vpmovsxdqxx,    0x000000ff,
                    TOP_vpmovsxdqxxx,   0x000000ff,
                    TOP_vpmovsxwd,      0x000000ff,
                    TOP_vpmovsxwdx,     0x000000ff,
                    TOP_vpmovsxwdxx,    0x000000ff,
                    TOP_vpmovsxwdxxx,   0x000000ff,
                    TOP_vpmovsxwq,      0x000000ff,
                    TOP_vpmovsxwqx,     0x000000ff,
                    TOP_vpmovsxwqxx,    0x000000ff,
                    TOP_vpmovsxwqxxx,   0x000000ff,
                    TOP_vpmovzxbd,      0x000000ff,
                    TOP_vpmovzxbdx,     0x000000ff,
                    TOP_vpmovzxbdxx,    0x000000ff,
                    TOP_vpmovzxbdxxx,   0x000000ff,
                    TOP_vpmovzxbq,      0x000000ff,
                    TOP_vpmovzxbqx,     0x000000ff,
                    TOP_vpmovzxbqxx,    0x000000ff,
                    TOP_vpmovzxbqxxx,   0x000000ff,
                    TOP_vpmovzxbw,      0x000000ff,
                    TOP_vpmovzxbwx,     0x000000ff,
                    TOP_vpmovzxbwxx,    0x000000ff,
                    TOP_vpmovzxbwxxx,   0x000000ff,
                    TOP_vpmovzxdq,      0x000000ff,
                    TOP_vpmovzxdqx,     0x000000ff,
                    TOP_vpmovzxdqxx,    0x000000ff,
                    TOP_vpmovzxdqxxx,   0x000000ff,
                    TOP_vpmovzxwd,      0x000000ff,
                    TOP_vpmovzxwdx,     0x000000ff,
                    TOP_vpmovzxwdxx,    0x000000ff,
                    TOP_vpmovzxwdxxx,   0x000000ff,
                    TOP_vpmovzxwq,      0x000000ff,
                    TOP_vpmovzxwqx,     0x000000ff,
                    TOP_vpmovzxwqxx,    0x000000ff,
                    TOP_vpmovzxwqxxx,   0x000000ff,
                    TOP_vmulhuw,        0x000000ff,
                    TOP_vmulhuwx,       0x000000ff,
                    TOP_vmulhuwxx,      0x000000ff,
                    TOP_vmulhuwxxx,     0x000000ff,
                    TOP_vmulhrsw,       0x000000ff,
                    TOP_vmulhrswx,      0x000000ff,
                    TOP_vmulhrswxx,     0x000000ff,
                    TOP_vmulhrswxxx,    0x000000ff,
                    TOP_vmulhw, 0x000000ff,
                    TOP_vmulhwx,        0x000000ff,
                    TOP_vmulhwxx,       0x000000ff,
                    TOP_vmulhwxxx,      0x000000ff,
                    TOP_vmulld, 0x000000ff,
                    TOP_vmulldx,        0x000000ff,
                    TOP_vmulldxx,       0x000000ff,
                    TOP_vmulldxxx,      0x000000ff,
                    TOP_vmul128v16,     0x000000ff,
                    TOP_vmulx128v16,    0x000000ff,
                    TOP_vmulxx128v16,   0x000000ff,
                    TOP_vmulxxx128v16,  0x000000ff,
                    TOP_vmul128v32,     0x000000ff,
                    TOP_vmulx128v32,    0x000000ff,
                    TOP_vmulxx128v32,   0x000000ff,
                    TOP_vmulxxx128v32,  0x000000ff,
                    TOP_vmuludq,        0x000000ff,
                    TOP_vmuludqx,       0x000000ff,
                    TOP_vmuludqxx,      0x000000ff,
                    TOP_vmuludqxxx,     0x000000ff,
                    TOP_vmuldq, 0x000000ff,
                    TOP_vmuldqx,        0x000000ff,
                    TOP_vmuldqxx,       0x000000ff,
                    TOP_vmuldqxxx,      0x000000ff,
                    TOP_vor128v8,       0x000000ff,
                    TOP_vorx128v8,      0x000000ff,
                    TOP_vorxx128v8,     0x000000ff,
                    TOP_vorxxx128v8,    0x000000ff,
                    TOP_vor128v16,      0x000000ff,
                    TOP_vorx128v16,     0x000000ff,
                    TOP_vorxx128v16,    0x000000ff,
                    TOP_vorxxx128v16,   0x000000ff,
                    TOP_vor128v32,      0x000000ff,
                    TOP_vorx128v32,     0x000000ff,
                    TOP_vorxx128v32,    0x000000ff,
                    TOP_vorxxx128v32,   0x000000ff,
                    TOP_vor128v64,      0x000000ff,
                    TOP_vorx128v64,     0x000000ff,
                    TOP_vorxx128v64,    0x000000ff,
                    TOP_vorxxx128v64,   0x000000ff,
                    TOP_vpsadbw,        0x000000ff,
                    TOP_vpsadbwx,       0x000000ff,
                    TOP_vpsadbwxx,      0x000000ff,
                    TOP_vpsadbwxxx,     0x000000ff,
                    TOP_vpshuf128v8,    0x000000ff,
                    TOP_vpshufx128v8,   0x000000ff,
                    TOP_vpshufxx128v8,  0x000000ff,
                    TOP_vpshufxxx128v8, 0x000000ff,
                    TOP_vpshuf128v32,   0x000000ff,
                    TOP_vpshufx128v32,  0x000000ff,
                    TOP_vpshufxx128v32, 0x000000ff,
                    TOP_vpshufxxx128v32,        0x000000ff,
                    TOP_vpshufw64v16,   0x000000ff,
                    TOP_vpshufwx64v16,  0x000000ff,
                    TOP_vpshufwxx64v16, 0x000000ff,
                    TOP_vpshufwxxx64v16,        0x000000ff,
                    TOP_vpshufhw,       0x000000ff,
                    TOP_vpshufhwx,      0x000000ff,
                    TOP_vpshufhwxx,     0x000000ff,
                    TOP_vpshufhwxxx,    0x000000ff,
                    TOP_vpshuflw,       0x000000ff,
                    TOP_vpshuflwx,      0x000000ff,
                    TOP_vpshuflwxx,     0x000000ff,
                    TOP_vpshuflwxxx,    0x000000ff,
                    TOP_vpsign128v8,    0x000000ff,
                    TOP_vpsignx128v8,   0x000000ff,
                    TOP_vpsignxx128v8,  0x000000ff,
                    TOP_vpsignxxx128v8, 0x000000ff,
                    TOP_vpsign128v32,   0x000000ff,
                    TOP_vpsignx128v32,  0x000000ff,
                    TOP_vpsignxx128v32, 0x000000ff,
                    TOP_vpsignxxx128v32,        0x000000ff,
                    TOP_vpsign128v16,   0x000000ff,
                    TOP_vpsignx128v16,  0x000000ff,
                    TOP_vpsignxx128v16, 0x000000ff,
                    TOP_vpsignxxx128v16,        0x000000ff,
                    TOP_vpslldq,        0x000000ff,
                    TOP_vpsrldq,        0x000000ff,
                    TOP_vpslld, 0x000000ff,
                    TOP_vpslldx,        0x000000ff,
                    TOP_vpslldxx,       0x000000ff,
                    TOP_vpslldxxx,      0x000000ff,
                    TOP_vpslldi,        0x000000ff,
                    TOP_vpsllq, 0x000000ff,
                    TOP_vpsllqx,        0x000000ff,
                    TOP_vpsllqxx,       0x000000ff,
                    TOP_vpsllqxxx,      0x000000ff,
                    TOP_vpsllqi,        0x000000ff,
                    TOP_vpsllw, 0x000000ff,
                    TOP_vpsllwx,        0x000000ff,
                    TOP_vpsllwxx,       0x000000ff,
                    TOP_vpsllwxxx,      0x000000ff,
                    TOP_vpsllwi,        0x000000ff,
                    TOP_vpsrad, 0x000000ff,
                    TOP_vpsradx,        0x000000ff,
                    TOP_vpsradxx,       0x000000ff,
                    TOP_vpsradxxx,      0x000000ff,
                    TOP_vpsradi,        0x000000ff,
                    TOP_vpsraw, 0x000000ff,
                    TOP_vpsrawx,        0x000000ff,
                    TOP_vpsrawxx,       0x000000ff,
                    TOP_vpsrawxxx,      0x000000ff,
                    TOP_vpsrawi,        0x000000ff,
                    TOP_vpsrld,         0x000000ff,
                    TOP_vpsrldx,        0x000000ff,
                    TOP_vpsrldxx,       0x000000ff,
                    TOP_vpsrldxxx,      0x000000ff,
                    TOP_vpsrldi,        0x000000ff,
                    TOP_vpsrlq,         0x000000ff,
                    TOP_vpsrlqx,        0x000000ff,
                    TOP_vpsrlqxx,       0x000000ff,
                    TOP_vpsrlqxxx,      0x000000ff,
                    TOP_vpsrlqi,        0x000000ff,
                    TOP_vpsrlw,         0x000000ff,
                    TOP_vpsrlwx,        0x000000ff,
                    TOP_vpsrlwxx,       0x000000ff,
                    TOP_vpsrlwxxx,      0x000000ff,
                    TOP_vpsrlwi,        0x000000ff,
                    TOP_vsub128v8,      0x000000ff,
                    TOP_vsubx128v8,     0x000000ff,
                    TOP_vsubxx128v8,    0x000000ff,
                    TOP_vsubxxx128v8,   0x000000ff,
                    TOP_vsub128v32,     0x000000ff,
                    TOP_vsubx128v32,    0x000000ff,
                    TOP_vsubxx128v32,   0x000000ff,
                    TOP_vsubxxx128v32,  0x000000ff,
                    TOP_vsub128v64,     0x000000ff,
                    TOP_vsubx128v64,    0x000000ff,
                    TOP_vsubxx128v64,   0x000000ff,
                    TOP_vsubxxx128v64,  0x000000ff,
                    TOP_vsub128v16,     0x000000ff,
                    TOP_vsubx128v16,    0x000000ff,
                    TOP_vsubxx128v16,   0x000000ff,
                    TOP_vsubxxx128v16,  0x000000ff,
                    TOP_vsubs128v8,     0x000000ff,
                    TOP_vsubsx128v8,    0x000000ff,
                    TOP_vsubsxx128v8,   0x000000ff,
                    TOP_vsubsxxx128v8,  0x000000ff,
                    TOP_vsubs128v16,    0x000000ff,
                    TOP_vsubsx128v16,   0x000000ff,
                    TOP_vsubsxx128v16,  0x000000ff,
                    TOP_vsubsxxx128v16, 0x000000ff,
                    TOP_vsubus128v8,    0x000000ff,
                    TOP_vsubusx128v8,   0x000000ff,
                    TOP_vsubusxx128v8,  0x000000ff,
                    TOP_vsubusxxx128v8, 0x000000ff,
                    TOP_vsubus128v16,   0x000000ff,
                    TOP_vsubusx128v16,  0x000000ff,
                    TOP_vsubusxx128v16, 0x000000ff,
                    TOP_vsubusxxx128v16,        0x000000ff,
                    TOP_vptest128,      0x000000ff,
                    TOP_vptestx128,     0x000000ff,
                    TOP_vptestxx128,    0x000000ff,
                    TOP_vptestxxx128,   0x000000ff,
                    TOP_vtestpd,        0x000000ff,
                    TOP_vtestxpd,       0x000000ff,
                    TOP_vtestxxpd,      0x000000ff,
                    TOP_vtestxxxpd,     0x000000ff,
                    TOP_vtestps,        0x000000ff,
                    TOP_vtestxps,       0x000000ff,
                    TOP_vtestxxps,      0x000000ff,
                    TOP_vtestxxxps,     0x000000ff,
                    TOP_vpunpckh64v8,   0x000000ff,
                    TOP_vpunpckhx64v8,  0x000000ff,
                    TOP_vpunpckhxx64v8, 0x000000ff,
                    TOP_vpunpckhxxx64v8,        0x000000ff,
                    TOP_vpunpckh64v32,  0x000000ff,
                    TOP_vpunpckhx64v32, 0x000000ff,
                    TOP_vpunpckhxx64v32,        0x000000ff,
                    TOP_vpunpckhxxx64v32,       0x000000ff,
                    TOP_vpunpckh64v16,  0x000000ff,
                    TOP_vpunpckhx64v16, 0x000000ff,
                    TOP_vpunpckhxx64v16,        0x000000ff,
                    TOP_vpunpckhxxx64v16,       0x000000ff,
                    TOP_vpunpckh64v64,  0x000000ff,
                    TOP_vpunpckhx64v64, 0x000000ff,
                    TOP_vpunpckhxx64v64,        0x000000ff,
                    TOP_vpunpckhxxx64v64,       0x000000ff,
                    TOP_vpunpckl64v8,   0x000000ff,
                    TOP_vpunpcklx64v8,  0x000000ff,
                    TOP_vpunpcklxx64v8, 0x000000ff,
                    TOP_vpunpcklxxx64v8,        0x000000ff,
                    TOP_vpunpckl64v32,  0x000000ff,
                    TOP_vpunpcklx64v32, 0x000000ff,
                    TOP_vpunpcklxx64v32,        0x000000ff,
                    TOP_vpunpcklxxx64v32,       0x000000ff,
                    TOP_vpunpckl64v16,  0x000000ff,
                    TOP_vpunpcklx64v16, 0x000000ff,
                    TOP_vpunpcklxx64v16,        0x000000ff,
                    TOP_vpunpcklxxx64v16,       0x000000ff,
                    TOP_vpunpckl64v64,  0x000000ff,
                    TOP_vpunpcklx64v64, 0x000000ff,
                    TOP_vpunpcklxx64v64,        0x000000ff,
                    TOP_vpunpcklxxx64v64,       0x000000ff,
                    TOP_vxor128v8,      0x000000ff,
                    TOP_vxorx128v8,     0x000000ff,
                    TOP_vxorxx128v8,    0x000000ff,
                    TOP_vxorxxx128v8,           0x000000ff,
                    TOP_vxor128v16,     0x000000ff,
                    TOP_vxorx128v16,    0x000000ff,
                    TOP_vxorxx128v16,   0x000000ff,
                    TOP_vxorxxx128v16,          0x000000ff,
                    TOP_vxor128v32,     0x000000ff,
                    TOP_vxorx128v32,    0x000000ff,
                    TOP_vxorxx128v32,   0x000000ff,
                    TOP_vxorxxx128v32,          0x000000ff,
                    TOP_vxor128v64,     0x000000ff,
                    TOP_vxorx128v64,    0x000000ff,
                    TOP_vxorxx128v64,   0x000000ff,
                    TOP_vxorxxx128v64,          0x000000ff,
                    TOP_vfrcp128v32,    0x000000ff,
                    TOP_vfrcpx128v32,   0x000000ff,
                    TOP_vfrcpxx128v32,  0x000000ff,
                    TOP_vfrcpxxx128v32, 0x000000ff,
                    TOP_vfrcpss,        0x000000ff,
                    TOP_vfrcpxss,       0x000000ff,
                    TOP_vfrcpxxss,      0x000000ff,
                    TOP_vfrcpxxxss,     0x000000ff,
                    TOP_vround128v64,   0x000000ff,
                    TOP_vroundx128v64,  0x000000ff,
                    TOP_vroundxx128v64, 0x000000ff,
                    TOP_vroundxxx128v64,        0x000000ff,
                    TOP_vround128v32,   0x000000ff,
                    TOP_vroundx128v32,  0x000000ff,
                    TOP_vroundxx128v32, 0x000000ff,
                    TOP_vroundxxx128v32,        0x000000ff,
                    TOP_vroundsd,       0x000000ff,
                    TOP_vroundxsd,      0x000000ff,
                    TOP_vroundxxsd,     0x000000ff,
                    TOP_vroundxxxsd,    0x000000ff,
                    TOP_vroundss,       0x000000ff,
                    TOP_vroundxss,      0x000000ff,
                    TOP_vroundxxss,     0x000000ff,
                    TOP_vroundxxxss,    0x000000ff,
                    TOP_vfrsqrt128v32,  0x000000ff,
                    TOP_vfrsqrtx128v32, 0x000000ff,
                    TOP_vfrsqrtxx128v32,        0x000000ff,
                    TOP_vfrsqrtxxx128v32,       0x000000ff,
                    TOP_vfrsqrtss,      0x000000ff,
                    TOP_vfrsqrtxss,     0x000000ff,
                    TOP_vfrsqrtxxss,    0x000000ff,
                    TOP_vfrsqrtxxxss,   0x000000ff,
                    TOP_vshufpd,        0x000000ff,
                    TOP_vfshuf128v64,   0x000000ff,
                    TOP_vfshufx128v64,  0x000000ff,
                    TOP_vfshufxx128v64, 0x000000ff,
                    TOP_vfshufxxx128v64,        0x000000ff,
                    TOP_vshufps,        0x000000ff,
                    TOP_vfshuf128v32,   0x000000ff,
                    TOP_vfshufx128v32,  0x000000ff,
                    TOP_vfshufxx128v32, 0x000000ff,
                    TOP_vfshufxxx128v32,        0x000000ff,
                    TOP_vfsqrt128v64,   0x000000ff,
                    TOP_vfsqrtx128v64,  0x000000ff,
                    TOP_vfsqrtxx128v64, 0x000000ff,
                    TOP_vfsqrtxxx128v64,        0x000000ff,
                    TOP_vfsqrt128v32,   0x000000ff,
                    TOP_vfsqrtx128v32,  0x000000ff,
                    TOP_vfsqrtxx128v32, 0x000000ff,
                    TOP_vfsqrtxxx128v32,        0x000000ff,
                    TOP_vfsqrtsd,       0x000000ff,
                    TOP_vfsqrtxsd,      0x000000ff,
                    TOP_vfsqrtxxsd,     0x000000ff,
                    TOP_vfsqrtxxxsd,    0x000000ff,
                    TOP_vfsqrtss,       0x000000ff,
                    TOP_vfsqrtxss,      0x000000ff,
                    TOP_vfsqrtxxss,     0x000000ff,
                    TOP_vfsqrtxxxss,    0x000000ff,
                    TOP_vstmxcsr,       0x000000ff,
                    TOP_vfsub128v64,    0x000000ff,
                    TOP_vfsubx128v64,   0x000000ff,
                    TOP_vfsubxx128v64,  0x000000ff,
                    TOP_vfsubxxx128v64, 0x000000ff,
                    TOP_vfsub128v32,    0x000000ff,
                    TOP_vfsubx128v32,   0x000000ff,
                    TOP_vfsubxx128v32,  0x000000ff,
                    TOP_vfsubxxx128v32, 0x000000ff,
                    TOP_vsubsd, 0x000000ff,
                    TOP_vsubxsd,        0x000000ff,
                    TOP_vsubxxsd,       0x000000ff,
                    TOP_vsubxxxsd,      0x000000ff,
                    TOP_vsubss, 0x000000ff,
                    TOP_vsubxss,        0x000000ff,
                    TOP_vsubxxss,       0x000000ff,
                    TOP_vsubxxxss,      0x000000ff,
                    TOP_vucomisd,       0x000000ff,
                    TOP_vucomixsd,      0x000000ff,
                    TOP_vucomixxsd,     0x000000ff,
                    TOP_vucomixxxsd,    0x000000ff,
                    TOP_vucomiss,       0x000000ff,
                    TOP_vucomixss,      0x000000ff,
                    TOP_vucomixxss,     0x000000ff,
                    TOP_vucomixxxss,    0x000000ff,
                    TOP_vunpckh128v64,  0x000000ff,
                    TOP_vunpckhx128v64, 0x000000ff,
                    TOP_vunpckhxx128v64,        0x000000ff,
                    TOP_vunpckhxxx128v64,       0x000000ff,
                    TOP_vunpckh128v32,  0x000000ff,
                    TOP_vunpckhx128v32, 0x000000ff,
                    TOP_vunpckhxx128v32,        0x000000ff,
                    TOP_vunpckhxxx128v32,       0x000000ff,
                    TOP_vunpckl128v64,  0x000000ff,
                    TOP_vunpcklx128v64, 0x000000ff,
                    TOP_vunpcklxx128v64,        0x000000ff,
                    TOP_vunpcklxxx128v64,       0x000000ff,
                    TOP_vunpckl128v32,  0x000000ff,
                    TOP_vunpcklx128v32, 0x000000ff,
                    TOP_vunpcklxx128v32,        0x000000ff,
                    TOP_vunpcklxxx128v32,       0x000000ff,
                    TOP_vxorpd,         0x000000ff,
                    TOP_vfxor128v64,    0x000000ff,
                    TOP_vfxorx128v64,   0x000000ff,
                    TOP_vfxorxx128v64,  0x000000ff,
                    TOP_vfxorxxx128v64, 0x000000ff,
                    TOP_vxzero128v64,   0x000000ff,
                    TOP_vxzero64,       0x000000ff,
                    TOP_vxorps,         0x000000ff,
                    TOP_vfxor128v32,    0x000000ff,
                    TOP_vfxorx128v32,   0x000000ff,
                    TOP_vfxorxx128v32,  0x000000ff,
                    TOP_vfxorxxx128v32, 0x000000ff,
                    TOP_vxzero128v32,   0x000000ff,
                    TOP_vxzero32,       0x000000ff,
                    TOP_vzeroall,       0x000000ff,
                    /* INTEL FMA instructions */
                    TOP_xfmadd132pd,    0x000000ff,
                    TOP_xfmadd132xpd,   0x000000ff,
                    TOP_xfmadd132xxpd,  0x000000ff,
                    TOP_xfmadd132xxxpd, 0x000000ff,
                    TOP_xfmadd213pd,    0x000000ff,
                    TOP_xfmadd213xpd,   0x000000ff,
                    TOP_xfmadd213xxpd,  0x000000ff,
                    TOP_xfmadd213xxxpd, 0x000000ff,
                    TOP_xfmadd231pd,    0x000000ff,
                    TOP_xfmadd231xpd,   0x000000ff,
                    TOP_xfmadd231xxpd,  0x000000ff,
                    TOP_xfmadd231xxxpd, 0x000000ff,
                    TOP_xfmadd132ps,    0x000000ff,
                    TOP_xfmadd132xps,   0x000000ff,
                    TOP_xfmadd132xxps,  0x000000ff,
                    TOP_xfmadd132xxxps, 0x000000ff,
                    TOP_xfmadd213ps,    0x000000ff,
                    TOP_xfmadd213xps,   0x000000ff,
                    TOP_xfmadd213xxps,  0x000000ff,
                    TOP_xfmadd213xxxps, 0x000000ff,
                    TOP_xfmadd231ps,    0x000000ff,
                    TOP_xfmadd231xps,   0x000000ff,
                    TOP_xfmadd231xxps,  0x000000ff,
                    TOP_xfmadd231xxxps, 0x000000ff,
                    TOP_xfmadd132sd,    0x000000ff,
                    TOP_xfmadd132xsd,   0x000000ff,
                    TOP_xfmadd132xxsd,  0x000000ff,
                    TOP_xfmadd132xxxsd, 0x000000ff,
                    TOP_xfmadd213sd,    0x000000ff,
                    TOP_xfmadd213xsd,   0x000000ff,
                    TOP_xfmadd213xxsd,  0x000000ff,
                    TOP_xfmadd213xxxsd, 0x000000ff,
                    TOP_xfmadd231sd,    0x000000ff,
                    TOP_xfmadd231xsd,   0x000000ff,
                    TOP_xfmadd231xxsd,  0x000000ff,
                    TOP_xfmadd231xxxsd, 0x000000ff,
                    TOP_xfmadd132ss,    0x000000ff,
                    TOP_xfmadd132xss,   0x000000ff,
                    TOP_xfmadd132xxss,  0x000000ff,
                    TOP_xfmadd132xxxss, 0x000000ff,
                    TOP_xfmadd213ss,    0x000000ff,
                    TOP_xfmadd213xss,   0x000000ff,
                    TOP_xfmadd213xxss,  0x000000ff,
                    TOP_xfmadd213xxxss, 0x000000ff,
                    TOP_xfmadd231ss,    0x000000ff,
                    TOP_xfmadd231xss,   0x000000ff,
                    TOP_xfmadd231xxss,  0x000000ff,
                    TOP_xfmadd231xxxss, 0x000000ff,
                    TOP_xfmaddsub132pd, 0x000000ff,
                    TOP_xfmaddsub132xpd,        0x000000ff,
                    TOP_xfmaddsub132xxpd,       0x000000ff,
                    TOP_xfmaddsub132xxxpd,      0x000000ff,
                    TOP_xfmaddsub213pd, 0x000000ff,
                    TOP_xfmaddsub213xpd,        0x000000ff,
                    TOP_xfmaddsub213xxpd,       0x000000ff,
                    TOP_xfmaddsub213xxxpd,      0x000000ff,
                    TOP_xfmaddsub231pd, 0x000000ff,
                    TOP_xfmaddsub231xpd,        0x000000ff,
                    TOP_xfmaddsub231xxpd,       0x000000ff,
                    TOP_xfmaddsub231xxxpd,      0x000000ff,
                    TOP_xfmaddsub132ps, 0x000000ff,
                    TOP_xfmaddsub132xps,        0x000000ff,
                    TOP_xfmaddsub132xxps,       0x000000ff,
                    TOP_xfmaddsub132xxxps,      0x000000ff,
                    TOP_xfmaddsub213ps, 0x000000ff,
                    TOP_xfmaddsub213xps,        0x000000ff,
                    TOP_xfmaddsub213xxps,       0x000000ff,
                    TOP_xfmaddsub213xxxps,      0x000000ff,
                    TOP_xfmaddsub231ps, 0x000000ff,
                    TOP_xfmaddsub231xps,        0x000000ff,
                    TOP_xfmaddsub231xxps,       0x000000ff,
                    TOP_xfmaddsub231xxxps,      0x000000ff,
                    TOP_xfmsubadd132pd, 0x000000ff,
                    TOP_xfmsubadd132xpd,        0x000000ff,
                    TOP_xfmsubadd132xxpd,       0x000000ff,
                    TOP_xfmsubadd132xxxpd,      0x000000ff,
                    TOP_xfmsubadd213pd, 0x000000ff,
                    TOP_xfmsubadd213xpd,        0x000000ff,
                    TOP_xfmsubadd213xxpd,       0x000000ff,
                    TOP_xfmsubadd213xxxpd,      0x000000ff,
                    TOP_xfmsubadd231pd, 0x000000ff,
                    TOP_xfmsubadd231xpd,        0x000000ff,
                    TOP_xfmsubadd231xxpd,       0x000000ff,
                    TOP_xfmsubadd231xxxpd,      0x000000ff,
                    TOP_xfmsubadd132ps, 0x000000ff,
                    TOP_xfmsubadd132xps,        0x000000ff,
                    TOP_xfmsubadd132xxps,       0x000000ff,
                    TOP_xfmsubadd132xxxps,      0x000000ff,
                    TOP_xfmsubadd213ps, 0x000000ff,
                    TOP_xfmsubadd213xps,        0x000000ff,
                    TOP_xfmsubadd213xxps,       0x000000ff,
                    TOP_xfmsubadd213xxxps,      0x000000ff,
                    TOP_xfmsubadd231ps, 0x000000ff,
                    TOP_xfmsubadd231xps,        0x000000ff,
                    TOP_xfmsubadd231xxps,       0x000000ff,
                    TOP_xfmsubadd231xxxps,      0x000000ff,
                    TOP_xfmsub132pd,    0x000000ff,
                    TOP_xfmsub132xpd,   0x000000ff,
                    TOP_xfmsub132xxpd,  0x000000ff,
                    TOP_xfmsub132xxxpd, 0x000000ff,
                    TOP_xfmsub213pd,    0x000000ff,
                    TOP_xfmsub213xpd,   0x000000ff,
                    TOP_xfmsub213xxpd,  0x000000ff,
                    TOP_xfmsub213xxxpd, 0x000000ff,
                    TOP_xfmsub231pd,    0x000000ff,
                    TOP_xfmsub231xpd,   0x000000ff,
                    TOP_xfmsub231xxpd,  0x000000ff,
                    TOP_xfmsub231xxxpd, 0x000000ff,
                    TOP_xfmsub132ps,    0x000000ff,
                    TOP_xfmsub132xps,   0x000000ff,
                    TOP_xfmsub132xxps,  0x000000ff,
                    TOP_xfmsub132xxxps, 0x000000ff,
                    TOP_xfmsub213ps,    0x000000ff,
                    TOP_xfmsub213xps,   0x000000ff,
                    TOP_xfmsub213xxps,  0x000000ff,
                    TOP_xfmsub213xxxps, 0x000000ff,
                    TOP_xfmsub231ps,    0x000000ff,
                    TOP_xfmsub231xps,   0x000000ff,
                    TOP_xfmsub231xxps,  0x000000ff,
                    TOP_xfmsub231xxxps, 0x000000ff,
                    TOP_xfmsub132sd,    0x000000ff,
                    TOP_xfmsub132xsd,   0x000000ff,
                    TOP_xfmsub132xxsd,  0x000000ff,
                    TOP_xfmsub132xxxsd, 0x000000ff,
                    TOP_xfmsub213sd,    0x000000ff,
                    TOP_xfmsub213xsd,   0x000000ff,
                    TOP_xfmsub213xxsd,  0x000000ff,
                    TOP_xfmsub213xxxsd, 0x000000ff,
                    TOP_xfmsub231sd,    0x000000ff,
                    TOP_xfmsub231xsd,   0x000000ff,
                    TOP_xfmsub231xxsd,  0x000000ff,
                    TOP_xfmsub231xxxsd, 0x000000ff,
                    TOP_xfmsub132ss,    0x000000ff,
                    TOP_xfmsub132xss,   0x000000ff,
                    TOP_xfmsub132xxss,  0x000000ff,
                    TOP_xfmsub132xxxss, 0x000000ff,
                    TOP_xfmsub213ss,    0x000000ff,
                    TOP_xfmsub213xss,   0x000000ff,
                    TOP_xfmsub213xxss,  0x000000ff,
                    TOP_xfmsub213xxxss, 0x000000ff,
                    TOP_xfmsub231ss,    0x000000ff,
                    TOP_xfmsub231xss,   0x000000ff,
                    TOP_xfmsub231xxss,  0x000000ff,
                    TOP_xfmsub231xxxss, 0x000000ff,
                    TOP_xfnmadd132pd,   0x000000ff,
                    TOP_xfnmadd132xpd,  0x000000ff,
                    TOP_xfnmadd132xxpd, 0x000000ff,
                    TOP_xfnmadd132xxxpd,        0x000000ff,
                    TOP_xfnmadd213pd,   0x000000ff,
                    TOP_xfnmadd213xpd,  0x000000ff,
                    TOP_xfnmadd213xxpd, 0x000000ff,
                    TOP_xfnmadd213xxxpd,        0x000000ff,
                    TOP_xfnmadd231pd,   0x000000ff,
                    TOP_xfnmadd231xpd,  0x000000ff,
                    TOP_xfnmadd231xxpd, 0x000000ff,
                    TOP_xfnmadd231xxxpd,        0x000000ff,
                    TOP_xfnmadd132ps,   0x000000ff,
                    TOP_xfnmadd132xps,  0x000000ff,
                    TOP_xfnmadd132xxps, 0x000000ff,
                    TOP_xfnmadd132xxxps,        0x000000ff,
                    TOP_xfnmadd213ps,   0x000000ff,
                    TOP_xfnmadd213xps,  0x000000ff,
                    TOP_xfnmadd213xxps, 0x000000ff,
                    TOP_xfnmadd213xxxps,        0x000000ff,
                    TOP_xfnmadd231ps,   0x000000ff,
                    TOP_xfnmadd231xps,  0x000000ff,
                    TOP_xfnmadd231xxps, 0x000000ff,
                    TOP_xfnmadd231xxxps,        0x000000ff,
                    TOP_xfnmadd132sd,   0x000000ff,
                    TOP_xfnmadd132xsd,  0x000000ff,
                    TOP_xfnmadd132xxsd, 0x000000ff,
                    TOP_xfnmadd132xxxsd,        0x000000ff,
                    TOP_xfnmadd213sd,   0x000000ff,
                    TOP_xfnmadd213xsd,  0x000000ff,
                    TOP_xfnmadd213xxsd, 0x000000ff,
                    TOP_xfnmadd213xxxsd,        0x000000ff,
                    TOP_xfnmadd231sd,   0x000000ff,
                    TOP_xfnmadd231xsd,  0x000000ff,
                    TOP_xfnmadd231xxsd, 0x000000ff,
                    TOP_xfnmadd231xxxsd,        0x000000ff,
                    TOP_xfnmadd132ss,   0x000000ff,
                    TOP_xfnmadd132xss,  0x000000ff,
                    TOP_xfnmadd132xxss, 0x000000ff,
                    TOP_xfnmadd132xxxss,        0x000000ff,
                    TOP_xfnmadd213ss,   0x000000ff,
                    TOP_xfnmadd213xss,  0x000000ff,
                    TOP_xfnmadd213xxss, 0x000000ff,
                    TOP_xfnmadd213xxxss,        0x000000ff,
                    TOP_xfnmadd231ss,   0x000000ff,
                    TOP_xfnmadd231xss,  0x000000ff,
                    TOP_xfnmadd231xxss, 0x000000ff,
                    TOP_xfnmadd231xxxss,        0x000000ff,
                    TOP_xfnmsub132pd,   0x000000ff,
                    TOP_xfnmsub132xpd,  0x000000ff,
                    TOP_xfnmsub132xxpd, 0x000000ff,
                    TOP_xfnmsub132xxxpd,        0x000000ff,
                    TOP_xfnmsub213pd,   0x000000ff,
                    TOP_xfnmsub213xpd,  0x000000ff,
                    TOP_xfnmsub213xxpd, 0x000000ff,
                    TOP_xfnmsub213xxxpd,        0x000000ff,
                    TOP_xfnmsub231pd,   0x000000ff,
                    TOP_xfnmsub231xpd,  0x000000ff,
                    TOP_xfnmsub231xxpd, 0x000000ff,
                    TOP_xfnmsub231xxxpd,        0x000000ff,
                    TOP_xfnmsub132ps,   0x000000ff,
                    TOP_xfnmsub132xps,  0x000000ff,
                    TOP_xfnmsub132xxps, 0x000000ff,
                    TOP_xfnmsub132xxxps,        0x000000ff,
                    TOP_xfnmsub213ps,   0x000000ff,
                    TOP_xfnmsub213xps,  0x000000ff,
                    TOP_xfnmsub213xxps, 0x000000ff,
                    TOP_xfnmsub213xxxps,        0x000000ff,
                    TOP_xfnmsub231ps,   0x000000ff,
                    TOP_xfnmsub231xps,  0x000000ff,
                    TOP_xfnmsub231xxps, 0x000000ff,
                    TOP_xfnmsub231xxxps,        0x000000ff,
                    TOP_xfnmsub132sd,   0x000000ff,
                    TOP_xfnmsub132xsd,  0x000000ff,
                    TOP_xfnmsub132xxsd, 0x000000ff,
                    TOP_xfnmsub132xxxsd,        0x000000ff,
                    TOP_xfnmsub213sd,   0x000000ff,
                    TOP_xfnmsub213xsd,  0x000000ff,
                    TOP_xfnmsub213xxsd, 0x000000ff,
                    TOP_xfnmsub213xxxsd,        0x000000ff,
                    TOP_xfnmsub231sd,   0x000000ff,
                    TOP_xfnmsub231xsd,  0x000000ff,
                    TOP_xfnmsub231xxsd, 0x000000ff,
                    TOP_xfnmsub231xxxsd,        0x000000ff,
                    TOP_xfnmsub132ss,   0x000000ff,
                    TOP_xfnmsub132xss,  0x000000ff,
                    TOP_xfnmsub132xxss, 0x000000ff,
                    TOP_xfnmsub132xxxss,        0x000000ff,
                    TOP_xfnmsub213ss,   0x000000ff,
                    TOP_xfnmsub213xss,  0x000000ff,
                    TOP_xfnmsub213xxss, 0x000000ff,
                    TOP_xfnmsub213xxxss,        0x000000ff,
                    TOP_xfnmsub231ss,   0x000000ff,
                    TOP_xfnmsub231xss,  0x000000ff,
                    TOP_xfnmsub231xxss, 0x000000ff,
                    TOP_xfnmsub231xxxss,        0x000000ff,
		    TOP_UNDEFINED);

  ISA_Pack_End();
  return 0;
}
